"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _index = require("../mdb/util/index");

var _eventHandler = _interopRequireDefault(require("../bootstrap/src/dom/event-handler"));

var _selectorEngine = _interopRequireDefault(require("../mdb/dom/selector-engine"));

var _dropdown = _interopRequireDefault(require("../bootstrap/src/dropdown"));

var _manipulator = _interopRequireDefault(require("../bootstrap/src/dom/manipulator"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

/**
 * ------------------------------------------------------------------------
 * Constants
 * ------------------------------------------------------------------------
 */
var NAME = 'dropdown';
var SELECTOR_EXPAND = '[data-toggle="dropdown"]';
var Default = {
  offset: 0,
  flip: true,
  boundary: 'scrollParent',
  reference: 'toggle',
  display: 'dynamic',
  popperConfig: null,
  dropdownAnimation: 'on'
};
var DefaultType = {
  offset: '(number|string|function)',
  flip: 'boolean',
  boundary: '(string|element)',
  reference: '(string|element)',
  display: 'string',
  popperConfig: '(null|object)',
  dropdownAnimation: 'string'
};
var EVENT_HIDE = 'hide.bs.dropdown';
var EVENT_HIDDEN = 'hidden.bs.dropdown';
var EVENT_SHOW = 'show.bs.dropdown';
var ANIMATION_CLASS = 'animation';
var ANIMATION_SHOW_CLASS = 'fade-in';
var ANIMATION_HIDE_CLASS = 'fade-out';

var Dropdown =
/*#__PURE__*/
function (_BSDropdown) {
  _inherits(Dropdown, _BSDropdown);

  function Dropdown(element, data) {
    var _this;

    _classCallCheck(this, Dropdown);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Dropdown).call(this, element, data));
    _this._config = _this._getConfig(data);
    _this._parent = Dropdown.getParentFromElement(_this._element);
    _this._menuStyle = '';
    _this._xPlacement = ''; //* prevents dropdown close issue when system animation is turned off

    var isPrefersReducedMotionSet = window.matchMedia('(prefers-reduced-motion: reduce)').matches;

    if (_this._config.dropdownAnimation === 'on' && !isPrefersReducedMotionSet) {
      _this._init();
    }

    return _this;
  }

  _createClass(Dropdown, [{
    key: "dispose",
    value: function dispose() {
      _eventHandler["default"].off(this._element, EVENT_SHOW);

      _eventHandler["default"].off(this._parent, EVENT_HIDE);

      _eventHandler["default"].off(this._parent, EVENT_HIDDEN);

      _get(_getPrototypeOf(Dropdown.prototype), "dispose", this).call(this);
    } // Getters

  }, {
    key: "_init",
    // Private
    value: function _init() {
      this._bindShowEvent();

      this._bindHideEvent();

      this._bindHiddenEvent();
    }
  }, {
    key: "_getConfig",
    value: function _getConfig(options) {
      var config = _objectSpread({}, Default, {}, _manipulator["default"].getDataAttributes(this._element), {}, options);

      (0, _index.typeCheckConfig)(NAME, config, DefaultType);
      return config;
    }
  }, {
    key: "_bindShowEvent",
    value: function _bindShowEvent() {
      var _this2 = this;

      _eventHandler["default"].on(this._element, EVENT_SHOW, function () {
        _this2._dropdownAnimationStart('show');
      });
    }
  }, {
    key: "_bindHideEvent",
    value: function _bindHideEvent() {
      var _this3 = this;

      _eventHandler["default"].on(this._parent, EVENT_HIDE, function () {
        _this3._menuStyle = _this3._menu.style.cssText;
        _this3._xPlacement = _this3._menu.getAttribute('x-placement');
      });
    }
  }, {
    key: "_bindHiddenEvent",
    value: function _bindHiddenEvent() {
      var _this4 = this;

      _eventHandler["default"].on(this._parent, EVENT_HIDDEN, function () {
        _this4._menu.style.cssText = _this4._menuStyle;

        _this4._menu.setAttribute('x-placement', _this4._xPlacement);

        _this4._dropdownAnimationStart('hide');
      });
    }
  }, {
    key: "_dropdownAnimationStart",
    value: function _dropdownAnimationStart(action) {
      switch (action) {
        case 'show':
          this._menu.classList.add(ANIMATION_CLASS, ANIMATION_SHOW_CLASS);

          this._menu.classList.remove(ANIMATION_HIDE_CLASS);

          break;

        default:
          // hide
          this._menu.classList.add(ANIMATION_CLASS, ANIMATION_HIDE_CLASS);

          this._menu.classList.remove(ANIMATION_SHOW_CLASS);

          break;
      }

      this._bindAnimationEnd();
    }
  }, {
    key: "_bindAnimationEnd",
    value: function _bindAnimationEnd() {
      var _this5 = this;

      _eventHandler["default"].one(this._menu, 'animationend', function () {
        _this5._menu.classList.remove(ANIMATION_CLASS, ANIMATION_HIDE_CLASS, ANIMATION_SHOW_CLASS);
      });
    }
  }], [{
    key: "NAME",
    get: function get() {
      return NAME;
    }
  }]);

  return Dropdown;
}(_dropdown["default"]);
/**
 * ------------------------------------------------------------------------
 * Data Api implementation - auto initialization
 * ------------------------------------------------------------------------
 */


_selectorEngine["default"].find(SELECTOR_EXPAND).forEach(function (el) {
  var instance = Dropdown.getInstance(el);

  if (!instance) {
    instance = new Dropdown(el);
  }
});
/**
 * ------------------------------------------------------------------------
 * jQuery
 * ------------------------------------------------------------------------
 * add .rating to jQuery only if jQuery is present
 */


var $ = (0, _index.getjQuery)();

if ($) {
  var JQUERY_NO_CONFLICT = $.fn[NAME];
  $.fn[NAME] = Dropdown.jQueryInterface;
  $.fn[NAME].Constructor = Dropdown;

  $.fn[NAME].noConflict = function () {
    $.fn[NAME] = JQUERY_NO_CONFLICT;
    return Dropdown.jQueryInterface;
  };
}

var _default = Dropdown;
exports["default"] = _default;