"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

var _classNames = require("./lib/class-names");

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function createEvent(name) {
  if (typeof window.CustomEvent === 'function') {
    return new CustomEvent(name);
  }

  var evt = document.createEvent('CustomEvent');
  evt.initCustomEvent(name, false, false, undefined);
  return evt;
}

function _default(i, axis, diff) {
  var useScrollingClass = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
  var forceFireReachEvent = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
  var fields;

  if (axis === 'top') {
    fields = ['contentHeight', 'containerHeight', 'scrollTop', 'y', 'up', 'down'];
  } else if (axis === 'left') {
    fields = ['contentWidth', 'containerWidth', 'scrollLeft', 'x', 'left', 'right'];
  } else {
    throw new Error('A proper axis should be provided');
  }

  processScrollDiff(i, diff, fields, useScrollingClass, forceFireReachEvent);
}

function processScrollDiff(i, diff, _ref) {
  var _ref2 = _slicedToArray(_ref, 6),
      contentHeight = _ref2[0],
      containerHeight = _ref2[1],
      scrollTop = _ref2[2],
      y = _ref2[3],
      up = _ref2[4],
      down = _ref2[5];

  var useScrollingClass = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
  var forceFireReachEvent = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
  var element = i.element; // reset reach

  i.reach[y] = null; // 1 for subpixel rounding

  if (element[scrollTop] < 1) {
    i.reach[y] = 'start';
  } // 1 for subpixel rounding


  if (element[scrollTop] > i[contentHeight] - i[containerHeight] - 1) {
    i.reach[y] = 'end';
  }

  if (diff) {
    element.dispatchEvent(createEvent("ps-scroll-".concat(y)));

    if (diff < 0) {
      element.dispatchEvent(createEvent("ps-scroll-".concat(up)));
    } else if (diff > 0) {
      element.dispatchEvent(createEvent("ps-scroll-".concat(down)));
    }

    if (useScrollingClass) {
      (0, _classNames.setScrollingClassInstantly)(i, y);
    }
  }

  if (i.reach[y] && (diff || forceFireReachEvent)) {
    element.dispatchEvent(createEvent("ps-".concat(y, "-reach-").concat(i.reach[y])));
  }
}