"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.addScrollingClass = addScrollingClass;
exports.removeScrollingClass = removeScrollingClass;
exports.setScrollingClassInstantly = setScrollingClassInstantly;
exports["default"] = void 0;

/* eslint-disable */
var cls = {
  main: 'ps',
  rtl: 'ps__rtl',
  element: {
    thumb: function thumb(x) {
      return "ps__thumb-".concat(x);
    },
    rail: function rail(x) {
      return "ps__rail-".concat(x);
    },
    consuming: 'ps__child--consume'
  },
  state: {
    focus: 'ps--focus',
    clicking: 'ps--clicking',
    active: function active(x) {
      return "ps--active-".concat(x);
    },
    scrolling: function scrolling(x) {
      return "ps--scrolling-".concat(x);
    }
  }
};
var _default = cls;
/*
 * Helper methods
 */

exports["default"] = _default;
var scrollingClassTimeout = {
  x: null,
  y: null
};

function addScrollingClass(i, x) {
  var classList = i.element.classList;
  var className = cls.state.scrolling(x);

  if (classList.contains(className)) {
    clearTimeout(scrollingClassTimeout[x]);
  } else {
    classList.add(className);
  }
}

function removeScrollingClass(i, x) {
  scrollingClassTimeout[x] = setTimeout(function () {
    return i.isAlive && i.element.classList.remove(cls.state.scrolling(x));
  }, i.settings.scrollingThreshold);
}

function setScrollingClassInstantly(i, x) {
  addScrollingClass(i, x);
  removeScrollingClass(i, x);
}