"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/* eslint-disable */
var EventElement =
/*#__PURE__*/
function () {
  function EventElement(element) {
    _classCallCheck(this, EventElement);

    this.element = element;
    this.handlers = {};
  }

  _createClass(EventElement, [{
    key: "bind",
    value: function bind(eventName, handler) {
      if (typeof this.handlers[eventName] === 'undefined') {
        this.handlers[eventName] = [];
      }

      this.handlers[eventName].push(handler);
      this.element.addEventListener(eventName, handler, false);
    }
  }, {
    key: "unbind",
    value: function unbind(eventName, target) {
      var _this = this;

      this.handlers[eventName] = this.handlers[eventName].filter(function (handler) {
        if (target && handler !== target) {
          return true;
        }

        _this.element.removeEventListener(eventName, handler, false);

        return false;
      });
    }
  }, {
    key: "unbindAll",
    value: function unbindAll() {
      for (var name in this.handlers) {
        this.unbind(name);
      }
    }
  }, {
    key: "isEmpty",
    get: function get() {
      var _this2 = this;

      return Object.keys(this.handlers).every(function (key) {
        return _this2.handlers[key].length === 0;
      });
    }
  }]);

  return EventElement;
}();

var EventManager =
/*#__PURE__*/
function () {
  function EventManager() {
    _classCallCheck(this, EventManager);

    this.eventElements = [];
  }

  _createClass(EventManager, [{
    key: "eventElement",
    value: function eventElement(element) {
      var ee = this.eventElements.filter(function (ee) {
        return ee.element === element;
      })[0];

      if (!ee) {
        ee = new EventElement(element);
        this.eventElements.push(ee);
      }

      return ee;
    }
  }, {
    key: "bind",
    value: function bind(element, eventName, handler) {
      this.eventElement(element).bind(eventName, handler);
    }
  }, {
    key: "unbind",
    value: function unbind(element, eventName, handler) {
      var ee = this.eventElement(element);
      ee.unbind(eventName, handler);

      if (ee.isEmpty) {
        // remove
        this.eventElements.splice(this.eventElements.indexOf(ee), 1);
      }
    }
  }, {
    key: "unbindAll",
    value: function unbindAll() {
      this.eventElements.forEach(function (e) {
        return e.unbindAll();
      });
      this.eventElements = [];
    }
  }, {
    key: "once",
    value: function once(element, eventName, handler) {
      var ee = this.eventElement(element);

      var onceHandler = function onceHandler(evt) {
        ee.unbind(eventName, onceHandler);
        handler(evt);
      };

      ee.bind(eventName, onceHandler);
    }
  }]);

  return EventManager;
}();

exports["default"] = EventManager;