"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _selectorEngine = _interopRequireDefault(require("../dom/selector-engine"));

var _index = require("./index");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var FocusTrap =
/*#__PURE__*/
function () {
  function FocusTrap(element) {
    var _this = this;

    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, FocusTrap);

    this._element = element;
    this._event = options.event || 'blur';

    this._condition = options.condition || function () {
      return true;
    };

    this._selector = options.selector || 'button, a, input, select, textarea, [tabindex]:not([tabindex="-1"])';
    this._onlyVisible = options.onlyVisible || false;
    this._focusableElements = [];
    this._firstElement = null;
    this._lastElement = null;

    this.handler = function (e) {
      if (_this._condition(e) && e.target === _this._lastElement) {
        e.preventDefault();

        _this._firstElement.focus();
      }
    };
  }

  _createClass(FocusTrap, [{
    key: "trap",
    value: function trap() {
      this._setElements();

      this._init();

      this._setFocusTrap();
    }
  }, {
    key: "disable",
    value: function disable() {
      var _this2 = this;

      this._focusableElements.forEach(function (element) {
        element.removeEventListener(_this2._event, _this2.handler);
      });
    }
  }, {
    key: "update",
    value: function update() {
      this._setElements();

      this._setFocusTrap();
    }
  }, {
    key: "_init",
    value: function _init() {
      var _this3 = this;

      var handler = function handler(e) {
        if (!_this3._firstElement || e.key !== 'Tab') return;
        e.preventDefault();

        _this3._firstElement.focus();

        window.removeEventListener('keydown', handler);
      };

      window.addEventListener('keydown', handler);
    }
  }, {
    key: "_filterVisible",
    value: function _filterVisible(elements) {
      return elements.filter(function (el) {
        if (!(0, _index.isVisible)(el)) return false;

        var ancestors = _selectorEngine["default"].parents(el, '*');

        for (var i = 0; i < ancestors.length; i++) {
          var style = window.getComputedStyle(ancestors[i]);
          if (style && (style.display === 'none' || style.visibility === 'hidden')) return false;
        }

        return true;
      });
    }
  }, {
    key: "_setElements",
    value: function _setElements() {
      this._focusableElements = _selectorEngine["default"].find(this._selector, this._element);

      if (this._onlyVisible) {
        this._focusableElements = this._filterVisible(this._focusableElements);
      }

      this._firstElement = this._focusableElements[0];
      this._lastElement = this._focusableElements[this._focusableElements.length - 1];
    }
  }, {
    key: "_setFocusTrap",
    value: function _setFocusTrap() {
      var _this4 = this;

      this._focusableElements.forEach(function (element, i) {
        if (i === _this4._focusableElements.length - 1) {
          element.addEventListener(_this4._event, _this4.handler);
        } else {
          element.removeEventListener(_this4._event, _this4.handler);
        }
      });
    }
  }]);

  return FocusTrap;
}();

var _default = FocusTrap;
exports["default"] = _default;