"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _swipe = _interopRequireDefault(require("./swipe"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Touch =
/*#__PURE__*/
function () {
  function Touch(element) {
    var event = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'swipe';
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

    _classCallCheck(this, Touch);

    this._element = element;
    this._event = event; // events

    this.swipe = new _swipe["default"](element, options); // handlers

    this._touchStartHandler = this._handleTouchStart.bind(this);
    this._touchMoveHandler = this._handleTouchMove.bind(this);
    this._touchEndHandler = this._handleTouchEnd.bind(this);
  }

  _createClass(Touch, [{
    key: "dispose",
    value: function dispose() {
      this._element.removeEventListener('touchstart', this._touchStartHandler);

      this._element.removeEventListener('touchmove', this._touchMoveHandler);

      window.removeEventListener('touchend', this._touchEndHandler);
    }
  }, {
    key: "init",
    value: function init() {
      var _this = this;

      // istanbul ignore next
      this._element.addEventListener('touchstart', function (e) {
        return _this._handleTouchStart(e);
      }); // istanbul ignore next


      this._element.addEventListener('touchmove', function (e) {
        return _this._handleTouchMove(e);
      }); // istanbul ignore next


      window.addEventListener('touchend', function (e) {
        return _this._handleTouchEnd(e);
      });
    }
  }, {
    key: "_handleTouchStart",
    value: function _handleTouchStart(e) {
      this[this._event].handleTouchStart(e);
    }
  }, {
    key: "_handleTouchMove",
    value: function _handleTouchMove(e) {
      this[this._event].handleTouchMove(e);
    }
  }, {
    key: "_handleTouchEnd",
    value: function _handleTouchEnd(e) {
      this[this._event].handleTouchEnd(e);
    }
  }]);

  return Touch;
}();

var _default = Touch;
exports["default"] = _default;