"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _perfectScrollbar = _interopRequireDefault(require("../../mdb/perfect-scrollbar"));

var _index = require("../../mdb/util/index");

var _data = _interopRequireDefault(require("../../mdb/dom/data"));

var _eventHandler = _interopRequireDefault(require("../../mdb/dom/event-handler"));

var _manipulator = _interopRequireDefault(require("../../mdb/dom/manipulator"));

var _selectorEngine = _interopRequireDefault(require("../../mdb/dom/selector-engine"));

var _table = _interopRequireDefault(require("./html/table"));

var _util = require("./util");

var _select = _interopRequireDefault(require("../select"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * ------------------------------------------------------------------------
 * Constants
 * ------------------------------------------------------------------------
 */
var NAME = 'datatable';
var DATA_KEY = 'mdb.datatable';
var CLASS_DATATABLE = 'datatable';
var CLASS_FIXED_CELL = 'fixed-cell';
var SELECTOR_DATATABLE = '.datatable';
var SELECTOR_BODY = '.datatable-inner';
var SELECTOR_CELL = 'td';
var SELECTOR_HEADER = '.datatable-header th';
var SELECTOR_HEADER_CHECKBOX = '.datatable-header-checkbox';
var SELECTOR_PAGINATION_RIGHT = '.datatable-pagination-right';
var SELECTOR_PAGINATION_LEFT = '.datatable-pagination-left';
var SELECTOR_PAGINATION_START = '.datatable-pagination-start';
var SELECTOR_PAGINATION_END = '.datatable-pagination-end';
var SELECTOR_PAGINATION_NAV = '.datatable-pagination-nav';
var SELECTOR_SELECT = '.datatable-select';
var SELECTOR_SORT_ICON = '.datatable-sort-icon';
var SELECTOR_ROW = '.datatable-body tr';
var SELECTOR_ROW_CHECKBOX = '.datatable-row-checkbox';
var EVENT_SELECT = 'selectRows.mdb.datatable';
var EVENT_RENDER = 'render.mdb.datatable';
var EVENT_UPDATE = 'update.mdb.datatable';
var TYPE_OPTIONS = {
  bordered: 'boolean',
  borderless: 'boolean',
  borderColor: '(string|null)',
  color: '(string|null)',
  defaultValue: 'string',
  edit: 'boolean',
  entries: 'number',
  entriesOptions: 'array',
  fullPagination: 'boolean',
  hover: 'boolean',
  loading: 'boolean',
  loadingMessage: 'string',
  maxWidth: '(null|number|string)',
  maxHeight: '(null|number|string)',
  multi: 'boolean',
  noFoundMessage: 'string',
  pagination: 'boolean',
  selectable: 'boolean',
  sm: 'boolean',
  loaderClass: 'string',
  fixedHeader: 'boolean',
  striped: 'boolean',
  rowsText: 'string'
};
var TYPE_COLUMN_FIELDS = {
  label: 'string',
  field: 'string',
  fixed: '(boolean|string)',
  width: '(number|null)',
  sort: 'boolean',
  columnIndex: 'number'
};
var DEFAULT_OPTIONS = {
  bordered: false,
  borderless: false,
  borderColor: null,
  color: null,
  dark: false,
  defaultValue: '-',
  edit: false,
  entries: 10,
  entriesOptions: [10, 25, 50, 200],
  fixedHeader: false,
  fullPagination: false,
  hover: false,
  loaderClass: 'bg-primary',
  loading: false,
  loadingMessage: 'Loading results...',
  maxWidth: null,
  maxHeight: null,
  multi: false,
  noFoundMessage: 'No matching results found',
  pagination: true,
  selectable: false,
  sm: false,
  striped: false,
  rowsText: 'Rows per page:'
};
var DEFAUL_COLUMN = {
  label: '',
  field: '',
  fixed: false,
  width: null,
  sort: true,
  columnIndex: 0
};
/**
 * ------------------------------------------------------------------------
 * Class Definition
 * ------------------------------------------------------------------------
 */

var Datatable =
/*#__PURE__*/
function () {
  function Datatable(element) {
    var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

    _classCallCheck(this, Datatable);

    this._element = element;
    this._options = this._getOptions(options);
    this._sortField = null;
    this._sortOrder = null;
    this._sortReverse = false;
    this._activePage = 0;
    this._search = '';
    this._searchColumn = null;
    this._paginationLeft = null;
    this._paginationRight = null;
    this._paginationStart = null;
    this._paginationEnd = null;
    this._select = null;
    this._selectInstance = null;
    this._selected = [];
    this._checkboxes = null;
    this._headerCheckbox = null;
    this._rows = this._getRows(data.rows);
    this._columns = this._getColumns(data.columns);

    if (this._element) {
      _data["default"].setData(element, DATA_KEY, this);

      this._perfectScrollbar = null;

      this._setup();
    }
  } // Getters


  _createClass(Datatable, [{
    key: "update",
    // Public
    value: function update(data) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      if (data && data.rows) {
        this._rows = data.rows;
      }

      if (data && data.columns) {
        this._columns = data.columns;
      }

      this._clearClassList(options);

      this._options = this._getOptions(_objectSpread({}, this._options, {}, options));

      this._setup();
    }
  }, {
    key: "dispose",
    value: function dispose() {
      if (this._selectInstance) {
        this._selectInstance.dispose();
      }

      _data["default"].removeData(this._element, DATA_KEY);

      this._removeEventListeners();

      this._perfectScrollbar.destroy();

      this._element = null;
    }
  }, {
    key: "search",
    value: function search(string, column) {
      this._search = string;
      this._searchColumn = column;
      this._activePage = 0;

      this._toggleDisableState();

      this._renderRows();
    }
  }, {
    key: "sort",
    value: function sort(column) {
      var order = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'asc';
      this._sortOrder = order;

      if (typeof column === 'string') {
        this._sortField = this.columns.find(function (header) {
          return header.label === column;
        }).field;
      } else {
        this._sortField = column.field;
      }

      var icon = _selectorEngine["default"].findOne("i[data-sort=\"".concat(this._sortField, "\"]"), this._element);

      this._activePage = 0;

      this._toggleDisableState();

      this._renderRows();

      this._setActiveSortIcon(icon);
    } // Private

  }, {
    key: "_changeActivePage",
    value: function _changeActivePage(index) {
      this._activePage = index;

      this._toggleDisableState();

      this._renderRows();
    }
  }, {
    key: "_clearClassList",
    value: function _clearClassList(options) {
      var _this = this;

      if (this._options.color && options.color) {
        _manipulator["default"].removeClass(this._element, this._options.color);
      }

      if (this._options.borderColor && options.borderColor) {
        _manipulator["default"].removeClass(this._element, "border-".concat(this._options.borderColor));
      }

      ['dark', 'hover', 'bordered', 'borderless', 'sm', 'striped', 'loading'].forEach(function (option) {
        if (_this._options[option] && !options[option]) {
          _manipulator["default"].removeClass(_this._element, "datatable-".concat(option));
        }
      });
    }
  }, {
    key: "_emitSelectEvent",
    value: function _emitSelectEvent() {
      var _this2 = this;

      _eventHandler["default"].trigger(this._element, EVENT_SELECT, {
        selectedRows: this.rows.filter(function (row) {
          return _this2._selected.indexOf(row.rowIndex) !== -1;
        }),
        selectedIndexes: this._selected,
        allSelected: this._selected.length === this.rows.length
      });
    }
  }, {
    key: "_getRows",
    value: function _getRows() {
      var rows = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      var body = _selectorEngine["default"].findOne('tbody', this._element);

      if (!body) {
        return rows;
      }

      var tableRows = _selectorEngine["default"].find('tr', body).map(function (row) {
        return _selectorEngine["default"].find('td', row).map(function (cell) {
          return cell.innerHTML;
        });
      });

      return [].concat(_toConsumableArray(tableRows), _toConsumableArray(rows));
    }
  }, {
    key: "_getColumns",
    value: function _getColumns() {
      var columns = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      var head = _selectorEngine["default"].findOne('thead', this._element);

      if (!head) {
        return columns;
      }

      var headerRow = _selectorEngine["default"].findOne('tr', head);

      var headers = _selectorEngine["default"].find('th', headerRow).map(function (cell) {
        return _objectSpread({
          label: cell.innerHTML
        }, _manipulator["default"].getDataAttributes(cell));
      });

      return [].concat(_toConsumableArray(headers), _toConsumableArray(columns));
    }
  }, {
    key: "_getCSSValue",
    value: function _getCSSValue(size) {
      if (typeof size === 'string') {
        return size;
      }

      return "".concat(size, "px");
    }
  }, {
    key: "_getOptions",
    value: function _getOptions(options) {
      var config = _objectSpread({}, DEFAULT_OPTIONS, {}, _manipulator["default"].getDataAttributes(this._element), {}, options);

      (0, _index.typeCheckConfig)(NAME, config, TYPE_OPTIONS);
      return config;
    }
  }, {
    key: "_setActiveRows",
    value: function _setActiveRows() {
      var _this3 = this;

      _selectorEngine["default"].find(SELECTOR_ROW, this._element).forEach(function (row) {
        if (_this3._selected.includes(_manipulator["default"].getDataAttribute(row, 'index'))) {
          _manipulator["default"].addClass(row, 'active');
        } else {
          _manipulator["default"].removeClass(row, 'active');
        }
      });
    }
  }, {
    key: "_setEntries",
    value: function _setEntries(e) {
      this._options = this._getOptions(_objectSpread({}, this._options, {
        entries: Number(e.target.value)
      }));

      if (this._activePage > this.pages - 1) {
        this._activePage = this.pages - 1;
      }

      this._toggleDisableState();

      this._renderRows();
    }
  }, {
    key: "_setSelected",
    value: function _setSelected() {
      var _this4 = this;

      _selectorEngine["default"].find(SELECTOR_ROW_CHECKBOX, this._element).forEach(function (checkbox) {
        var index = _manipulator["default"].getDataAttribute(checkbox, 'rowIndex');

        checkbox.checked = _this4._selected.includes(index);
      });

      this._setActiveRows();
    }
  }, {
    key: "_setActiveSortIcon",
    value: function _setActiveSortIcon(active) {
      var _this5 = this;

      _selectorEngine["default"].find(SELECTOR_SORT_ICON, this._element).forEach(function (icon) {
        var angle = _this5._sortOrder === 'desc' && icon === active ? 180 : 0;

        _manipulator["default"].style(icon, {
          transform: "rotate(".concat(angle, "deg)")
        });

        if (icon === active && _this5._sortOrder) {
          _manipulator["default"].addClass(icon, 'active');
        } else {
          _manipulator["default"].removeClass(icon, 'active');
        }
      });
    }
  }, {
    key: "_setClassNames",
    value: function _setClassNames() {
      var _this6 = this;

      this.classNames.forEach(function (className) {
        _manipulator["default"].addClass(_this6._element, className);
      });
    }
  }, {
    key: "_setup",
    value: function _setup() {
      this._setClassNames();

      this._renderTable();

      if (this._options.pagination) {
        this._setupPagination();
      }

      if (this._options.edit) {
        this._setupEditable();
      }

      if (this._options.selectable) {
        this._setupSelectable();
      }

      this._setupScroll();

      this._setupSort();
    }
  }, {
    key: "_setupEditable",
    value: function _setupEditable() {
      var _this7 = this;

      _selectorEngine["default"].find(SELECTOR_ROW, this._element).forEach(function (row) {
        var index = _manipulator["default"].getDataAttribute(row, 'index');

        _selectorEngine["default"].find(SELECTOR_CELL, row).forEach(function (cell) {
          _eventHandler["default"].on(cell, 'input', function (e) {
            return _this7._updateRow(e, index);
          });
        });
      });
    }
  }, {
    key: "_setupScroll",
    value: function _setupScroll() {
      var _this8 = this;

      var datatableBody = _selectorEngine["default"].findOne(SELECTOR_BODY, this._element);

      var style = {
        overflow: 'auto',
        position: 'relative'
      };

      if (this._options.maxHeight) {
        style.maxHeight = this._getCSSValue(this._options.maxHeight);
      }

      if (this._options.maxWidth) {
        var width = this._getCSSValue(this._options.maxWidth);

        style.maxWidth = width;

        _manipulator["default"].style(this._element, {
          maxWidth: width
        });
      }

      _manipulator["default"].style(datatableBody, style);

      if (this._options.fixedHeader) {
        _selectorEngine["default"].find(SELECTOR_HEADER, this._element).forEach(function (header) {
          _manipulator["default"].addClass(header, CLASS_FIXED_CELL);

          _manipulator["default"].addClass(header, _this8._options.color);
        });
      }

      this._perfectScrollbar = new _perfectScrollbar["default"](datatableBody);
    }
  }, {
    key: "_setupSort",
    value: function _setupSort() {
      var _this9 = this;

      _selectorEngine["default"].find(SELECTOR_SORT_ICON, this._element).forEach(function (icon) {
        var field = _manipulator["default"].getDataAttribute(icon, 'sort');

        var _SelectorEngine$paren = _selectorEngine["default"].parents(icon, 'th'),
            _SelectorEngine$paren2 = _slicedToArray(_SelectorEngine$paren, 1),
            header = _SelectorEngine$paren2[0];

        _manipulator["default"].style(header, {
          cursor: 'pointer'
        });

        _eventHandler["default"].on(header, 'click', function () {
          if (_this9._sortField === field && _this9._sortOrder === 'asc') {
            _this9._sortOrder = 'desc';
          } else if (_this9._sortField === field && _this9._sortOrder === 'desc') {
            _this9._sortOrder = null;
          } else {
            _this9._sortOrder = 'asc';
          }

          _this9._sortField = field;
          _this9._activePage = 0;

          _this9._toggleDisableState();

          _this9._renderRows();

          _this9._setActiveSortIcon(icon);
        });
      });
    }
  }, {
    key: "_setupSelectable",
    value: function _setupSelectable() {
      var _this10 = this;

      this._checkboxes = _selectorEngine["default"].find(SELECTOR_ROW_CHECKBOX, this._element);
      this._headerCheckbox = _selectorEngine["default"].findOne(SELECTOR_HEADER_CHECKBOX, this._element);

      _eventHandler["default"].on(this._headerCheckbox, 'input', function (e) {
        return _this10._toggleSelectAll(e);
      });

      this._checkboxes.forEach(function (checkbox) {
        var rowIndex = _manipulator["default"].getDataAttribute(checkbox, 'rowIndex');

        _eventHandler["default"].on(checkbox, 'input', function (e) {
          return _this10._toggleSelectRow(e, rowIndex);
        });
      });
    }
  }, {
    key: "_setupPagination",
    value: function _setupPagination() {
      var _this11 = this;

      this._paginationRight = _selectorEngine["default"].findOne(SELECTOR_PAGINATION_RIGHT, this._element);
      this._paginationLeft = _selectorEngine["default"].findOne(SELECTOR_PAGINATION_LEFT, this._element);

      _eventHandler["default"].on(this._paginationRight, 'click', function () {
        return _this11._changeActivePage(_this11._activePage + 1);
      });

      _eventHandler["default"].on(this._paginationLeft, 'click', function () {
        return _this11._changeActivePage(_this11._activePage - 1);
      });

      if (this._options.fullPagination) {
        this._paginationStart = _selectorEngine["default"].findOne(SELECTOR_PAGINATION_START, this._element);
        this._paginationEnd = _selectorEngine["default"].findOne(SELECTOR_PAGINATION_END, this._element);

        _eventHandler["default"].on(this._paginationStart, 'click', function () {
          return _this11._changeActivePage(0);
        });

        _eventHandler["default"].on(this._paginationEnd, 'click', function () {
          return _this11._changeActivePage(_this11.pages - 1);
        });
      }

      this._toggleDisableState();

      this._setupPaginationSelect();
    }
  }, {
    key: "_setupPaginationSelect",
    value: function _setupPaginationSelect() {
      var _this12 = this;

      this._select = _selectorEngine["default"].findOne(SELECTOR_SELECT, this._element);

      if (this._selectInstance) {
        this._selectInstance.dispose();
      }

      this._selectInstance = new _select["default"](this._select);

      _eventHandler["default"].on(this._select, 'valueChange.mdb.select', function (e) {
        return _this12._setEntries(e);
      });
    }
  }, {
    key: "_removeEventListeners",
    value: function _removeEventListeners() {
      if (this._options.pagination) {
        _eventHandler["default"].off(this._paginationRight, 'click');

        _eventHandler["default"].off(this._paginationLeft, 'click');

        _eventHandler["default"].off(this._select, 'valueChange.mdb.select');

        if (this._options.fullPagination) {
          _eventHandler["default"].off(this._paginationStart, 'click');

          _eventHandler["default"].off(this._paginationEnd, 'click');
        }
      }

      if (this._options.editable) {
        _selectorEngine["default"].find(SELECTOR_CELL, this._element).forEach(function (cell) {
          _eventHandler["default"].off(cell, 'input');
        });
      }

      _selectorEngine["default"].find(SELECTOR_SORT_ICON, this._element).forEach(function (icon) {
        var _SelectorEngine$paren3 = _selectorEngine["default"].parents(icon, 'th'),
            _SelectorEngine$paren4 = _slicedToArray(_SelectorEngine$paren3, 1),
            header = _SelectorEngine$paren4[0];

        _eventHandler["default"].off(header, 'click');
      });

      if (this._options.selectable) {
        _eventHandler["default"].off(this._headerCheckbox, 'input');

        this._checkboxes.forEach(function (checkbox) {
          _eventHandler["default"].off(checkbox, 'input');
        });
      }
    }
  }, {
    key: "_renderTable",
    value: function _renderTable() {
      this._element.innerHTML = (0, _table["default"])(this.tableOptions).table;

      _eventHandler["default"].trigger(this._element, EVENT_RENDER);
    }
  }, {
    key: "_renderRows",
    value: function _renderRows() {
      var body = _selectorEngine["default"].findOne('tbody', this._element);

      if (this._options.pagination) {
        var navigation = _selectorEngine["default"].findOne(SELECTOR_PAGINATION_NAV, this._element);

        navigation.innerText = this.navigationText;
      }

      body.innerHTML = (0, _table["default"])(this.tableOptions).rows;

      if (this._options.edit) {
        this._setupEditable();
      }

      if (this._options.selectable) {
        this._setupSelectable();

        this._setSelected();
      }

      _eventHandler["default"].trigger(this._element, EVENT_RENDER);
    }
  }, {
    key: "_toggleDisableState",
    value: function _toggleDisableState() {
      if (this._activePage === 0 || this._options.loading) {
        this._paginationLeft.setAttribute('disabled', true);

        if (this._options.fullPagination) {
          this._paginationStart.setAttribute('disabled', true);
        }
      } else {
        this._paginationLeft.removeAttribute('disabled');

        if (this._options.fullPagination) {
          this._paginationStart.removeAttribute('disabled');
        }
      }

      if (this._activePage === this.pages - 1 || this._options.loading) {
        this._paginationRight.setAttribute('disabled', true);

        if (this._options.fullPagination) {
          this._paginationEnd.setAttribute('disabled', true);
        }
      } else {
        this._paginationRight.removeAttribute('disabled');

        if (this._options.fullPagination) {
          this._paginationEnd.removeAttribute('disabled');
        }
      }
    }
  }, {
    key: "_toggleSelectAll",
    value: function _toggleSelectAll(e) {
      if (e.target.checked) {
        this._selected = this.rows.map(function (row) {
          return row.rowIndex;
        });
      } else this._selected = [];

      this._setSelected();

      this._emitSelectEvent();
    }
  }, {
    key: "_toggleSelectRow",
    value: function _toggleSelectRow(e, rowIndex) {
      if (e.target.checked) {
        if (this._options.multi && !this._selected.includes(rowIndex)) {
          this._selected = [].concat(_toConsumableArray(this._selected), [rowIndex]);
        } else {
          this._selected = [rowIndex];

          this._checkboxes.forEach(function (checkbox) {
            if (checkbox !== e.target) {
              checkbox.checked = false;
            }
          });
        }
      } else {
        this._selected = this._selected.filter(function (index) {
          return index !== rowIndex;
        });
      }

      this._setActiveRows();

      this._emitSelectEvent();
    }
  }, {
    key: "_updateRow",
    value: function _updateRow(event, index) {
      var field = _manipulator["default"].getDataAttribute(event.target, 'field');

      var value = event.target.textContent;
      var row = this._rows[index];

      if (Array.isArray(row)) {
        var column = this.columns.find(function (column) {
          return column.field === field;
        });
        var columnIndex = column.columnIndex;
        row[columnIndex] = value;
      } else {
        row[field] = value;
      }

      _eventHandler["default"].trigger(this._element, EVENT_UPDATE, {
        rows: this._rows,
        columns: this._columns
      });
    }
  }, {
    key: "columns",
    get: function get() {
      return this._columns.map(function (column, index) {
        var template = _objectSpread({}, DEFAUL_COLUMN, {
          field: "field_".concat(index),
          columnIndex: index
        });

        if (typeof column === 'string') {
          template.label = column;
        } else if (_typeof(column) === 'object') {
          template = _objectSpread({}, template, {}, column);
        }

        (0, _index.typeCheckConfig)('column', template, TYPE_COLUMN_FIELDS);
        return template;
      });
    }
  }, {
    key: "rows",
    get: function get() {
      var _this13 = this;

      return this._rows.map(function (row, index) {
        var output = {
          rowIndex: index
        };

        if (Array.isArray(row)) {
          _this13.columns.forEach(function (column, i) {
            output[column.field] = row[i] || _this13._options.defaultValue;
          });
        } else if (_typeof(row) === 'object') {
          _this13.columns.forEach(function (column) {
            output[column.field] = row[column.field] || _this13._options.defaultValue;
          });
        }

        return output;
      });
    }
  }, {
    key: "searchResult",
    get: function get() {
      return (0, _util.search)(this.rows, this._search, this._searchColumn);
    }
  }, {
    key: "computedRows",
    get: function get() {
      var result = _toConsumableArray(this.searchResult);

      if (this._sortOrder) {
        result = (0, _util.sort)({
          rows: result,
          field: this._sortField,
          order: this._sortOrder
        });
      }

      if (this._options.pagination) {
        result = (0, _util.paginate)({
          rows: result,
          entries: this._options.entries,
          activePage: this._activePage
        });
      }

      return result;
    }
  }, {
    key: "pages",
    get: function get() {
      return Math.ceil(this.rows.length / this._options.entries);
    }
  }, {
    key: "navigationText",
    get: function get() {
      var firstVisibleEntry = this._activePage * this._options.entries;
      return "".concat(firstVisibleEntry + 1, " - ").concat(this.computedRows.length + firstVisibleEntry, " of ").concat(this.searchResult.length);
    }
  }, {
    key: "classNames",
    get: function get() {
      return [CLASS_DATATABLE, this._options.color, this._options.borderColor && "border-".concat(this._options.borderColor), this._options.dark && 'datatable-dark', this._options.hover && 'datatable-hover', this._options.bordered && 'datatable-bordered', this._options.borderless && 'datatable-borderless', this._options.sm && 'datatable-sm', this._options.striped && 'datatable-striped', this._options.loading && 'datatable-loading'].filter(function (className) {
        return className;
      });
    }
  }, {
    key: "tableOptions",
    get: function get() {
      return {
        columns: this.columns,
        rows: this.computedRows,
        noFoundMessage: this._options.noFoundMessage,
        edit: this._options.edit,
        loading: this._options.loading,
        loaderClass: this._options.loaderClass,
        loadingMessage: this._options.loadingMessage,
        selectable: this._options.selectable,
        multi: this._options.multi,
        pagination: {
          enable: this._options.pagination,
          text: this.navigationText,
          entries: this._options.entries,
          entriesOptions: this._options.entriesOptions,
          fullPagination: this._options.fullPagination,
          rowsText: this._options.rowsText
        }
      };
    }
  }], [{
    key: "jQueryInterface",
    value: function jQueryInterface(config, param1, param2) {
      return this.each(function () {
        var data = _data["default"].getData(this, DATA_KEY);

        var _config = _typeof(config) === 'object' && config;

        if (!data && /dispose/.test(config)) {
          return;
        }

        if (!data) {
          data = new Datatable(this, _config, param1);
        }

        if (typeof config === 'string') {
          if (typeof data[config] === 'undefined') {
            throw new TypeError("No method named \"".concat(config, "\""));
          }

          data[config](param1, param2);
        }
      });
    }
  }, {
    key: "getInstance",
    value: function getInstance(element) {
      return _data["default"].getData(element, DATA_KEY);
    }
  }, {
    key: "NAME",
    get: function get() {
      return NAME;
    }
  }]);

  return Datatable;
}();
/**
 * ------------------------------------------------------------------------
 * Data Api implementation - auto initialization
 * ------------------------------------------------------------------------
 */


_selectorEngine["default"].find(SELECTOR_DATATABLE).forEach(function (datatable) {
  var instance = Datatable.getInstance(datatable);

  if (!instance) {
    instance = new Datatable(datatable);
  }

  return instance;
});
/**
 * ------------------------------------------------------------------------
 * jQuery
 * ------------------------------------------------------------------------
 * add .datatable to jQuery only if jQuery is present
 */


var $ = (0, _index.getjQuery)();

if ($) {
  var JQUERY_NO_CONFLICT = $.fn[NAME];
  $.fn[NAME] = Datatable.jQueryInterface;
  $.fn[NAME].Constructor = Datatable;

  $.fn[NAME].noConflict = function () {
    $.fn[NAME] = JQUERY_NO_CONFLICT;
    return Datatable.jQueryInterface;
  };
}

var _default = Datatable;
exports["default"] = _default;