"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

/* eslint-disable indent */
var rows = function rows(_ref) {
  var rows = _ref.rows,
      columns = _ref.columns,
      noFoundMessage = _ref.noFoundMessage,
      edit = _ref.edit,
      selectable = _ref.selectable,
      loading = _ref.loading;
  var rowsTemplate = rows.map(function (row) {
    var checkbox = "\n    <td data-field=\"checkbox\">\n      <div class=\"form-check\">\n        <input data-row-index=\"".concat(row.rowIndex, "\" class=\"datatable-row-checkbox form-check-input\" type=\"checkbox\">\n      </div>\n    </td>\n    ");
    var innerRow = columns.map(function (column, i) {
      var style = {};

      if (column.width) {
        style['min-width'] = "".concat(column.width, "px");
        style['max-width'] = "".concat(column.width, "px");
      }

      if (column.fixed) {
        var fixedOffset = columns.filter(function (cell, j) {
          return cell.fixed === column.fixed && j < i;
        }).reduce(function (a, b) {
          return a + b.width;
        }, 0);
        style[column.fixed === 'right' ? 'right' : 'left'] = "".concat(fixedOffset, "px");
      }

      var cssText = Object.keys(style).map(function (property) {
        return "".concat(property, ": ").concat(style[property]);
      }).join('; ');
      return "<td style=\"".concat(cssText, "\" class=\"").concat(column.fixed ? 'fixed-cell' : '', "\" data-field=\"").concat(column.field, "\" ").concat(edit && 'contenteditable="true"', ">").concat(row[column.field], "</td>");
    }).join('');
    return "<tr scope=\"row\" data-index=\"".concat(row.rowIndex, "\">").concat(selectable ? checkbox : '').concat(innerRow, "</tr>");
  });
  return rows.length > 0 || loading ? rowsTemplate.join('\n') : "<tr><td>".concat(noFoundMessage, "</td></tr>");
};

var _default = rows;
exports["default"] = _default;