"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _pagination = _interopRequireDefault(require("./pagination"));

var _columns = _interopRequireDefault(require("./columns"));

var _rows = _interopRequireDefault(require("./rows"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/* eslint-disable indent */
var tableTemplate = function tableTemplate(_ref) {
  var columns = _ref.columns,
      rows = _ref.rows,
      noFoundMessage = _ref.noFoundMessage,
      edit = _ref.edit,
      multi = _ref.multi,
      selectable = _ref.selectable,
      loading = _ref.loading,
      loadingMessage = _ref.loadingMessage,
      loaderClass = _ref.loaderClass,
      pagination = _ref.pagination;
  var rowsTemplate = (0, _rows["default"])({
    rows: rows,
    columns: columns,
    noFoundMessage: noFoundMessage,
    edit: edit,
    loading: loading,
    selectable: selectable
  });
  var columnsTemplate = (0, _columns["default"])(columns, selectable, multi);
  var table = "\n<div class=\"datatable-inner table-responsive\">\n  <table class=\"table datatable-table\">\n    <thead class=\"datatable-header\">\n      <tr>\n        ".concat(columnsTemplate, "\n      </tr>\n    </thead>\n    <tbody class=\"datatable-body\">\n      ").concat(loading ? '' : rowsTemplate, "\n    </tbody>\n  </table>\n</div>\n  ").concat(loading ? "\n  <div class=\"datatable-loader bg-light}\">\n    <span class=\"datatable-loader-inner\"><span class=\"datatable-progress ".concat(loaderClass, "\"></span></span>\n  </div>\n  <p class=\"text-center text-muted my-4\">").concat(loadingMessage, "</p>\n") : '', "\n  ").concat(pagination.enable ? (0, _pagination["default"])(pagination, loading) : '', "\n  ");
  return {
    table: table,
    rows: rowsTemplate,
    column: columnsTemplate
  };
};

var _default = tableTemplate;
exports["default"] = _default;