"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _index = require("../mdb/util/index");

var _eventHandler = _interopRequireDefault(require("../mdb/dom/event-handler"));

var _manipulator = _interopRequireDefault(require("../mdb/dom/manipulator"));

var _selectorEngine = _interopRequireDefault(require("../mdb/dom/selector-engine"));

var _alert = _interopRequireDefault(require("../bootstrap/src/alert"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

/**
 * ------------------------------------------------------------------------
 * Constants
 * ------------------------------------------------------------------------
 */
var NAME = 'alert';
var SELECTOR_ALERT = '.alert';
var DefaultType = {
  position: '(string || null)',
  delay: 'number',
  autohide: 'boolean',
  width: '(string || null)',
  offset: 'number',
  stacking: 'boolean',
  hidden: 'boolean',
  appendToBody: 'boolean',
  color: '(string || null)'
};
var Default = {
  position: null,
  delay: 1000,
  autohide: false,
  width: null,
  offset: 10,
  stacking: false,
  hidden: false,
  appendToBody: false,
  color: null
};

var Alert =
/*#__PURE__*/
function (_BSAlert) {
  _inherits(Alert, _BSAlert);

  function Alert(element) {
    var _this;

    var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, Alert);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Alert).call(this, element, data));
    _this._options = _this._getConfig(data);

    _this._init();

    return _this;
  } // Getters


  _createClass(Alert, [{
    key: "update",
    // Public
    value: function update() {
      var updatedData = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (this._timeout !== null) {
        clearTimeout(this._timeout);
        this._timeout = null;
      }

      this._options = this._getConfig(updatedData);

      this._setup();
    }
  }, {
    key: "hide",
    value: function hide() {
      var _this2 = this;

      if (this._element.classList.contains('show')) {
        _manipulator["default"].toggleClass(this._element, 'show');

        var handler = function handler(e) {
          _manipulator["default"].style(e.target, {
            display: 'none'
          });

          if (_this2._timeout !== null) {
            clearTimeout(_this2._timeout);
            _this2._timeout = null;
          }

          _eventHandler["default"].off(e.target, 'transitionend', handler);
        };

        _eventHandler["default"].on(this._element, 'transitionend', handler);
      }
    }
  }, {
    key: "show",
    value: function show() {
      if (this._options.autohide) {
        this._setupAutohide();
      }

      if (!this._element.classList.contains('show')) {
        _manipulator["default"].style(this._element, {
          display: 'block'
        });

        if ((0, _index.isVisible)(this._element)) {
          var handler = function handler(e) {
            _manipulator["default"].style(e.target, {
              display: 'block'
            });

            _eventHandler["default"].off(e.target, 'transitionend', handler);
          };

          _manipulator["default"].toggleClass(this._element, 'show');

          if (this._options.position) {
            this._setupAlignment();
          }

          _eventHandler["default"].on(this._element, 'transitionend', handler);
        }
      }
    } // Private

  }, {
    key: "_init",
    value: function _init() {
      if (this._options.hidden) {
        _manipulator["default"].style(this._element, {
          display: 'none'
        });
      }

      if (this._options.color) {
        this._setColor();
      }

      this._setup();
    }
  }, {
    key: "_setup",
    value: function _setup() {
      if (this._options.autohide) {
        this._setupAutohide();
      }

      if (this._options.width) {
        this._setupWidth();
      }

      if (this._options.appendToBody) {
        this._appendToBody();
      }

      if (!this._options.position) {
        return;
      }

      this._setupAlignment();

      this._setupPosition();
    }
  }, {
    key: "_setColor",
    value: function _setColor() {
      var _this3 = this;

      var colors = ['primary', 'secondary', 'success', 'info', 'warning', 'danger', 'light', 'dark'];
      var color = colors.includes(this._options.color) ? this._options.color : 'primary';
      colors.forEach(function (color) {
        _this3._element.classList.remove("alert-".concat(color));
      });

      _manipulator["default"].addClass(this._element, "alert-".concat(color));
    }
  }, {
    key: "_setupWidth",
    value: function _setupWidth() {
      _manipulator["default"].style(this._element, {
        width: this._options.width
      });
    }
  }, {
    key: "_setupAutohide",
    value: function _setupAutohide() {
      var _this4 = this;

      this._timeout = setTimeout(function () {
        _this4.hide();
      }, this._options.delay);
    }
  }, {
    key: "_setupAlignment",
    value: function _setupAlignment() {
      var oppositeY = this.position.y === 'top' ? 'bottom' : 'top';
      var oppositeX = this.position.x === 'left' ? 'right' : 'left';

      if (this.position.x === 'center') {
        var _Manipulator$style;

        _manipulator["default"].style(this._element, (_Manipulator$style = {}, _defineProperty(_Manipulator$style, this.position.y, "".concat(this.verticalOffset + this._options.offset, "px")), _defineProperty(_Manipulator$style, oppositeY, 'unset'), _defineProperty(_Manipulator$style, "left", '50%'), _defineProperty(_Manipulator$style, "transform", 'translate(-50%)'), _Manipulator$style));
      } else {
        var _Manipulator$style2;

        _manipulator["default"].style(this._element, (_Manipulator$style2 = {}, _defineProperty(_Manipulator$style2, this.position.y, "".concat(this.verticalOffset + this._options.offset, "px")), _defineProperty(_Manipulator$style2, this.position.x, "".concat(this._options.offset, "px")), _defineProperty(_Manipulator$style2, oppositeY, 'unset'), _defineProperty(_Manipulator$style2, oppositeX, 'unset'), _defineProperty(_Manipulator$style2, "transform", 'unset'), _Manipulator$style2));
      }
    }
  }, {
    key: "_setupPosition",
    value: function _setupPosition() {
      if (this._options.container) {
        _manipulator["default"].addClass(this.parent, 'parent-alert-relative');

        _manipulator["default"].addClass(this._element, 'alert-absolute');
      } else {
        _manipulator["default"].addClass(this._element, 'alert-fixed');
      }
    }
  }, {
    key: "_appendToBody",
    value: function _appendToBody() {
      this._element.parentNode.removeChild(this._element);

      document.body.appendChild(this._element);
    }
  }, {
    key: "_getConfig",
    value: function _getConfig(options) {
      var config = _objectSpread({}, Default, {}, _manipulator["default"].getDataAttributes(this._element), {}, options);

      (0, _index.typeCheckConfig)(NAME, config, DefaultType);
      return config;
    }
  }, {
    key: "verticalOffset",
    get: function get() {
      var _this5 = this;

      if (!this._options.stacking) return 0;

      var offset = _selectorEngine["default"].find(SELECTOR_ALERT).filter(function (alert) {
        return alert !== _this5._element && (0, _index.isVisible)(alert);
      }).map(function (alert) {
        return {
          el: alert,
          instance: Alert.getInstance(alert)
        };
      }).filter(function (_ref) {
        var instance = _ref.instance;
        if (!instance) return false;
        return instance._options.container === _this5._options.container && instance._options.position === _this5._options.position;
      }).map(function (_ref2) {
        var el = _ref2.el,
            instance = _ref2.instance;

        var _el$getBoundingClient = el.getBoundingClientRect(),
            y = _el$getBoundingClient.y,
            height = _el$getBoundingClient.height;

        if (_this5.position.y === 'bottom') {
          return y - (y - height - instance._options.offset * 2);
        }

        return instance._options.offset * 2 + height;
      }).reduce(function (a, b) {
        return a + b;
      }, 0);

      return offset;
    }
  }, {
    key: "parent",
    get: function get() {
      var _SelectorEngine$paren = _selectorEngine["default"].parents(this._element, this._options.container),
          _SelectorEngine$paren2 = _slicedToArray(_SelectorEngine$paren, 1),
          parent = _SelectorEngine$paren2[0];

      return parent;
    }
  }, {
    key: "position",
    get: function get() {
      var _this$_options$positi = this._options.position.split('-'),
          _this$_options$positi2 = _slicedToArray(_this$_options$positi, 2),
          y = _this$_options$positi2[0],
          x = _this$_options$positi2[1];

      return {
        y: y,
        x: x
      };
    }
  }]);

  return Alert;
}(_alert["default"]);
/**
 * ------------------------------------------------------------------------
 * Data Api implementation - auto initialization
 * ------------------------------------------------------------------------
 */


_selectorEngine["default"].find(SELECTOR_ALERT).forEach(function (alert) {
  var instance = Alert.getInstance(alert);

  if (!instance) {
    instance = new Alert(alert);
  }

  return instance;
});
/**
 * ------------------------------------------------------------------------
 * jQuery
 * ------------------------------------------------------------------------
 */


var $ = (0, _index.getjQuery)();

if ($) {
  var JQUERY_NO_CONFLICT = $.fn[NAME];
  $.fn[NAME] = Alert.jQueryInterface;
  $.fn[NAME].Constructor = Alert;

  $.fn[NAME].noConflict = function () {
    $.fn[NAME] = JQUERY_NO_CONFLICT;
    return Alert.jQueryInterface;
  };
}

var _default = Alert;
exports["default"] = _default;