"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _chart = require("chart.js");

var _chartjsPluginDatalabels = _interopRequireDefault(require("chartjs-plugin-datalabels"));

var _index = require("../mdb/util/index");

var _data = _interopRequireDefault(require("../mdb/dom/data"));

var _manipulator = _interopRequireDefault(require("../mdb/dom/manipulator"));

var _selectorEngine = _interopRequireDefault(require("../mdb/dom/selector-engine"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

_chart.Chart.plugins.unregister(_chartjsPluginDatalabels["default"]);
/**
 * ------------------------------------------------------------------------
 * Constants
 * ------------------------------------------------------------------------
 */


var merge = require('deepmerge');

var NAME = 'chart';
var DATA_KEY = 'mdb.chart';
var CLASSNAME_CHARTS = 'chart'; // Default options

var DEFAULT_OPTIONS = {
  line: {
    options: {
      elements: {
        line: {
          backgroundColor: 'rgba(66, 133, 244, 0.0)',
          borderColor: 'rgb(66, 133, 244)',
          borderWidth: 2,
          tension: 0.0
        },
        point: {
          borderColor: 'rgb(66, 133, 244)',
          backgroundColor: 'rgb(66, 133, 244)'
        }
      },
      responsive: true,
      legend: {
        display: true
      },
      tooltips: {
        intersect: false,
        mode: 'index'
      },
      datasets: {
        borderColor: 'red'
      },
      scales: {
        xAxes: [{
          stacked: true,
          gridLines: {
            display: false
          },
          ticks: {
            fontColor: 'rgba(0,0,0, 0.5)'
          }
        }],
        yAxes: [{
          stacked: false,
          gridLines: {
            borderDash: [2],
            drawBorder: false,
            zeroLineColor: 'rgba(0,0,0,0)',
            zeroLineBorderDash: [2],
            zeroLineBorderDashOffset: [2]
          },
          ticks: {
            fontColor: 'rgba(0,0,0, 0.5)'
          }
        }]
      }
    }
  },
  bar: {
    options: {
      elements: {
        line: {
          backgroundColor: 'rgb(66, 133, 244)',
          borderWidth: 0
        },
        rectangle: {
          backgroundColor: 'rgb(66, 133, 244)',
          borderWidth: 0
        }
      },
      responsive: true,
      legend: {
        display: true
      },
      tooltips: {
        intersect: false,
        mode: 'index'
      },
      scales: {
        xAxes: [{
          stacked: true,
          gridLines: {
            display: false
          },
          ticks: {
            fontColor: 'rgba(0,0,0, 0.5)'
          }
        }],
        yAxes: [{
          stacked: true,
          gridLines: {
            borderDash: [2],
            drawBorder: false,
            zeroLineColor: 'rgba(0,0,0,0)',
            zeroLineBorderDash: [2],
            zeroLineBorderDashOffset: [2]
          },
          ticks: {
            fontColor: 'rgba(0,0,0, 0.5)'
          }
        }]
      }
    }
  },
  horizontalBar: {
    options: {
      elements: {
        rectangle: {
          backgroundColor: 'rgb(66, 133, 244)',
          borderWidth: 0
        }
      },
      responsive: true,
      legend: {
        display: true
      },
      tooltips: {
        intersect: false,
        mode: 'index'
      },
      scales: {
        xAxes: [{
          stacked: true,
          gridLines: {
            display: true
          },
          ticks: {
            fontColor: 'rgba(0,0,0, 0.5)'
          }
        }],
        yAxes: [{
          stacked: true,
          gridLines: {
            display: false,
            borderDash: [2],
            drawBorder: false,
            zeroLineColor: 'rgba(0,0,0,0)',
            zeroLineBorderDash: [2],
            zeroLineBorderDashOffset: [2]
          },
          ticks: {
            fontColor: 'rgba(0,0,0, 0.5)'
          }
        }]
      }
    }
  },
  pie: {
    options: {
      elements: {
        arc: {
          backgroundColor: 'rgb(66, 133, 244)'
        }
      },
      responsive: true,
      legend: {
        display: true
      }
    }
  },
  doughnut: {
    options: {
      elements: {
        arc: {
          backgroundColor: 'rgb(66, 133, 244)'
        }
      },
      responsive: true,
      legend: {
        display: true
      }
    }
  },
  polarArea: {
    options: {
      elements: {
        arc: {
          backgroundColor: 'rgba(66, 133, 244, 0.5)'
        }
      },
      responsive: true,
      legend: {
        display: true
      }
    }
  },
  radar: {
    options: {
      elements: {
        line: {
          backgroundColor: 'rgba(66, 133, 244, 0.5)',
          borderColor: 'rgb(66, 133, 244)',
          borderWidth: 2
        },
        point: {
          borderColor: 'rgb(66, 133, 244)',
          backgroundColor: 'rgb(66, 133, 244)'
        }
      },
      responsive: true,
      legend: {
        display: true
      }
    }
  },
  scatter: {
    options: {
      elements: {
        line: {
          backgroundColor: 'rgba(66, 133, 244, 0.5)',
          borderColor: 'rgb(66, 133, 244)',
          borderWidth: 2,
          tension: 0.0
        },
        point: {
          borderColor: 'rgb(66, 133, 244)',
          backgroundColor: 'rgba(66, 133, 244, 0.5)'
        }
      },
      responsive: true,
      legend: {
        display: true
      },
      tooltips: {
        intersect: false,
        mode: 'index'
      },
      datasets: {
        borderColor: 'red'
      },
      scales: {
        xAxes: [{
          stacked: true,
          gridLines: {
            display: false
          },
          ticks: {
            fontColor: 'rgba(0,0,0, 0.5)'
          }
        }],
        yAxes: [{
          stacked: false,
          gridLines: {
            borderDash: [2],
            drawBorder: false,
            zeroLineColor: 'rgba(0,0,0,0)',
            zeroLineBorderDash: [2],
            zeroLineBorderDashOffset: [2]
          },
          ticks: {
            fontColor: 'rgba(0,0,0, 0.5)'
          }
        }]
      }
    }
  },
  bubble: {
    options: {
      elements: {
        point: {
          borderColor: 'rgb(66, 133, 244)',
          backgroundColor: 'rgba(66, 133, 244, 0.5)'
        }
      },
      responsive: true,
      legend: {
        display: true
      },
      scales: {
        xAxes: [{
          gridLines: {
            display: false
          },
          ticks: {
            fontColor: 'rgba(0,0,0, 0.5)'
          }
        }],
        yAxes: [{
          gridLines: {
            borderDash: [2],
            drawBorder: false,
            zeroLineColor: 'rgba(0,0,0,0)',
            zeroLineBorderDash: [2],
            zeroLineBorderDashOffset: [2]
          },
          ticks: {
            fontColor: 'rgba(0,0,0, 0.5)'
          }
        }]
      }
    }
  }
};

var GENERATE_DATA = function GENERATE_DATA(options, type, defaultType) {
  var mergeObjects = function mergeObjects(target, source, options) {
    var destination = target.slice();
    source.forEach(function (item, index) {
      if (typeof destination[index] === 'undefined') {
        destination[index] = options.cloneUnlessOtherwiseSpecified(item, options);
      } else if (options.isMergeableObject(item)) {
        destination[index] = merge(target[index], item, options);
      } else if (target.indexOf(item) === -1) {
        destination.push(item);
      }
    });
    return destination;
  };

  return merge(defaultType[type], options, {
    arrayMerge: mergeObjects
  });
};
/**
 * ------------------------------------------------------------------------
 * Class Definition
 * ------------------------------------------------------------------------
 */
//


var Chart =
/*#__PURE__*/
function () {
  function Chart(element, data) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

    _classCallCheck(this, Chart);

    this._element = element;
    this._data = data;
    this._options = options;
    this._type = data.type;
    this._canvas = null;
    this._chart = null;

    if (this._element) {
      _data["default"].setData(element, DATA_KEY, this);

      _manipulator["default"].addClass(this._element, CLASSNAME_CHARTS);

      this._chartConstructor();
    }
  } // Getters


  _createClass(Chart, [{
    key: "dispose",
    // Public
    value: function dispose() {
      _data["default"].removeData(this._element, DATA_KEY);

      this._element = null;
    }
  }, {
    key: "update",
    value: function update(data, config) {
      this._data = _objectSpread({}, this._data, {}, data);
      this._chart.data = this._data;

      this._chart.update(config);
    } // Private

  }, {
    key: "_chartConstructor",
    value: function _chartConstructor() {
      if (this._data) {
        this._createCanvas();

        var options = GENERATE_DATA(this._options, this._type, DEFAULT_OPTIONS);

        if (options.dataLabelsPlugin) {
          options.plugins = _chartjsPluginDatalabels["default"];
        }

        this._chart = new _chart.Chart(this._canvas, _objectSpread({}, this._data, {}, options));
      }
    }
  }, {
    key: "_createCanvas",
    value: function _createCanvas() {
      if (this._canvas) return;

      if (this._element.nodeName === 'CANVAS') {
        this._canvas = this._element;
      } else {
        this._canvas = (0, _index.element)('canvas');

        this._element.appendChild(this._canvas);
      }
    }
  }], [{
    key: "jQueryInterface",
    value: function jQueryInterface(data, options, type) {
      return this.each(function () {
        var chartData = _data["default"].getData(this, DATA_KEY);

        if (!chartData && /dispose/.test(data)) {
          return;
        }

        if (!chartData) {
          var chartOptions = options ? GENERATE_DATA(options, type, DEFAULT_OPTIONS) : DEFAULT_OPTIONS[type];
          chartData = new Chart(this, _objectSpread({}, data, {}, chartOptions));
        }

        if (typeof data === 'string') {
          if (typeof chartData[data] === 'undefined') {
            throw new TypeError("No method named \"".concat(data, "\""));
          }

          chartData[data](options, type);
        }
      });
    }
  }, {
    key: "getInstance",
    value: function getInstance(element) {
      return _data["default"].getData(element, DATA_KEY);
    }
  }, {
    key: "NAME",
    get: function get() {
      return NAME;
    }
  }]);

  return Chart;
}();
/**
 * ------------------------------------------------------------------------
 * Data Api implementation - auto initialization
 * ------------------------------------------------------------------------
 */
// eslint-disable-next-line consistent-return


var IS_COMPLEX = function IS_COMPLEX(data) {
  return data[0] === '{' && data[data.length - 1] === '}' || data[0] === '[' && data[data.length - 1] === ']';
};

var CONVERT_DATA_TYPE = function CONVERT_DATA_TYPE(data) {
  if (typeof data !== 'string') return data;

  if (IS_COMPLEX(data)) {
    return JSON.parse(data.replace(/'/g, '"'));
  }

  return data;
};

var PARSE_DATA = function PARSE_DATA(data) {
  var dataset = {};
  Object.keys(data).forEach(function (property) {
    if (property.match(/dataset.*/)) {
      var chartProperty = property.slice(7, 8).toLowerCase().concat(property.slice(8));
      dataset[chartProperty] = CONVERT_DATA_TYPE(data[property]);
    }
  });
  return dataset;
};

_selectorEngine["default"].find('[data-chart]').forEach(function (el) {
  if (_manipulator["default"].getDataAttribute(el, 'chart') !== 'bubble' && _manipulator["default"].getDataAttribute(el, 'chart') !== 'scatter') {
    var dataSet = _manipulator["default"].getDataAttributes(el);

    var dataAttr = {
      data: {
        datasets: [PARSE_DATA(dataSet)]
      }
    };

    if (dataSet.chart) {
      dataAttr.type = dataSet.chart;
    }

    if (dataSet.labels) {
      dataAttr.data.labels = JSON.parse(dataSet.labels.replace(/'/g, '"'));
    }

    return new Chart(el, _objectSpread({}, dataAttr, {}, DEFAULT_OPTIONS[dataAttr.type]));
  }

  return null;
});
/**
 * ------------------------------------------------------------------------
 * jQuery
 * ------------------------------------------------------------------------
 * add .chart to jQuery only if jQuery is present
 */


var $ = (0, _index.getjQuery)();

if ($) {
  var JQUERY_NO_CONFLICT = $.fn[NAME];
  $.fn[NAME] = Chart.jQueryInterface;
  $.fn[NAME].Constructor = Chart;

  $.fn[NAME].noConflict = function () {
    $.fn[NAME] = JQUERY_NO_CONFLICT;
    return Chart.jQueryInterface;
  };
}

var _default = Chart;
exports["default"] = _default;