"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _index = require("../mdb/util/index");

var _data = _interopRequireDefault(require("../mdb/dom/data"));

var _manipulator = _interopRequireDefault(require("../mdb/dom/manipulator"));

var _selectorEngine = _interopRequireDefault(require("../mdb/dom/selector-engine"));

var _eventHandler = _interopRequireDefault(require("../mdb/dom/event-handler"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * ------------------------------------------------------------------------
 * Constants
 * ------------------------------------------------------------------------
 */
var NAME = 'infiniteScroll';
var DATA_KEY = 'mdb.infiniteScroll';
var SELECTOR_INFINITE_SCROLL = '.infinite-scroll';
var Default = {
  infiniteDirection: 'y'
};
var DefaultType = {
  infiniteDirection: 'string'
};

var InfiniteScroll =
/*#__PURE__*/
function () {
  function InfiniteScroll(element, data) {
    _classCallCheck(this, InfiniteScroll);

    this._element = element;

    if (this._element) {
      _data["default"].setData(element, DATA_KEY, this);
    }

    this._options = this._getConfig(data);
    this.scrollHandler = this._scrollHandler.bind(this);

    this._init();
  } // Getters


  _createClass(InfiniteScroll, [{
    key: "dispose",
    // Public
    value: function dispose() {
      _eventHandler["default"].off(this._element, 'scroll', this.scrollHandler);

      _data["default"].removeData(this._element, DATA_KEY);

      this._element = null;
    } // Private

  }, {
    key: "_init",
    value: function _init() {
      var _this = this;

      _eventHandler["default"].on(this._element, 'scroll', function () {
        return _this._scrollHandler();
      });
    }
  }, {
    key: "_scrollHandler",
    value: function _scrollHandler() {
      if (this.condition) {
        _eventHandler["default"].trigger(this._element, 'complete.mdb.infiniteScroll');
      }

      _eventHandler["default"].off(this._element, 'scroll', this.scrollHandler);
    }
  }, {
    key: "_getConfig",
    value: function _getConfig(options) {
      var config = _objectSpread({}, Default, {}, _manipulator["default"].getDataAttributes(this._element), {}, options);

      (0, _index.typeCheckConfig)(NAME, config, DefaultType);
      return config;
    } // Static

  }, {
    key: "rect",
    get: function get() {
      return this._element.getBoundingClientRect();
    }
  }, {
    key: "condition",
    get: function get() {
      if (this._element === window) {
        return window.scrollY + window.innerHeight === document.documentElement.scrollHeight;
      }

      if (this._options.infiniteDirection === 'x') {
        return this.rect.width + this._element.scrollLeft + 10 >= this._element.scrollWidth;
      }

      return this.rect.height + this._element.scrollTop >= this._element.scrollHeight;
    }
  }], [{
    key: "getInstance",
    value: function getInstance(element) {
      return _data["default"].getData(element, DATA_KEY);
    }
  }, {
    key: "jQueryInterface",
    value: function jQueryInterface(config) {
      return this.each(function () {
        var data = _data["default"].getData(this, DATA_KEY);

        var _config = _typeof(config) === 'object' && config;

        if (!data) {
          data = new InfiniteScroll(this, _config);
        }

        if (typeof config === 'string') {
          if (typeof data[config] === 'undefined') {
            throw new TypeError("No method named \"".concat(config, "\""));
          }

          data[config](this);
        }
      });
    }
  }, {
    key: "NAME",
    get: function get() {
      return NAME;
    }
  }]);

  return InfiniteScroll;
}();
/**
 * ------------------------------------------------------------------------
 * Data Api implementation - auto initialization
 * ------------------------------------------------------------------------
 */


_selectorEngine["default"].find(SELECTOR_INFINITE_SCROLL).forEach(function (infiniteScroll) {
  var instance = InfiniteScroll.getInstance(infiniteScroll);

  if (!instance) {
    instance = new InfiniteScroll(infiniteScroll);
  }

  return instance;
});
/**
 * ------------------------------------------------------------------------
 * jQuery
 * ------------------------------------------------------------------------
 */


var $ = (0, _index.getjQuery)();

if ($) {
  var JQUERY_NO_CONFLICT = $.fn[NAME];
  $.fn[NAME] = InfiniteScroll.jQueryInterface;
  $.fn[NAME].Constructor = InfiniteScroll;

  $.fn[NAME].noConflict = function () {
    $.fn[NAME] = JQUERY_NO_CONFLICT;
    return InfiniteScroll.jQueryInterface;
  };
}

var _default = InfiniteScroll;
exports["default"] = _default;