"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _data = _interopRequireDefault(require("../mdb/dom/data"));

var _eventHandler = _interopRequireDefault(require("../bootstrap/src/dom/event-handler"));

var _manipulator = _interopRequireDefault(require("../mdb/dom/manipulator"));

var _selectorEngine = _interopRequireDefault(require("../mdb/dom/selector-engine"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * ------------------------------------------------------------------------
 * Constants
 * ------------------------------------------------------------------------
 */
var NAME = 'navbar';
var DATA_KEY = 'mdb.navbar';
var CLASSNAME_WRAPPER = 'navbar-scroll';
/**
 * ------------------------------------------------------------------------
 * Class Definition
 * ------------------------------------------------------------------------
 */

var Navbar =
/*#__PURE__*/
function () {
  function Navbar(element) {
    _classCallCheck(this, Navbar);

    this._element = element;

    if (this._element) {
      _data["default"].setData(element, DATA_KEY, this);
    }
  } // Getters


  _createClass(Navbar, [{
    key: "init",
    // Public
    value: function init() {
      this._onScroll();

      this._addEvent();
    }
  }, {
    key: "dispose",
    value: function dispose() {
      this._removeEvent();

      _data["default"].removeData(this._element, DATA_KEY);

      this._element = null;
    } // Private

  }, {
    key: "_addEvent",
    value: function _addEvent() {
      var _this = this;

      _eventHandler["default"].on(window, 'scroll', function () {
        return _this._onScroll();
      });
    }
  }, {
    key: "_removeEvent",
    value: function _removeEvent() {
      _eventHandler["default"].off(window, 'scroll', this._onScroll);
    }
  }, {
    key: "_onScroll",
    value: function _onScroll() {
      if (window.scrollY > 0) {
        _manipulator["default"].addClass(this._element, 'navbar-scrolled');
      } else {
        _manipulator["default"].removeClass(this._element, 'navbar-scrolled');
      }
    }
  }], [{
    key: "getInstance",
    value: function getInstance(element) {
      return _data["default"].getData(element, DATA_KEY);
    }
  }, {
    key: "NAME",
    get: function get() {
      return NAME;
    }
  }]);

  return Navbar;
}(); // auto-init


_selectorEngine["default"].find(".".concat(CLASSNAME_WRAPPER)).forEach(function (element) {
  new Navbar(element).init();
});

var _default = Navbar;
exports["default"] = _default;