"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _perfectScrollbar = _interopRequireDefault(require("perfect-scrollbar"));

var _index = require("../mdb/util/index");

var _data = _interopRequireDefault(require("../mdb/dom/data"));

var _manipulator = _interopRequireDefault(require("../mdb/dom/manipulator"));

var _eventHandler = _interopRequireDefault(require("../mdb/dom/event-handler"));

var _selectorEngine = _interopRequireDefault(require("../mdb/dom/selector-engine"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var NAME = 'perfectScrollbar';
var CLASSNAME_PS = 'perfect-scrollbar';
var DATA_KEY = 'mdb.perfectScrollbar';
var MDB_NAME = 'mdb';
var PS_NAME = 'ps';
var EVENTS = [{
  mdb: "scrollX.".concat(MDB_NAME, ".").concat(PS_NAME),
  ps: 'ps-scroll-x'
}, {
  mdb: "scrollY.".concat(MDB_NAME, ".").concat(PS_NAME),
  ps: 'ps-scroll-y'
}, {
  mdb: "scrollUp.".concat(MDB_NAME, ".").concat(PS_NAME),
  ps: 'ps-scroll-up'
}, {
  mdb: "scrollDown.".concat(MDB_NAME, ".").concat(PS_NAME),
  ps: 'ps-scroll-down'
}, {
  mdb: "scrollLeft.".concat(MDB_NAME, ".").concat(PS_NAME),
  ps: 'ps-scroll-left'
}, {
  mdb: "scrollRight.".concat(MDB_NAME, ".").concat(PS_NAME),
  ps: 'ps-scroll-right'
}, {
  mdb: "scrollXEnd.".concat(MDB_NAME, ".").concat(PS_NAME),
  ps: 'ps-x-reach-end'
}, {
  mdb: "scrollYEnd.".concat(MDB_NAME, ".").concat(PS_NAME),
  ps: 'ps-y-reach-end'
}, {
  mdb: "scrollXStart.".concat(MDB_NAME, ".").concat(PS_NAME),
  ps: 'ps-x-reach-start'
}, {
  mdb: "scrollYStart.".concat(MDB_NAME, ".").concat(PS_NAME),
  ps: 'ps-y-reach-start'
}];
var Default = {
  handlers: ['click-rail', 'drag-thumb', 'keyboard', 'wheel', 'touch'],
  wheelSpeed: 1,
  wheelPropagation: true,
  swipeEasing: true,
  minScrollbarLength: null,
  maxScrollbarLength: null,
  scrollingThreshold: 1000,
  useBothWheelAxes: false,
  suppressScrollX: false,
  suppressScrollY: false,
  scrollXMarginOffset: 0,
  scrollYMarginOffset: 0
};
var DefaultType = {
  handlers: '(string|array)',
  wheelSpeed: 'number',
  wheelPropagation: 'boolean',
  swipeEasing: 'boolean',
  minScrollbarLength: '(number|null)',
  maxScrollbarLength: '(number|null)',
  scrollingThreshold: 'number',
  useBothWheelAxes: 'boolean',
  suppressScrollX: 'boolean',
  suppressScrollY: 'boolean',
  scrollXMarginOffset: 'number',
  scrollYMarginOffset: 'number'
};

var PerfectScrollbars =
/*#__PURE__*/
function () {
  function PerfectScrollbars(element) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, PerfectScrollbars);

    this._element = element;
    this._options = this._getConfig(options);
    this.perfectScrollbar = null;

    if (this._element) {
      _data["default"].setData(element, DATA_KEY, this);

      _manipulator["default"].addClass(this._element, CLASSNAME_PS);
    }

    this.init();
  } // Getters


  _createClass(PerfectScrollbars, [{
    key: "_getConfig",
    value: function _getConfig(config) {
      var dataAttributes = _manipulator["default"].getDataAttributes(this._element);

      if (dataAttributes.handlers !== undefined) {
        dataAttributes.handlers = dataAttributes.handlers.split(' ');
      }

      config = _objectSpread({}, Default, {}, dataAttributes, {}, config);
      (0, _index.typeCheckConfig)(NAME, config, DefaultType);
      return config;
    } // Public

  }, {
    key: "dispose",
    value: function dispose() {
      _data["default"].removeData(this._element, DATA_KEY);

      this._element = null;
      this._dataAttrOptions = null;
      this._options = null;
      this.perfectScrollbar.destroy();
      this.removeEvent(EVENTS);
      this.perfectScrollbar = null;
    }
  }, {
    key: "init",
    value: function init() {
      this.perfectScrollbar = new _perfectScrollbar["default"](this._element, this._options);

      this._initEvents(EVENTS);
    }
  }, {
    key: "update",
    value: function update() {
      return this.perfectScrollbar.update();
    }
  }, {
    key: "_initEvents",
    value: function _initEvents() {
      var _this = this;

      var events = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      events.forEach(function (_ref) {
        var ps = _ref.ps,
            mdb = _ref.mdb;
        return _eventHandler["default"].on(_this._element, ps, function (e) {
          return _eventHandler["default"].trigger(_this._element, mdb, {
            e: e
          });
        });
      });
    }
  }, {
    key: "removeEvent",
    value: function removeEvent(event) {
      var _this2 = this;

      var filter = [];

      if (typeof event === 'string') {
        filter = EVENTS.filter(function (_ref2) {
          var mdb = _ref2.mdb;
          return mdb === event;
        });
      }

      filter.forEach(function (_ref3) {
        var ps = _ref3.ps,
            mdb = _ref3.mdb;

        _eventHandler["default"].off(_this2._element, ps);

        _eventHandler["default"].off(_this2._element, mdb);
      });
    } // Static

  }], [{
    key: "jQueryInterface",
    value: function jQueryInterface(config) {
      return this.each(function () {
        var data = _data["default"].getData(this, DATA_KEY);

        var _config = _typeof(config) === 'object' && config;

        if (!data && /dispose|hide/.test(config)) {
          return;
        }

        if (!data) {
          data = new PerfectScrollbars(this, _config);
        }

        if (typeof config === 'string') {
          if (typeof data[config] === 'undefined') {
            throw new TypeError("No method named \"".concat(config, "\""));
          }

          data[config]();
        }
      });
    }
  }, {
    key: "getInstance",
    value: function getInstance(element) {
      return _data["default"].getData(element, DATA_KEY);
    }
  }, {
    key: "NAME",
    get: function get() {
      return NAME;
    }
  }]);

  return PerfectScrollbars;
}();

_selectorEngine["default"].find('[data-perfect-scrollbar="true"]').forEach(function (scroll) {
  var instance = PerfectScrollbars.getInstance(scroll);

  if (!instance) {
    instance = new PerfectScrollbars(scroll);
  }

  return instance;
});
/**
 * ------------------------------------------------------------------------
 * jQuery
 * ------------------------------------------------------------------------
 * add .perfectScrollbar to jQuery only if jQuery is present
 */


var $ = (0, _index.getjQuery)();

if ($) {
  var JQUERY_NO_CONFLICT = $.fn[NAME];
  $.fn[NAME] = PerfectScrollbars.jQueryInterface;
  $.fn[NAME].Constructor = PerfectScrollbars;

  $.fn[NAME].noConflict = function () {
    $.fn[NAME] = JQUERY_NO_CONFLICT;
    return PerfectScrollbars.jQueryInterface;
  };
}

var _default = PerfectScrollbars;
exports["default"] = _default;