"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _perfectScrollbar = _interopRequireDefault(require("perfect-scrollbar"));

var _index = require("../mdb/util/index");

var _focusTrap = _interopRequireDefault(require("../mdb/util/focusTrap"));

var _keycodes = require("../mdb/util/keycodes");

var _touch = _interopRequireDefault(require("../mdb/util/touch"));

var _collapse = _interopRequireDefault(require("../bootstrap/src/collapse"));

var _data = _interopRequireDefault(require("../mdb/dom/data"));

var _eventHandler = _interopRequireDefault(require("../bootstrap/src/dom/event-handler"));

var _manipulator = _interopRequireDefault(require("../mdb/dom/manipulator"));

var _selectorEngine = _interopRequireDefault(require("../mdb/dom/selector-engine"));

var _ripple = _interopRequireDefault(require("../free/ripple"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * ------------------------------------------------------------------------
 * Constants
 * ------------------------------------------------------------------------
 */
var NAME = 'sidenav';
var DATA_KEY = 'mdb.sidenav';
var ARROW_CLASS = 'rotate-icon';
var BACKDROP_CLASS = 'sidenav-backdrop';
var SELECTOR_SIDENAV = '.sidenav';
var SELECTOR_TOGGLE = '[data-toggle="sidenav"]';
var SELECTOR_SHOW_SLIM = '[data-slim="true"]';
var SELECTOR_HIDE_SLIM = '[data-slim="false"]';
var SELECTOR_NAVIGATION = '.sidenav-menu';
var SELECTOR_COLLAPSE = '.sidenav-collapse';
var SELECTOR_LINK = '.sidenav-link';
var TRANSLATION_LEFT = -100;
var TRANSLATION_RIGHT = 100;
var instanceCount = 0;
var OPTIONS_TYPE = {
  accordion: '(boolean)',
  backdrop: '(boolean)',
  backdropClass: '(null|string)',
  closeOnEsc: '(boolean)',
  color: '(string)',
  content: '(null|string)',
  expandable: '(boolean)',
  expandOnHover: '(boolean)',
  focusTrap: '(boolean)',
  hidden: '(boolean)',
  mode: '(string)',
  scrollContainer: '(null|string)',
  slim: '(boolean)',
  slimCollapsed: '(boolean)',
  slimWidth: '(number)',
  position: '(string)',
  right: '(boolean)',
  transitionDuration: '(number)',
  width: '(number)'
};
var DEFAULT_OPTIONS = {
  accordion: false,
  backdrop: true,
  backdropClass: null,
  closeOnEsc: true,
  color: 'primary',
  content: null,
  expandable: true,
  expandOnHover: false,
  focusTrap: true,
  hidden: true,
  mode: 'over',
  scrollContainer: null,
  slim: false,
  slimCollapsed: false,
  slimWidth: 70,
  position: 'fixed',
  right: false,
  transitionDuration: 300,
  width: 240
};
/**
 * ------------------------------------------------------------------------
 * Class Definition
 * ------------------------------------------------------------------------
 */

var Sidenav =
/*#__PURE__*/
function () {
  function Sidenav(node) {
    var _this = this;

    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, Sidenav);

    this._element = node;
    this._options = options;
    instanceCount++;
    this._ID = instanceCount;
    this._backdrop = null;
    this._content = null;
    this._initialContentStyle = null;
    this._slimCollapsed = false;
    this._activeNode = null;
    this._tempSlim = false;
    this._focusTrap = null;
    this._perfectScrollbar = null;
    this._touch = null;

    this.escHandler = function (e) {
      if (e.keyCode === _keycodes.ESCAPE && _this.toggler && (0, _index.isVisible)(_this.toggler)) {
        _this._update(false);

        _eventHandler["default"].off(window, 'keydown', _this.escHandler);
      }
    };

    this.hashHandler = function () {
      _this._setActiveElements();
    };

    if (node) {
      _data["default"].setData(node, DATA_KEY, this);

      this._setup();
    }
  } // Getters


  _createClass(Sidenav, [{
    key: "changeMode",
    // Public
    value: function changeMode(mode) {
      this._setMode(mode);
    }
  }, {
    key: "dispose",
    value: function dispose() {
      if (this._backdrop) {
        this._removeBackdrop();
      }

      _eventHandler["default"].off(window, 'keydown', this.escHandler);

      _eventHandler["default"].off(window, 'hashchange', this.hashHandler);

      this._touch.dispose();

      _data["default"].removeData(this._element, DATA_KEY);

      this._element = null;
    }
  }, {
    key: "hide",
    value: function hide() {
      this._setVisibility(false);

      this._update(false);
    }
  }, {
    key: "show",
    value: function show() {
      this._setVisibility(true);

      this._update(true);
    }
  }, {
    key: "toggle",
    value: function toggle() {
      this._setVisibility(!this.isVisible);

      this._update(!this.isVisible);
    }
  }, {
    key: "toggleSlim",
    value: function toggleSlim() {
      this._setSlim(!this._slimCollapsed);
    }
  }, {
    key: "update",
    value: function update(options) {
      this._options = options;

      this._setup();
    } // Private

  }, {
    key: "_appendArrow",
    value: function _appendArrow(node) {
      var arrow = (0, _index.element)('i');
      ['fas', 'fa-angle-down', ARROW_CLASS].forEach(function (className) {
        _manipulator["default"].addClass(arrow, className);
      });

      if (_selectorEngine["default"].find(".".concat(ARROW_CLASS), node).length === 0) {
        node.appendChild(arrow);
      }
    }
  }, {
    key: "_collapseItems",
    value: function _collapseItems() {
      this.navigation.forEach(function (menu) {
        var collapseElements = _selectorEngine["default"].find(SELECTOR_COLLAPSE, menu);

        collapseElements.forEach(function (el) {
          _collapse["default"].getInstance(el).hide();
        });
      });
    }
  }, {
    key: "_setupBackdrop",
    value: function _setupBackdrop() {
      var _this2 = this,
          _this$_backdrop$class;

      var classes = [];

      if (this.options.backdropClass) {
        classes.push(this.options.backdropClass);
      }

      var style = {
        transition: "opacity ".concat(this.transitionDuration, " ease-out"),
        position: this.options.position,
        width: this.options.position === 'fixed' ? '100vw' : '100%',
        height: this.options.position === 'fixed' ? '100vh' : '100%'
      };

      if (!this._backdrop) {
        var backdrop = (0, _index.element)('div');
        classes.push(BACKDROP_CLASS);
        style.opacity = 0;

        _eventHandler["default"].on(backdrop, 'click', function () {
          _this2._setVisibility(false);

          _this2._update(false);
        });

        this._backdrop = backdrop;
      }

      (_this$_backdrop$class = this._backdrop.classList).add.apply(_this$_backdrop$class, classes);

      _manipulator["default"].style(this._backdrop, style);
    }
  }, {
    key: "_getOffsetValue",
    value: function _getOffsetValue(show, _ref) {
      var index = _ref.index,
          property = _ref.property,
          offsets = _ref.offsets;

      var initialValue = this._getPxValue(this._initialContentStyle[index][offsets[property].property]);

      var offset = show ? offsets[property].value : 0;
      return initialValue + offset;
    }
  }, {
    key: "_getProperty",
    value: function _getProperty() {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return args.map(function (arg, i) {
        if (i === 0) {
          return arg;
        }

        return arg[0].toUpperCase().concat(arg.slice(1));
      }).join('');
    }
  }, {
    key: "_getPxValue",
    value: function _getPxValue(property) {
      if (!property) {
        return 0;
      }

      return parseFloat(property);
    }
  }, {
    key: "_handleSwipe",
    value: function _handleSwipe(e, inverseDirecion) {
      if (inverseDirecion && this._slimCollapsed && this.options.slim && this.options.expandable) {
        this.toggleSlim();
      } else if (!inverseDirecion) {
        if (this._slimCollapsed || !this.options.slim || !this.options.expandable) {
          if (this.toggler && (0, _index.isVisible)(this.toggler)) {
            this.toggle();
          }
        } else {
          this.toggleSlim();
        }
      }
    }
  }, {
    key: "_isActive",
    value: function _isActive(link, reference) {
      if (reference) {
        return reference === link;
      }

      if (link.attributes.href) {
        return new URL(link, window.location.href).href === window.location.href;
      }

      return false;
    }
  }, {
    key: "_isAllCollapsed",
    value: function _isAllCollapsed() {
      return _selectorEngine["default"].find(SELECTOR_COLLAPSE, this._element).filter(function (el) {
        return (0, _index.isVisible)(el);
      }).length === 0;
    }
  }, {
    key: "_setup",
    value: function _setup() {
      // Touch events
      this._setupTouch(); // Focus trap


      if (this.options.focusTrap) {
        this._setupFocusTrap();
      } // Backdrop


      if (this.options.backdrop) {
        this._setupBackdrop();

        if (!this.options.hidden && this.options.mode === 'over') {
          this._appendBackdrop();
        }
      } // Collapse


      this._setupCollapse(); // Slim


      if (this.options.slim) {
        this._setupSlim();
      } // Initial position


      this._setupInitialStyling(); // Perfect Scrollbar


      this._setupScrolling(); // Content


      if (this.options.content) {
        this._setupContent();
      } // Active link


      this._setupActiveState(); // Ripple


      this._setupRippleEffect(); // Shown on init


      if (!this.options.hidden) {
        this._updateOffsets(true, true);
      }
    }
  }, {
    key: "_setupActiveState",
    value: function _setupActiveState() {
      var _this3 = this;

      this._setActiveElements();

      this.links.forEach(function (link) {
        _eventHandler["default"].on(link, 'click', function () {
          return _this3._setActiveElements(link);
        });

        _eventHandler["default"].on(link, 'keydown', function (e) {
          if (e.keyCode === _keycodes.ENTER) {
            _this3._setActiveElements(link);
          }
        });
      });

      _eventHandler["default"].on(window, 'hashchange', this.hashHandler);
    }
  }, {
    key: "_setupCollapse",
    value: function _setupCollapse() {
      var _this4 = this;

      this.navigation.forEach(function (menu, menuIndex) {
        var categories = _selectorEngine["default"].find(SELECTOR_COLLAPSE, menu);

        categories.forEach(function (list, index) {
          return _this4._setupCollapseList({
            list: list,
            index: index,
            menu: menu,
            menuIndex: menuIndex
          });
        });
      });
    }
  }, {
    key: "_generateCollpaseID",
    value: function _generateCollpaseID(index, menuIndex) {
      return "sidenav-collapse-".concat(this._ID, "-").concat(menuIndex, "-").concat(index);
    }
  }, {
    key: "_setupCollapseList",
    value: function _setupCollapseList(_ref2) {
      var _this5 = this;

      var list = _ref2.list,
          index = _ref2.index,
          menu = _ref2.menu,
          menuIndex = _ref2.menuIndex;

      var ID = this._generateCollpaseID(index, menuIndex);

      list.classList.add('collapse');
      list.setAttribute('id', ID);

      var _SelectorEngine$prev = _selectorEngine["default"].prev(list, SELECTOR_LINK),
          _SelectorEngine$prev2 = _slicedToArray(_SelectorEngine$prev, 1),
          toggler = _SelectorEngine$prev2[0];

      _manipulator["default"].setDataAttribute(toggler, 'toggle', 'collapse');

      toggler.setAttribute('href', "#".concat(ID));
      toggler.setAttribute('role', 'button');
      var instance = _collapse["default"].getInstance(list) || new _collapse["default"](list, {
        toggle: false,
        parent: this.options.accordion ? menu : list
      }); // Arrow

      this._appendArrow(toggler); // Event listeners


      _eventHandler["default"].on(toggler, 'click', function (e) {
        return _this5._toggleCategory(e, instance, list);
      });

      _eventHandler["default"].on(list, 'show.bs.collapse', function () {
        return _this5._rotateArrow(toggler, 180);
      });

      _eventHandler["default"].on(list, 'hide.bs.collapse', function () {
        return _this5._rotateArrow(toggler, 0);
      });

      _eventHandler["default"].on(list, 'shown.bs.collapse', function () {
        if (_this5.options.mode === 'over' && _this5._focusTrap) {
          _this5._focusTrap.update();
        }
      });

      _eventHandler["default"].on(list, 'hidden.bs.collapse', function () {
        if (_this5._tempSlim && _this5._isAllCollapsed()) {
          _this5._setSlim(true);

          _this5._tempSlim = false;
        }

        if (_this5.options.mode === 'over' && _this5._focusTrap) {
          _this5._focusTrap.update();
        }
      });
    }
  }, {
    key: "_setupContent",
    value: function _setupContent() {
      this._content = _selectorEngine["default"].find(this.options.content);
      this._initialContentStyle = this._content.map(function (el) {
        var _window$getComputedSt = window.getComputedStyle(el),
            paddingLeft = _window$getComputedSt.paddingLeft,
            paddingRight = _window$getComputedSt.paddingRight,
            marginLeft = _window$getComputedSt.marginLeft,
            marginRight = _window$getComputedSt.marginRight,
            transition = _window$getComputedSt.transition;

        return {
          paddingLeft: paddingLeft,
          paddingRight: paddingRight,
          marginLeft: marginLeft,
          marginRight: marginRight,
          transition: transition
        };
      });
    }
  }, {
    key: "_setupFocusTrap",
    value: function _setupFocusTrap() {
      this._focusTrap = new _focusTrap["default"](this._element, {
        event: 'keydown',
        condition: function condition(e) {
          return e.keyCode === _keycodes.TAB;
        },
        onlyVisible: true
      });
    }
  }, {
    key: "_setupInitialStyling",
    value: function _setupInitialStyling() {
      this._setColor();

      _manipulator["default"].style(this._element, this.sidenavStyle);
    }
  }, {
    key: "_setupScrolling",
    value: function _setupScrolling() {
      var container = this._element;

      if (this.options.scrollContainer) {
        container = _selectorEngine["default"].findOne(this.options.scrollContainer, this._element);
        var siblings = (0, _index.array)(container.parentNode.children).filter(function (el) {
          return el !== container;
        });
        var siblingsHeight = siblings.reduce(function (a, b) {
          return a + b.clientHeight;
        }, 0);

        _manipulator["default"].style(container, {
          maxHeight: "calc(100% - ".concat(siblingsHeight, "px)"),
          position: 'relative'
        });
      }

      this._perfectScrollbar = new _perfectScrollbar["default"](container, {
        suppressScrollX: true
      });
    }
  }, {
    key: "_setupSlim",
    value: function _setupSlim() {
      var _this6 = this;

      this._slimCollapsed = this.options.slimCollapsed;

      this._toggleSlimDisplay(this._slimCollapsed);

      if (this.options.expandOnHover) {
        this._element.addEventListener('mouseenter', function () {
          if (_this6._slimCollapsed) {
            _this6._setSlim(false);
          }
        });

        this._element.addEventListener('mouseleave', function () {
          if (!_this6._slimCollapsed) {
            _this6._setSlim(true);
          }
        });
      }
    }
  }, {
    key: "_setupRippleEffect",
    value: function _setupRippleEffect() {
      var _this7 = this;

      this.links.forEach(function (link) {
        var wave = _ripple["default"].getInstance(link);

        if (wave && wave._options.color !== _this7.options.color) {
          wave.dispose();
        } else if (wave) {
          return;
        }

        wave = new _ripple["default"](link, {
          rippleColor: _this7.options.color
        });
      });
    }
  }, {
    key: "_setupTouch",
    value: function _setupTouch() {
      var _this8 = this;

      this._touch = new _touch["default"](this._element, 'swipe', {
        threshold: 20
      });

      this._touch.init();

      _eventHandler["default"].on(this._element, 'swipeleft', function (e) {
        return _this8._handleSwipe(e, _this8.options.right);
      });

      _eventHandler["default"].on(this._element, 'swiperight', function (e) {
        return _this8._handleSwipe(e, !_this8.options.right);
      });
    }
  }, {
    key: "_setActive",
    value: function _setActive(link, reference) {
      // Link
      _manipulator["default"].addClass(link, 'active');

      if (this._activeNode) {
        this._activeNode.classList.remove('active');
      }

      this._activeNode = link; // Collapse

      var _SelectorEngine$paren = _selectorEngine["default"].parents(this._activeNode, SELECTOR_COLLAPSE),
          _SelectorEngine$paren2 = _slicedToArray(_SelectorEngine$paren, 1),
          collapse = _SelectorEngine$paren2[0];

      if (!collapse) {
        this._setActiveCategory();

        return;
      } // Category


      var _SelectorEngine$prev3 = _selectorEngine["default"].prev(collapse, SELECTOR_LINK),
          _SelectorEngine$prev4 = _slicedToArray(_SelectorEngine$prev3, 1),
          category = _SelectorEngine$prev4[0];

      this._setActiveCategory(category); // Expand active collapse


      if (!reference && !this._slimCollapsed) {
        _collapse["default"].getInstance(collapse).show();
      }
    }
  }, {
    key: "_setActiveCategory",
    value: function _setActiveCategory(el) {
      this.navigation.forEach(function (menu) {
        var categories = _selectorEngine["default"].find(SELECTOR_COLLAPSE, menu);

        categories.forEach(function (collapse) {
          var _SelectorEngine$prev5 = _selectorEngine["default"].prev(collapse, SELECTOR_LINK),
              _SelectorEngine$prev6 = _slicedToArray(_SelectorEngine$prev5, 1),
              collapseToggler = _SelectorEngine$prev6[0];

          if (collapseToggler !== el) {
            collapseToggler.classList.remove('active');
          } else {
            _manipulator["default"].addClass(collapseToggler, 'active');
          }
        });
      });
    }
  }, {
    key: "_setActiveElements",
    value: function _setActiveElements(reference) {
      var _this9 = this;

      this.navigation.forEach(function (menu) {
        var links = _selectorEngine["default"].find(SELECTOR_LINK, menu);

        links.filter(function (link) {
          return _selectorEngine["default"].next(link, SELECTOR_COLLAPSE).length === 0;
        }).forEach(function (link) {
          if (_this9._isActive(link, reference) && link !== _this9._activeNode) {
            _this9._setActive(link, reference);
          }
        });
      });
    }
  }, {
    key: "_setColor",
    value: function _setColor() {
      var _this10 = this;

      var colors = ['primary', 'secondary', 'success', 'info', 'warning', 'danger', 'light', 'dark'];
      var optionColor = this.options.color;
      var color = colors.includes(optionColor) ? optionColor : 'primary';
      colors.forEach(function (color) {
        _this10._element.classList.remove("sidenav-".concat(color));
      });

      _manipulator["default"].addClass(this._element, "sidenav-".concat(color));
    }
  }, {
    key: "_setContentOffsets",
    value: function _setContentOffsets(show, offsets, initial) {
      var _this11 = this;

      this._content.forEach(function (el, i) {
        var padding = _this11._getOffsetValue(show, {
          index: i,
          property: 'padding',
          offsets: offsets
        });

        var margin = _this11._getOffsetValue(show, {
          index: i,
          property: 'margin',
          offsets: offsets
        });

        var style = {};

        if (!initial) {
          style.transition = "all ".concat(_this11.transitionDuration, " linear");
        }

        style[offsets.padding.property] = "".concat(padding, "px");
        style[offsets.margin.property] = "".concat(margin, "px");

        _manipulator["default"].style(el, style);

        if (!show) {
          return;
        }

        if (initial) {
          _manipulator["default"].style(el, {
            transition: _this11._initialContentStyle[i].transition
          });

          return;
        }

        _eventHandler["default"].on(el, 'transitionend', function () {
          _manipulator["default"].style(el, {
            transition: _this11._initialContentStyle[i].transition
          });
        });
      });
    }
  }, {
    key: "_setMode",
    value: function _setMode(mode) {
      if (this.options.mode === mode) {
        return;
      }

      this._options.mode = mode;

      this._update(this.isVisible);
    }
  }, {
    key: "_setSlim",
    value: function _setSlim(value) {
      var events = value ? ['collapse', 'collapsed'] : ['expand', 'expanded'];

      this._triggerEvents.apply(this, events);

      if (value) {
        this._collapseItems();
      }

      this._slimCollapsed = value;

      this._toggleSlimDisplay(value);

      _manipulator["default"].style(this._element, {
        width: "".concat(this.width, "px")
      });

      this._updateOffsets(this.isVisible);
    }
  }, {
    key: "_setTabindex",
    value: function _setTabindex(value) {
      this.links.forEach(function (link) {
        link.tabIndex = value ? 1 : -1;
      });
    }
  }, {
    key: "_setVisibility",
    value: function _setVisibility(show) {
      var events = show ? ['show', 'shown'] : ['hide', 'hidden'];

      this._triggerEvents.apply(this, events);
    }
  }, {
    key: "_rotateArrow",
    value: function _rotateArrow(toggler, angle) {
      var _SelectorEngine$child = _selectorEngine["default"].children(toggler, ".".concat(ARROW_CLASS)),
          _SelectorEngine$child2 = _slicedToArray(_SelectorEngine$child, 1),
          arrow = _SelectorEngine$child2[0];

      if (!arrow) {
        return;
      }

      _manipulator["default"].style(arrow, {
        transform: "rotate(".concat(angle, "deg)")
      });
    }
  }, {
    key: "_toggleBackdrop",
    value: function _toggleBackdrop(value) {
      var _this12 = this;

      return regeneratorRuntime.async(function _toggleBackdrop$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(value && this.options.mode === 'over')) {
                _context.next = 4;
                break;
              }

              this._appendBackdrop();

              _context.next = 7;
              break;

            case 4:
              _manipulator["default"].style(this._backdrop, {
                opacity: 0
              });

              _context.next = 7;
              return regeneratorRuntime.awrap(setTimeout(function () {
                _this12._removeBackdrop();
              }, this.options.transitionDuration));

            case 7:
            case "end":
              return _context.stop();
          }
        }
      }, null, this);
    }
  }, {
    key: "_removeBackdrop",
    value: function _removeBackdrop() {
      if (this._backdrop.parentNode === this.container) {
        this.container.removeChild(this._backdrop);
      }
    }
  }, {
    key: "_appendBackdrop",
    value: function _appendBackdrop() {
      var _this13 = this;

      this.container.appendChild(this._backdrop);
      setTimeout(function () {
        return _manipulator["default"].style(_this13._backdrop, {
          opacity: 1
        });
      }, 0);
    }
  }, {
    key: "_toggleCategory",
    value: function _toggleCategory(e, instance) {
      e.preventDefault();
      instance.toggle();

      if (this._slimCollapsed && this.options.expandable) {
        this._tempSlim = true;

        this._setSlim(false);
      }
    }
  }, {
    key: "_toggleSlimDisplay",
    value: function _toggleSlimDisplay(slim) {
      var _this14 = this;

      var slimCollapsedElements = _selectorEngine["default"].find(SELECTOR_SHOW_SLIM, this._element);

      var fullWidthElements = _selectorEngine["default"].find(SELECTOR_HIDE_SLIM, this._element);

      var toggleElements = function toggleElements() {
        slimCollapsedElements.forEach(function (el) {
          _manipulator["default"].style(el, {
            display: _this14._slimCollapsed ? 'unset' : 'none'
          });
        });
        fullWidthElements.forEach(function (el) {
          _manipulator["default"].style(el, {
            display: _this14._slimCollapsed ? 'none' : 'unset'
          });
        });
      };

      if (slim) {
        setTimeout(function () {
          return toggleElements(true);
        }, this.options.transitionDuration);
      } else {
        toggleElements();
      }
    }
  }, {
    key: "_triggerEvents",
    value: function _triggerEvents(startEvent, completeEvent) {
      var _this15 = this;

      return regeneratorRuntime.async(function _triggerEvents$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _eventHandler["default"].trigger(this._element, "".concat(startEvent, ".mdb.sidenav"));

              if (!completeEvent) {
                _context2.next = 4;
                break;
              }

              _context2.next = 4;
              return regeneratorRuntime.awrap(setTimeout(function () {
                _eventHandler["default"].trigger(_this15._element, "".concat(completeEvent, ".mdb.sidenav"));
              }, this.options.transitionDuration + 5));

            case 4:
            case "end":
              return _context2.stop();
          }
        }
      }, null, this);
    }
  }, {
    key: "_update",
    value: function _update(show) {
      if (this.toggler) {
        this._updateTogglerAria(show);
      }

      this._updateDisplay(show);

      if (this.options.backdrop) {
        this._toggleBackdrop(show);
      }

      this._updateOffsets(show);

      if (show && this.options.closeOnEsc && this.options.mode !== 'side') {
        _eventHandler["default"].on(window, 'keydown', this.escHandler);
      }

      if (this.options.focusTrap) {
        this._updateFocus(show);
      }
    }
  }, {
    key: "_updateDisplay",
    value: function _updateDisplay(value) {
      var translation = value ? 0 : this.translation;

      _manipulator["default"].style(this._element, {
        transform: "translateX(".concat(translation, "%)")
      });
    }
  }, {
    key: "_updateFocus",
    value: function _updateFocus(show) {
      this._setTabindex(show);

      if (this.options.mode === 'over' && this.options.focusTrap) {
        if (show) {
          this._focusTrap.trap();

          return;
        }

        this._focusTrap.disable();

        if (this.toggler) {
          this.toggler.focus();
        }
      }

      this._focusTrap.disable();
    }
  }, {
    key: "_updateOffsets",
    value: function _updateOffsets(show) {
      var initial = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      var _ref3 = this.options.right ? ['right', 'left'] : ['left', 'right'],
          _ref4 = _slicedToArray(_ref3, 2),
          paddingPosition = _ref4[0],
          marginPosition = _ref4[1];

      var padding = {
        property: this._getProperty('padding', paddingPosition),
        value: this.options.mode === 'over' ? 0 : this.width
      };
      var margin = {
        property: this._getProperty('margin', marginPosition),
        value: this.options.mode === 'push' ? -1 * this.width : 0
      };

      _eventHandler["default"].trigger(this._element, 'update.mdb.sidenav', {
        margin: margin,
        padding: padding
      });

      if (!this._content) {
        return;
      }

      this._setContentOffsets(show, {
        padding: padding,
        margin: margin
      }, initial);
    }
  }, {
    key: "_updateTogglerAria",
    value: function _updateTogglerAria(value) {
      this.toggler.setAttribute('aria-expanded', value);
    } // Static

  }, {
    key: "container",
    get: function get() {
      if (this.options.position === 'fixed') {
        return _selectorEngine["default"].findOne('body');
      }

      var findContainer = function findContainer(el) {
        if (!el.parentNode || el.parentNode === document) {
          return el;
        }

        if (el.parentNode.style.position === 'relative') {
          return el.parentNode;
        }

        return findContainer(el.parentNode);
      };

      return findContainer(this._element);
    }
  }, {
    key: "isVisible",
    get: function get() {
      var containerStart = 0;
      var containerEnd = window.innerWidth;

      if (this.options.position !== 'fixed') {
        var boundry = this.container.getBoundingClientRect();
        containerStart = boundry.x;
        containerEnd = boundry.x + boundry.width;
      }

      var _this$_element$getBou = this._element.getBoundingClientRect(),
          x = _this$_element$getBou.x;

      if (this.options.right) {
        return Math.abs(x - containerEnd) > 10;
      }

      return Math.abs(x - containerStart) < 10;
    }
  }, {
    key: "links",
    get: function get() {
      return _selectorEngine["default"].find(SELECTOR_LINK, this._element);
    }
  }, {
    key: "navigation",
    get: function get() {
      return _selectorEngine["default"].find(SELECTOR_NAVIGATION, this._element);
    }
  }, {
    key: "options",
    get: function get() {
      var config = _objectSpread({}, DEFAULT_OPTIONS, {}, _manipulator["default"].getDataAttributes(this._element), {}, this._options);

      (0, _index.typeCheckConfig)(NAME, config, OPTIONS_TYPE);
      return config;
    }
  }, {
    key: "sidenavStyle",
    get: function get() {
      return {
        width: "".concat(this.width, "px"),
        height: this.options.position === 'fixed' ? '100vh' : '100%',
        position: this.options.position,
        transition: "all ".concat(this.transitionDuration, " linear")
      };
    }
  }, {
    key: "toggler",
    get: function get() {
      var _this16 = this;

      var toggleElement = _selectorEngine["default"].find(SELECTOR_TOGGLE).find(function (toggler) {
        var target = _manipulator["default"].getDataAttribute(toggler, 'target');

        return _selectorEngine["default"].findOne(target) === _this16._element;
      });

      return toggleElement;
    }
  }, {
    key: "transitionDuration",
    get: function get() {
      return "".concat(this.options.transitionDuration / 1000, "s");
    }
  }, {
    key: "translation",
    get: function get() {
      return this.options.right ? TRANSLATION_RIGHT : TRANSLATION_LEFT;
    }
  }, {
    key: "width",
    get: function get() {
      return this._slimCollapsed ? this.options.slimWidth : this.options.width;
    }
  }], [{
    key: "toggleSidenav",
    value: function toggleSidenav() {
      return function (e) {
        var toggler = _selectorEngine["default"].closest(e.target, SELECTOR_TOGGLE);

        var elementSelector = _manipulator["default"].getDataAttributes(toggler).target;

        _selectorEngine["default"].find(elementSelector).forEach(function (element) {
          var instance = Sidenav.getInstance(element) || new Sidenav(element);
          instance.toggle();
        });
      };
    }
  }, {
    key: "jQueryInterface",
    value: function jQueryInterface(config, options) {
      return this.each(function () {
        var data = _data["default"].getData(this, DATA_KEY);

        var _config = _typeof(config) === 'object' && config;

        if (!data && /dispose/.test(config)) {
          return;
        }

        if (!data) {
          data = new Sidenav(this, _config);
        }

        if (typeof config === 'string') {
          if (typeof data[config] === 'undefined') {
            throw new TypeError("No method named \"".concat(config, "\""));
          }

          data[config](options);
        }
      });
    }
  }, {
    key: "getInstance",
    value: function getInstance(element) {
      return _data["default"].getData(element, DATA_KEY);
    }
  }, {
    key: "NAME",
    get: function get() {
      return NAME;
    }
  }]);

  return Sidenav;
}();
/**
 * ------------------------------------------------------------------------
 * Data Api implementation - auto initialization
 * ------------------------------------------------------------------------
 */


_eventHandler["default"].on(document, 'click', SELECTOR_TOGGLE, Sidenav.toggleSidenav());

_selectorEngine["default"].find(SELECTOR_SIDENAV).forEach(function (sidenav) {
  var instance = Sidenav.getInstance(sidenav);

  if (!instance) {
    instance = new Sidenav(sidenav);
  }

  return instance;
});
/**
 * ------------------------------------------------------------------------
 * jQuery
 * ------------------------------------------------------------------------
 * add .sidenav to jQuery only if jQuery is present
 */


var $ = (0, _index.getjQuery)();

if ($) {
  var JQUERY_NO_CONFLICT = $.fn[NAME];
  $.fn[NAME] = Sidenav.jQueryInterface;
  $.fn[NAME].Constructor = Sidenav;

  $.fn[NAME].noConflict = function () {
    $.fn[NAME] = JQUERY_NO_CONFLICT;
    return Sidenav.jQueryInterface;
  };
}

var _default = Sidenav;
exports["default"] = _default;