"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _index = require("../mdb/util/index");

var _data = _interopRequireDefault(require("../mdb/dom/data"));

var _eventHandler = _interopRequireDefault(require("../bootstrap/src/dom/event-handler"));

var _manipulator = _interopRequireDefault(require("../mdb/dom/manipulator"));

var _selectorEngine = _interopRequireDefault(require("../mdb/dom/selector-engine"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var NAME = 'smoothScroll';
var DATA_KEY = "mdb.".concat(NAME);
var EVENT_KEY = ".".concat(DATA_KEY);
var SELECTOR_COMPONENT = 'a[data-smooth-scroll="smooth-scroll"]';
var DefaultType = {
  container: 'string',
  offset: 'number',
  easing: 'string',
  duration: 'number'
};
var Default = {
  container: 'body',
  offset: 0,
  easing: 'linear',
  duration: 500
};
var EVENT_SCROLL_START = "scrollStart".concat(EVENT_KEY);
var EVENT_SCROLL_END = "scrollEnd".concat(EVENT_KEY);
var EVENT_SCROLL_CANCEL = "scrollCancel".concat(EVENT_KEY);

var SmoothScroll =
/*#__PURE__*/
function () {
  function SmoothScroll(element) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, SmoothScroll);

    this._element = element;
    this._options = this._getConfig(options);
    this._href = this._element.getAttribute('href');
    this.isCancel = false;

    if (this._element) {
      _data["default"].setData(element, DATA_KEY, this);

      this._setup();
    }
  } // getters


  _createClass(SmoothScroll, [{
    key: "dispose",
    // public
    value: function dispose() {
      _eventHandler["default"].off(this._element, 'click', this._handleClick);

      _data["default"].removeData(this._element, DATA_KEY);

      this._element = null;
    }
  }, {
    key: "cancelScroll",
    value: function cancelScroll() {
      this.isCancel = true;
    } // private

  }, {
    key: "_getConfig",
    value: function _getConfig(options) {
      var config = _objectSpread({}, Default, {}, _manipulator["default"].getDataAttributes(this._element), {}, options);

      (0, _index.typeCheckConfig)(NAME, config, DefaultType);
      return config;
    }
  }, {
    key: "_inViewport",
    value: function _inViewport() {
      if (this.isWindow) {
        return true;
      }

      var rect = this.containerToScroll.getBoundingClientRect();
      return rect.top >= 0 && rect.bottom <= (window.innerHeight || document.documentElement.clientHeight);
    }
  }, {
    key: "_setup",
    value: function _setup() {
      var linkExist = typeof this._href !== 'undefined';

      var isHashInLink = this._href.includes('#');

      if (linkExist && isHashInLink && this.elFromHrefExist) {
        this._scrollOnClickEvent();

        this._preventNativeScroll();
      }
    }
  }, {
    key: "_scrollOnClickEvent",
    value: function _scrollOnClickEvent() {
      var _this = this;

      _eventHandler["default"].on(this._element, 'click', function (e) {
        _this._handleClick(e);
      });
    }
  }, {
    key: "_handleClick",
    value: function _handleClick(e) {
      var _this2 = this;

      e.preventDefault();
      this.isCancel = false;

      _eventHandler["default"].trigger(this._element, EVENT_SCROLL_START);

      var scrollingContainer = this.containerToScroll;
      var positionFrom = this.containerToScroll.scrollTop;
      var positionTo = this.offsetFromEl;
      var scrollProgress = 0;
      var speed = 1 / this._options.duration; // Thanks to this value time of scrolling is almost equal to value which user set

      var step = 4.25;
      var easing = this.easingFunction;

      if (!this._inViewport()) {
        this._scrollOnNextTick(document.documentElement, document.documentElement.scrollTop, this.containerToScroll.offsetTop, scrollProgress, speed, step, easing); // Function which is waiting for ends scrolling to viewport


        setTimeout(function () {
          _this2._scrollOnNextTick(scrollingContainer, positionFrom, positionTo, scrollProgress, speed, step, easing);

          _this2.isCancel = false;
        }, this._options.duration);
      } else {
        this._scrollOnNextTick(scrollingContainer, positionFrom, positionTo, scrollProgress, speed, step, easing);
      }
    }
  }, {
    key: "_scrollOnNextTick",
    value: function _scrollOnNextTick(scrollingContainer, positionFrom, positionTo, scrollProgress, speed, step, easing) {
      var _this3 = this;

      var progressWrongValue = scrollProgress < 0;
      var scrollEnd = scrollProgress > 1;
      var speedWrongValue = speed <= 0;

      if (progressWrongValue || scrollEnd || speedWrongValue || this.isCancel) {
        if (this.isCancel) {
          if (this.isInViewport) {
            this.isCancel = false;
          }

          _eventHandler["default"].trigger(this._element, EVENT_SCROLL_CANCEL);

          return;
        }

        _eventHandler["default"].trigger(this._element, EVENT_SCROLL_END);

        scrollingContainer.scrollTop = positionTo;
        return;
      }

      scrollingContainer.scrollTo({
        top: positionFrom - (positionFrom - positionTo) * easing(scrollProgress)
      });
      scrollProgress += speed * step; // After one tick ends next tick is able to run, otherwise scrolling aren't goint to be animated

      setTimeout(function () {
        _this3._scrollOnNextTick(scrollingContainer, positionFrom, positionTo, scrollProgress, speed, step, easing);
      });
    }
  }, {
    key: "_preventDefault",
    value: function _preventDefault(e) {
      e.preventDefault();
    }
  }, {
    key: "_preventNativeScroll",
    value: function _preventNativeScroll() {
      var supportsPassive = false;

      try {
        window.addEventListener('test', null, Object.defineProperty({}, 'passive', {
          get: function get() {
            return supportsPassive = true;
          }
        }));
      } catch (e) {
        this._scrollError = e;
      }

      var wheelOpt = supportsPassive ? {
        passive: false
      } : false;
      var wheelEvent = 'onwheel' in (0, _index.element)('div') ? 'wheel' : 'mousewheel';

      if (this.isWindow) {
        this._deleteScrollOnStart(wheelOpt, wheelEvent);

        this._addScrollOnEnd(wheelOpt, wheelEvent);

        this._addScrollOnCancel(wheelOpt, wheelEvent);
      }
    }
  }, {
    key: "_deleteScrollOnStart",
    value: function _deleteScrollOnStart(wheelOpt, wheelEvent) {
      var _this4 = this;

      _eventHandler["default"].on(this._element, 'scrollStart.mdb.smoothScroll', function () {
        window.addEventListener(wheelEvent, _this4._preventDefault, wheelOpt);
        window.addEventListener('touchmove', _this4._preventDefault, wheelOpt);
      });
    }
  }, {
    key: "_addScrollOnEnd",
    value: function _addScrollOnEnd(wheelOpt, wheelEvent) {
      var _this5 = this;

      _eventHandler["default"].on(this._element, 'scrollEnd.mdb.smoothScroll', function () {
        window.removeEventListener(wheelEvent, _this5._preventDefault, wheelOpt);
        window.removeEventListener('touchmove', _this5._preventDefault, wheelOpt);
      });
    }
  }, {
    key: "_addScrollOnCancel",
    value: function _addScrollOnCancel(wheelOpt, wheelEvent) {
      var _this6 = this;

      _eventHandler["default"].on(this._element, 'scrollCancel.mdb.smoothScroll', function () {
        window.removeEventListener(wheelEvent, _this6._preventDefault, wheelOpt);
        window.removeEventListener('touchmove', _this6._preventDefault, wheelOpt);
      });
    } // Motions
    // Linear

  }, {
    key: "_motionLinear",
    value: function _motionLinear(t) {
      return t;
    } // Ease-In

  }, {
    key: "_motionEaseInQuad",
    value: function _motionEaseInQuad(t) {
      return t * t;
    }
  }, {
    key: "_motionEaseInCubic",
    value: function _motionEaseInCubic(t) {
      return t * t * t;
    }
  }, {
    key: "_motionEaseInQuart",
    value: function _motionEaseInQuart(t) {
      return t * t * t * t;
    }
  }, {
    key: "_motionEaseInQuint",
    value: function _motionEaseInQuint(t) {
      return t * t * t * t * t;
    } // Ease-In-Out

  }, {
    key: "_motionEaseInOutQuad",
    value: function _motionEaseInOutQuad(t) {
      return t < 0.5 ? 2 * t * t : -1 + (4 - 2 * t) * t;
    }
  }, {
    key: "_motionEaseInOutCubic",
    value: function _motionEaseInOutCubic(t) {
      t /= 0.5;
      if (t < 1) return t * t * t / 2;
      t -= 2;
      return (t * t * t + 2) / 2;
    }
  }, {
    key: "_motionEaseInOutQuart",
    value: function _motionEaseInOutQuart(t) {
      t /= 0.5;
      if (t < 1) return 0.5 * t * t * t * t;
      t -= 2;
      return -(t * t * t * t - 2) / 2;
    }
  }, {
    key: "_motionEaseInOutQuint",
    value: function _motionEaseInOutQuint(t) {
      t /= 0.5;
      if (t < 1) return t * t * t * t * t / 2;
      t -= 2;
      return (t * t * t * t * t + 2) / 2;
    } // Ease-Out

  }, {
    key: "_motionEaseOutQuad",
    value: function _motionEaseOutQuad(t) {
      return -t * (t - 2);
    }
  }, {
    key: "_motionEaseOutCubic",
    value: function _motionEaseOutCubic(t) {
      t--;
      return t * t * t + 1;
    }
  }, {
    key: "_motionEaseOutQuart",
    value: function _motionEaseOutQuart(t) {
      t--;
      return -(t * t * t * t - 1);
    }
  }, {
    key: "_motionEaseOutQuint",
    value: function _motionEaseOutQuint(t) {
      t--;
      return t * t * t * t * t + 1;
    } // static

  }, {
    key: "isWindow",
    get: function get() {
      return this._options.container === 'body';
    }
  }, {
    key: "containerToScroll",
    get: function get() {
      return this.isWindow ? document.documentElement : _selectorEngine["default"].findOne(this._options.container, document.documentElement);
    }
  }, {
    key: "elFromHrefExist",
    get: function get() {
      return !!_selectorEngine["default"].findOne(this._href, this.containerToScroll);
    }
  }, {
    key: "offsetFromEl",
    get: function get() {
      var heightFromTop = this.containerToScroll.scrollTop;

      var el = _selectorEngine["default"].findOne(this._href, this.containerToScroll);

      if (this.isWindow) {
        return _manipulator["default"].offset(el).top - this._options.offset + heightFromTop;
      }

      var elY = el.getBoundingClientRect().y;
      var containerY = this.containerToScroll.getBoundingClientRect().y;
      var offsetFromContainer = elY - containerY;
      return offsetFromContainer - this._options.offset + heightFromTop;
    }
  }, {
    key: "easingFunction",
    get: function get() {
      var easing = this._options.easing;
      var motionName = "_motion".concat(easing[0].toUpperCase()).concat(easing.slice(1));
      return this[motionName] ? this[motionName] : this._motionLinear;
    }
  }], [{
    key: "getInstance",
    value: function getInstance(element) {
      return _data["default"].getData(element, DATA_KEY);
    }
  }, {
    key: "jQueryInterface",
    value: function jQueryInterface(config) {
      return this.each(function () {
        var data = _data["default"].getData(this, DATA_KEY);

        var _config = _typeof(config) === 'object' && config;

        if (!data) {
          data = new SmoothScroll(this, _config);
        }

        if (typeof config === 'string') {
          if (typeof data[config] === 'undefined') {
            throw new TypeError("No method named \"".concat(config, "\""));
          }

          data[config](this);
        }
      });
    }
  }, {
    key: "NAME",
    get: function get() {
      return NAME;
    }
  }]);

  return SmoothScroll;
}();
/**
 * ------------------------------------------------------------------------
 * Data Api implementation - auto initialization
 * ------------------------------------------------------------------------
 */


_selectorEngine["default"].find(SELECTOR_COMPONENT).forEach(function (el) {
  var instance = SmoothScroll.getInstance(el);

  if (!instance) {
    instance = new SmoothScroll(el);
  }

  return instance;
});
/**
 * ------------------------------------------------------------------------
 * jQuery
 * ------------------------------------------------------------------------
 * */


var $ = (0, _index.getjQuery)();

if ($) {
  var JQUERY_NO_CONFLICT = $.fn[NAME];
  $.fn[NAME] = SmoothScroll.jQueryInterface;
  $.fn[NAME].Constructor = SmoothScroll;

  $.fn[NAME].noConflict = function () {
    $.fn[NAME] = JQUERY_NO_CONFLICT;
    return SmoothScroll.jQueryInterface;
  };
}

var _default = SmoothScroll;
exports["default"] = _default;