"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _index = require("../mdb/util/index");

var _data = _interopRequireDefault(require("../mdb/dom/data"));

var _eventHandler = _interopRequireDefault(require("../bootstrap/src/dom/event-handler"));

var _manipulator = _interopRequireDefault(require("../mdb/dom/manipulator"));

var _selectorEngine = _interopRequireDefault(require("../mdb/dom/selector-engine"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _toArray(arr) { return _arrayWithHoles(arr) || _iterableToArray(arr) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * ------------------------------------------------------------------------
 * Constants
 * ------------------------------------------------------------------------
 */
var NAME = 'treeview';
var DATA_KEY = 'mdb.treeview';
var CLASSNAME_TREEVIEW = 'treeview';
var SELECTOR_EXPAND = '[data-toggle="treeview"]';
/**
 * ------------------------------------------------------------------------
 * Class Definition
 * ------------------------------------------------------------------------
 */

var Treeview =
/*#__PURE__*/
function () {
  function Treeview(element, data) {
    _classCallCheck(this, Treeview);

    this._element = element;

    if (this._element) {
      this._data = data ? this._createHTMLNodes(data, element) : this._setData(element);

      _data["default"].setData(element, DATA_KEY, this);

      _manipulator["default"].addClass(this._element, CLASSNAME_TREEVIEW);

      this._constructTreeview(this._data);
    }
  } // Getters


  _createClass(Treeview, [{
    key: "collapse",
    // Public
    value: function collapse() {
      var _SelectorEngine$find = _selectorEngine["default"].find('ul', this._element),
          _SelectorEngine$find2 = _toArray(_SelectorEngine$find),
          innerLists = _SelectorEngine$find2.slice(1);

      innerLists.forEach(function (node) {
        return node.style.display = 'none';
      });
    }
  }, {
    key: "dispose",
    value: function dispose() {
      _data["default"].removeData(this._element, DATA_KEY);

      this._element = null;
    } // Private

  }, {
    key: "_toggleSubmenu",
    value: function _toggleSubmenu(e) {
      e.stopPropagation();
      var li = e.target.nodeName === 'I' ? e.target.parentNode : e.target;

      var _ref = li.nodeName === 'I' ? _selectorEngine["default"].children(li.parentNode, 'ul') : _selectorEngine["default"].children(li, 'ul'),
          _ref2 = _slicedToArray(_ref, 1),
          ul = _ref2[0];

      if (ul) {
        ul.style.display = window.getComputedStyle(ul).display === 'none' ? 'block' : 'none';

        this._toggleIcon(li);
      }
    }
  }, {
    key: "_toggleIcon",
    value: function _toggleIcon(el) {
      var icon1 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'fa-caret-down';
      var icon2 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'fa-caret-up';

      var _SelectorEngine$child = _selectorEngine["default"].children(el, 'i'),
          _SelectorEngine$child2 = _slicedToArray(_SelectorEngine$child, 1),
          i = _SelectorEngine$child2[0];

      if (!i) return;
      var faClasses = [icon1, icon2];

      var _ref3 = i.classList.contains(icon1) ? faClasses : faClasses.reverse(),
          _ref4 = _slicedToArray(_ref3, 2),
          current = _ref4[0],
          next = _ref4[1];

      i.classList.remove(current);
      i.classList.add(next);
    }
  }, {
    key: "_constructTreeview",
    value: function _constructTreeview(data) {
      var _this = this;

      data.forEach(function (el) {
        el.node.addEventListener('click', _this._toggleSubmenu.bind(_this));

        if (el.children && el.children.length > 0) {
          var arrow = (0, _index.element)('i');
          arrow.classList = ['fas fa-caret-down'];
          el.node.appendChild(arrow);

          _this._constructTreeview(el.children);
        }
      });
    }
  }, {
    key: "_setData",
    value: function _setData(el) {
      var _this2 = this;

      var _SelectorEngine$child3 = _selectorEngine["default"].children(el, 'ul'),
          _SelectorEngine$child4 = _slicedToArray(_SelectorEngine$child3, 1),
          list = _SelectorEngine$child4[0];

      if (!list) return [];
      return _selectorEngine["default"].children(list, 'li').map(function (node) {
        var children = _this2._setData(node);

        return {
          name: node.innerText ? node.innerText.split('\n')[0] : '',
          node: node,
          children: children
        };
      });
    }
  }, {
    key: "_createHTMLNodes",
    value: function _createHTMLNodes(data, parent) {
      var _this3 = this;

      var ul = (0, _index.element)('ul');
      return data.map(function (item) {
        var li = (0, _index.element)('li');
        li.innerText = item.name;
        var children = item.children;

        if (children && children.length > 0) {
          children = _this3._createHTMLNodes(item.children, li);
        }

        ul.appendChild(li);
        parent.appendChild(ul);
        return _objectSpread({}, item, {
          children: children,
          node: li
        });
      });
    }
  }], [{
    key: "toggleSubmenu",
    value: function toggleSubmenu(instance) {
      return function (event) {
        instance._toggleSubmenu(event);
      };
    }
  }, {
    key: "jQueryInterface",
    value: function jQueryInterface(options) {
      return this.each(function () {
        var data = _data["default"].getData(this, DATA_KEY);

        if (!data) {
          return new Treeview(this, options);
        }

        return null;
      });
    }
  }, {
    key: "getInstance",
    value: function getInstance(element) {
      return _data["default"].getData(element, DATA_KEY);
    }
  }, {
    key: "NAME",
    get: function get() {
      return NAME;
    }
  }]);

  return Treeview;
}();
/**
 * ------------------------------------------------------------------------
 * Data Api implementation - auto initialization
 * ------------------------------------------------------------------------
 */


_eventHandler["default"].on(document, 'click', SELECTOR_EXPAND, Treeview.toggleSubmenu(new Treeview()));
/**
 * ------------------------------------------------------------------------
 * jQuery
 * ------------------------------------------------------------------------
 * add .treeview to jQuery only if jQuery is present
 */


var $ = (0, _index.getjQuery)();

if ($) {
  var JQUERY_NO_CONFLICT = $.fn[NAME];
  $.fn[NAME] = Treeview.jQueryInterface;
  $.fn[NAME].Constructor = Treeview;

  $.fn[NAME].noConflict = function () {
    $.fn[NAME] = JQUERY_NO_CONFLICT;
    return Treeview.jQueryInterface;
  };
}

var _default = Treeview;
exports["default"] = _default;