"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _index = require("../../mdb/util/index");

var _data = _interopRequireDefault(require("../../mdb/dom/data"));

var _manipulator = _interopRequireDefault(require("../../mdb/dom/manipulator"));

var _selectorEngine = _interopRequireDefault(require("../../mdb/dom/selector-engine"));

var _eventHandler = _interopRequireDefault(require("../../mdb/dom/event-handler"));

var _templates = require("./templates");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var NAME = 'loading';
var CLASS_SPINNER = 'loading-spinner';
var DATA_KEY = 'mdb.loading';
var CLASS_NAME_SHOW = 'show';
var SELECTOR_LOADING = '.loading';
var SELECTOR_LOADING_ICON = '.loading-icon';
var SELECTOR_LOADING_TEXT = '.loading-text';
var SHOW_EVENT = 'show.mdb.loading';
var DefaultType = {
  backdrop: '(null|boolean)',
  backdropColor: 'string',
  backdropOpacity: '(number|string)',
  delay: '(null|number)',
  loader: 'string',
  loadingIcon: 'boolean',
  loadingText: 'boolean',
  scroll: 'boolean'
};
var Default = {
  backdrop: true,
  backdropColor: 'rgba(0, 0, 0)',
  backdropOpacity: 0.4,
  backdropID: '',
  delay: null,
  loader: '',
  parentSelector: null,
  scroll: true,
  loadingText: true,
  loadingIcon: true
};

var Loading =
/*#__PURE__*/
function () {
  function Loading(element) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, Loading);

    this._element = element;
    this._options = this._getConfig(options);

    if (this._element) {
      _data["default"].setData(element, DATA_KEY, this);
    }

    this._backdropElement = null;
    this._parentElement = _selectorEngine["default"].findOne(this._options.parentSelector);
    this._loadingIcon = _selectorEngine["default"].findOne(SELECTOR_LOADING_ICON, this._element);
    this._loadingText = _selectorEngine["default"].findOne(SELECTOR_LOADING_TEXT, this._element);
    this.init();
  } // Getters


  _createClass(Loading, [{
    key: "toggle",
    // Public
    value: function toggle() {
      var isActive = _manipulator["default"].hasClass(this._element, CLASS_NAME_SHOW);

      if (isActive) return;
      this.init();
    }
  }, {
    key: "init",
    value: function init() {
      var _this = this;

      var spinnerCloned = this._loadingIcon.cloneNode(true);

      var loadingCloned = this._loadingText.cloneNode(true);

      this._removeElementsOnStart();

      setTimeout(function () {
        _manipulator["default"].addClass(_this._element, CLASS_SPINNER);

        _this._setBackdrop();

        _this._setLoadingIcon(spinnerCloned);

        _this._setLoadingText(loadingCloned);

        _this._setScrollOption();

        _eventHandler["default"].trigger(_this._element, SHOW_EVENT);
      }, this._options.delay);
    }
  }, {
    key: "dispose",
    value: function dispose() {
      _data["default"].removeData(this._element, DATA_KEY);

      this._backdropElement = null;
      this._element = null;
      this._options = null;
    } // Private

  }, {
    key: "_setBackdrop",
    value: function _setBackdrop() {
      var backdrop = this._options.backdrop;
      if (!backdrop) return;
      this._backdropElement = (0, _templates.getBackdropTemplate)(this._options);

      if (this._parentElement !== null) {
        _manipulator["default"].addClass(this._element, 'position-absolute');

        _manipulator["default"].addClass(this._parentElement, 'position-relative');

        _manipulator["default"].addClass(this._backdropElement, 'position-absolute');

        this._parentElement.appendChild(this._backdropElement);
      } else {
        _manipulator["default"].addClass(this._element, 'position-fixed');

        document.body.appendChild(this._backdropElement);
        document.body.appendChild(this._element);
      }
    }
  }, {
    key: "_setLoadingIcon",
    value: function _setLoadingIcon(spinner) {
      if (!this._options.loadingIcon) {
        spinner.remove();
        return;
      }

      this._element.appendChild(spinner);

      spinner.id = this._options.loader;
    }
  }, {
    key: "_setLoadingText",
    value: function _setLoadingText(text) {
      if (!this._options.loadingText) {
        text.remove();
        return;
      }

      this._element.appendChild(text);
    }
  }, {
    key: "_removeElementsOnStart",
    value: function _removeElementsOnStart() {
      if (this._element === null) return;

      this._loadingIcon.remove();

      this._loadingText.remove();
    }
  }, {
    key: "_setScrollOption",
    value: function _setScrollOption() {
      if (!this._options.scroll) {
        if (this._parentElement === null) {
          document.body.style.overflow = 'hidden';
          return;
        }

        _manipulator["default"].addStyle(this._parentElement, {
          overflow: 'hidden'
        });
      } else {
        if (this._parentElement === null) {
          document.body.style.overflow = '';
          return;
        }

        _manipulator["default"].addStyle(this._parentElement, {
          overflow: ''
        });
      }
    }
  }, {
    key: "_getConfig",
    value: function _getConfig(options) {
      var config = _objectSpread({}, Default, {}, _manipulator["default"].getDataAttributes(this._element), {}, options);

      (0, _index.typeCheckConfig)(NAME, config, DefaultType);
      return config;
    } // Static

  }], [{
    key: "getInstance",
    value: function getInstance(element) {
      return _data["default"].getData(element, DATA_KEY);
    }
  }, {
    key: "jQueryInterface",
    value: function jQueryInterface(config) {
      return this.each(function () {
        var data = _data["default"].getData(this, DATA_KEY);

        var _config = _typeof(config) === 'object' && config;

        if (!data) {
          data = new Loading(this, _config);
        }

        if (typeof config === 'string') {
          if (typeof data[config] === 'undefined') {
            throw new TypeError("No method named \"".concat(config, "\""));
          }

          data[config](this);
        }
      });
    }
  }, {
    key: "NAME",
    get: function get() {
      return NAME;
    }
  }]);

  return Loading;
}();
/**
 * ------------------------------------------------------------------------
 * Data Api implementation - auto initialization
 * ------------------------------------------------------------------------
 */


_selectorEngine["default"].find(SELECTOR_LOADING).forEach(function (loading) {
  var instance = Loading.getInstance(loading);

  if (!instance) {
    instance = new Loading(loading);
  }

  return instance;
});
/**
 * ------------------------------------------------------------------------
 * jQuery
 * ------------------------------------------------------------------------
 */


var $ = (0, _index.getjQuery)();

if ($) {
  var JQUERY_NO_CONFLICT = $.fn[NAME];
  $.fn[NAME] = Loading.jQueryInterface;
  $.fn[NAME].Constructor = Loading;

  $.fn[NAME].noConflict = function () {
    $.fn[NAME] = JQUERY_NO_CONFLICT;
    return Loading.jQueryInterface;
  };
}

var _default = Loading;
exports["default"] = _default;