"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _popper = _interopRequireDefault(require("popper.js"));

var _data = _interopRequireDefault(require("../../mdb/dom/data"));

var _eventHandler = _interopRequireDefault(require("../../mdb/dom/event-handler"));

var _manipulator = _interopRequireDefault(require("../../mdb/dom/manipulator"));

var _selectorEngine = _interopRequireDefault(require("../../mdb/dom/selector-engine"));

var _index = require("../../mdb/util/index");

var _input = _interopRequireDefault(require("../../free/input"));

var _selectOption = _interopRequireDefault(require("./select-option"));

var _selectionModel = _interopRequireDefault(require("./selection-model"));

var _keycodes = require("../../mdb/util/keycodes");

var _util = _interopRequireDefault(require("./util"));

var _templates = require("./templates");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Default = {
  container: 'body',
  clearButton: false,
  disabled: false,
  displayedLabels: 5,
  formWhite: false,
  multiple: false,
  optionsSelectedLabel: 'options selected',
  optionHeight: 38,
  selectAll: true,
  selectAllLabel: 'Select all',
  size: 'default',
  visibleOptions: 5,
  filter: false,
  filterDebounce: 300,
  noResultText: 'No results',
  validation: false,
  validFeedback: 'Valid',
  invalidFeedback: 'Invalid',
  placeholder: ''
};
var DefaultType = {
  container: 'string',
  clearButton: 'boolean',
  disabled: 'boolean',
  displayedLabels: 'number',
  formWhite: 'boolean',
  multiple: 'boolean',
  optionsSelectedLabel: 'string',
  optionHeight: 'number',
  selectAll: 'boolean',
  selectAllLabel: 'string',
  size: 'string',
  visibleOptions: 'number',
  filter: 'boolean',
  filterDebounce: 'number',
  noResultText: 'string',
  validation: 'boolean',
  validFeedback: 'string',
  invalidFeedback: 'string',
  placeholder: ''
};
var NAME = 'select';
var DATA_KEY = 'mdb.select';
var EVENT_KEY = ".".concat(DATA_KEY);
var EVENT_CLOSE = "close".concat(EVENT_KEY);
var EVENT_OPEN = "open".concat(EVENT_KEY);
var EVENT_SELECT = "optionSelect".concat(EVENT_KEY);
var EVENT_DESELECT = "optionDeselect".concat(EVENT_KEY);
var EVENT_VALUE_CHANGE = "valueChange".concat(EVENT_KEY);
var EVENT_CHANGE = 'change';
var SELECTOR_SELECT = '.select';
var SELECTOR_LABEL = '.select-label';
var SELECTOR_INPUT = '.select-input';
var SELECTOR_FILTER_INPUT = '.select-filter-input';
var SELECTOR_DROPDOWN = '.select-dropdown';
var SELECTOR_OPTIONS_WRAPPER = '.select-options-wrapper';
var SELECTOR_OPTIONS_LIST = '.select-options-list';
var SELECTOR_OPTION = '.select-option';
var SELECTOR_CLEAR_BUTTON = '.select-clear-btn';
var SELECTOR_CUSTOM_CONTENT = '.select-custom-content';
var SELECTOR_NO_RESULTS = '.select-no-results';
var SELECTOR_FORM_OUTLINE = '.form-outline';
var CLASS_NAME_INITIALIZED = 'select-initialized';
var CLASS_NAME_OPEN = 'open';
var CLASS_NAME_ACTIVE = 'active';
var CLASS_NAME_FOCUSED = 'focused';
var CLASS_NAME_OPTION_GROUP_LABEL = 'select-option-group-label';
var CLASS_NAME_SELECT_ALL_OPTION = 'select-all-option';
var ANIMATION_TRANSITION_TIME = 200;

var Select =
/*#__PURE__*/
function () {
  function Select(element, config) {
    _classCallCheck(this, Select);

    this._element = element;
    this._config = this._getConfig(config);
    this._optionsToRender = this._getOptionsToRender(element); // optionsToRender may contain option groups and nested options, in this case
    // we need a list of plain options to manage selections and keyboard navigation

    this._plainOptions = this._getPlainOptions(this._optionsToRender);
    this._filteredOptionsList = null;
    this._selectionModel = new _selectionModel["default"](this.multiple);
    this._activeOptionIndex = -1;
    this._activeOption = null;
    this._wrapperId = (0, _index.getUID)('select-wrapper-');
    this._dropdownContainerId = (0, _index.getUID)('select-dropdown-container-');
    this._selectAllId = (0, _index.getUID)('select-all-');
    this._debounceTimeoutId = null;
    this._dropdownHeight = this._config.optionHeight * this._config.visibleOptions;
    this._popper = null;
    this._input = null;
    this._label = _selectorEngine["default"].next(this._element, SELECTOR_LABEL)[0];
    this._customContent = _selectorEngine["default"].next(element, SELECTOR_CUSTOM_CONTENT)[0];
    this._wrapper = null;
    this._inputEl = null;
    this._dropdownContainer = null;
    this._container = null;
    this._selectAllOption = null;

    this._init();

    this._mutationObserver = null;
    this._isOpen = false;

    this._addMutationObserver();

    if (this._element) {
      _data["default"].setData(element, DATA_KEY, this);
    }
  }

  _createClass(Select, [{
    key: "_getConfig",
    value: function _getConfig(config) {
      var dataAttributes = _manipulator["default"].getDataAttributes(this._element);

      config = _objectSpread({}, Default, {}, dataAttributes, {}, config);

      if (this._element.hasAttribute('multiple')) {
        config.multiple = true;
      }

      if (this._element.hasAttribute('disabled')) {
        config.disabled = true;
      }

      (0, _index.typeCheckConfig)(NAME, config, DefaultType);
      return config;
    }
  }, {
    key: "_getOptionsToRender",
    value: function _getOptionsToRender(select) {
      var _this = this;

      var options = [];
      var nodes = select.childNodes;
      nodes.forEach(function (node) {
        if (node.nodeName === 'OPTGROUP') {
          var optionGroup = {
            id: (0, _index.getUID)('group-'),
            label: node.label,
            disabled: node.hasAttribute('disabled'),
            hidden: node.hasAttribute('hidden'),
            options: []
          };
          var groupOptions = node.childNodes;
          groupOptions.forEach(function (option) {
            if (option.nodeName === 'OPTION') {
              optionGroup.options.push(_this._createOptionObject(option, optionGroup));
            }
          });
          options.push(optionGroup);
        } else if (node.nodeName === 'OPTION') {
          options.push(_this._createOptionObject(node));
        }
      });
      return options;
    }
  }, {
    key: "_getPlainOptions",
    value: function _getPlainOptions(optionsToRender) {
      var hasOptionGroup = _selectorEngine["default"].findOne('optgroup', this._element);

      if (!hasOptionGroup) {
        return optionsToRender;
      }

      var options = [];
      optionsToRender.forEach(function (option) {
        var isOptionGroup = option.hasOwnProperty('options');

        if (isOptionGroup) {
          option.options.forEach(function (nestedOption) {
            options.push(nestedOption);
          });
        } else {
          options.push(option);
        }
      });
      return options;
    }
  }, {
    key: "_createOptionObject",
    value: function _createOptionObject(nativeOption) {
      var group = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var id = (0, _index.getUID)('option-');
      var groupId = group.id ? group.id : null;
      var groupDisabled = group.disabled ? group.disabled : false;
      var selected = nativeOption.selected || nativeOption.hasAttribute('selected');
      var disabled = nativeOption.hasAttribute('disabled') || groupDisabled;
      var hidden = nativeOption.hasAttribute('hidden') || group && group.hidden;
      var multiple = this.multiple;
      var value = nativeOption.value;
      var label = nativeOption.label;

      var secondaryText = _manipulator["default"].getDataAttribute(nativeOption, 'secondaryText');

      var icon = _manipulator["default"].getDataAttribute(nativeOption, 'icon');

      return new _selectOption["default"](id, nativeOption, multiple, value, label, selected, disabled, hidden, secondaryText, groupId, icon);
    }
  }, {
    key: "_getNavigationOptions",
    value: function _getNavigationOptions() {
      var availableOptions = this.options.filter(function (option) {
        return !option.hidden;
      });
      return this.hasSelectAll ? [this._selectAllOption].concat(_toConsumableArray(availableOptions)) : availableOptions;
    }
  }, {
    key: "_init",
    value: function _init() {
      this._renderMaterialWrapper();

      this._wrapper = _selectorEngine["default"].findOne("#".concat(this._wrapperId));
      this._input = _selectorEngine["default"].findOne(SELECTOR_INPUT, this._wrapper);
      var containerSelector = this._config.container;

      if (containerSelector === 'body') {
        this._container = document.body;
      } else {
        this._container = _selectorEngine["default"].findOne(containerSelector);
      }

      this._initOutlineInput();

      this._setDefaultSelections();

      this._updateInputValue();

      this._updateLabelPosition();

      this._updateClearButtonVisibility();

      this._bindComponentEvents();

      if (this.hasSelectAll) {
        this._selectAllOption = this._createSelectAllOption();
      }

      this._dropdownContainer = (0, _templates.getDropdownTemplate)(this._dropdownContainerId, this._config, this._input.offsetWidth, this._dropdownHeight, this._selectAllOption, this._optionsToRender, this._customContent);

      this._setFirstActiveOption();
    }
  }, {
    key: "_renderMaterialWrapper",
    value: function _renderMaterialWrapper() {
      var template = (0, _templates.getWrapperTemplate)(this._wrapperId, this._config, this._label);

      this._element.parentNode.insertBefore(template, this._element);

      _manipulator["default"].addClass(this._element, CLASS_NAME_INITIALIZED);

      template.appendChild(this._element);
    }
  }, {
    key: "_initOutlineInput",
    value: function _initOutlineInput() {
      var inputWrapper = _selectorEngine["default"].findOne(SELECTOR_FORM_OUTLINE, this._wrapper);

      var outlineInput = new _input["default"](inputWrapper);
      outlineInput.init();
    }
  }, {
    key: "_bindComponentEvents",
    value: function _bindComponentEvents() {
      this._listenToComponentKeydown();

      this._listenToWrapperClick();

      this._listenToClearBtnClick();

      this._listenToClearBtnKeydown();
    }
  }, {
    key: "_setDefaultSelections",
    value: function _setDefaultSelections() {
      var _this2 = this;

      this.options.forEach(function (option) {
        if (option.selected) {
          _this2._selectionModel.select(option);
        }
      });
    }
  }, {
    key: "_listenToComponentKeydown",
    value: function _listenToComponentKeydown() {
      _eventHandler["default"].on(this._wrapper, 'keydown', this._handleKeydown.bind(this));
    }
  }, {
    key: "_handleKeydown",
    value: function _handleKeydown(event) {
      if (this._isOpen && !this._config.filter) {
        this._handleOpenKeydown(event);
      } else {
        this._handleClosedKeydown(event);
      }
    }
  }, {
    key: "_handleOpenKeydown",
    value: function _handleOpenKeydown(event) {
      var key = event.keyCode;
      var isCloseKey = key === _keycodes.ESCAPE || key === _keycodes.UP_ARROW && event.altKey;

      if (isCloseKey) {
        this.close();

        this._input.focus();

        return;
      }

      switch (key) {
        case _keycodes.DOWN_ARROW:
          this._setNextOptionActive();

          this._scrollToOption(this._activeOption);

          break;

        case _keycodes.UP_ARROW:
          this._setPreviousOptionActive();

          this._scrollToOption(this._activeOption);

          break;

        case _keycodes.HOME:
          this._setFirstOptionActive();

          this._scrollToOption(this._activeOption);

          break;

        case _keycodes.END:
          this._setLastOptionActive();

          this._scrollToOption(this._activeOption);

          break;

        case _keycodes.ENTER:
          if (this._activeOption) {
            if (this.hasSelectAll && this._activeOptionIndex === 0) {
              this._handleSelectAll();
            } else {
              this._handleSelection(this._activeOption);
            }
          }

          return;

        default:
          return;
      }

      event.preventDefault();
    }
  }, {
    key: "_handleClosedKeydown",
    value: function _handleClosedKeydown(event) {
      var key = event.keyCode;
      var isOpenKey = key === _keycodes.ENTER || key === _keycodes.DOWN_ARROW && event.altKey || key === _keycodes.DOWN_ARROW && this.multiple;

      if (isOpenKey) {
        this.open();
      }

      if (!this.multiple) {
        switch (key) {
          case _keycodes.DOWN_ARROW:
            this._setNextOptionActive();

            this._handleSelection(this._activeOption);

            break;

          case _keycodes.UP_ARROW:
            this._setPreviousOptionActive();

            this._handleSelection(this._activeOption);

            break;

          case _keycodes.HOME:
            this._setFirstOptionActive();

            this._handleSelection(this._activeOption);

            break;

          case _keycodes.END:
            this._setLastOptionActive();

            this._handleSelection(this._activeOption);

            break;

          default:
            return;
        }
      } else {
        switch (key) {
          case _keycodes.DOWN_ARROW:
            this.open();
            break;

          case _keycodes.UP_ARROW:
            this.open();
            break;

          default:
            return;
        }
      }

      event.preventDefault();
    }
  }, {
    key: "_scrollToOption",
    value: function _scrollToOption(option) {
      if (!option) {
        return;
      }

      var optionIndex;
      var visibleOptions = this.options.filter(function (option) {
        return !option.hidden;
      });

      if (this.hasSelectAll) {
        optionIndex = visibleOptions.indexOf(option) + 1;
      } else {
        optionIndex = visibleOptions.indexOf(option);
      }

      var groupsNumber = this._getNumberOfGroupsBeforeOption(optionIndex);

      var scrollToIndex = optionIndex + groupsNumber;
      var list = this.optionsWrapper;
      var listHeight = list.offsetHeight;
      var optionHeight = this._config.optionHeight;
      var scrollTop = list.scrollTop;

      if (optionIndex > -1) {
        var optionOffset = scrollToIndex * optionHeight;
        var isBelow = optionOffset + optionHeight > scrollTop + listHeight;
        var isAbove = optionOffset < scrollTop;

        if (isAbove) {
          list.scrollTop = optionOffset;
        } else if (isBelow) {
          list.scrollTop = optionOffset - listHeight + optionHeight;
        } else {
          list.scrollTop = scrollTop;
        }
      }
    }
  }, {
    key: "_getNumberOfGroupsBeforeOption",
    value: function _getNumberOfGroupsBeforeOption(optionIndex) {
      var optionsList = this.options.filter(function (option) {
        return !option.hidden;
      });

      var groupsList = this._optionsToRender.filter(function (group) {
        return !group.hidden;
      });

      var index = this.hasSelectAll ? optionIndex - 1 : optionIndex;
      var groupsNumber = 0;

      for (var i = 0; i <= index; i++) {
        if (optionsList[i].groupId && groupsList[groupsNumber] && groupsList[groupsNumber].id && optionsList[i].groupId === groupsList[groupsNumber].id) {
          groupsNumber++;
        }
      }

      return groupsNumber;
    }
  }, {
    key: "_setNextOptionActive",
    value: function _setNextOptionActive() {
      var index = this._activeOptionIndex + 1;

      var options = this._getNavigationOptions();

      if (!options[index]) {
        return;
      }

      while (options[index].disabled) {
        index += 1;

        if (!options[index]) {
          return;
        }
      }

      this._updateActiveOption(options[index], index);
    }
  }, {
    key: "_setPreviousOptionActive",
    value: function _setPreviousOptionActive() {
      var index = this._activeOptionIndex - 1;

      var options = this._getNavigationOptions();

      if (!options[index]) {
        return;
      }

      while (options[index].disabled) {
        index -= 1;

        if (!options[index]) {
          return;
        }
      }

      this._updateActiveOption(options[index], index);
    }
  }, {
    key: "_setFirstOptionActive",
    value: function _setFirstOptionActive() {
      var index = 0;

      var options = this._getNavigationOptions();

      this._updateActiveOption(options[index], index);
    }
  }, {
    key: "_setLastOptionActive",
    value: function _setLastOptionActive() {
      var options = this._getNavigationOptions();

      var index = options.length - 1;

      this._updateActiveOption(options[index], index);
    }
  }, {
    key: "_updateActiveOption",
    value: function _updateActiveOption(newActiveOption, index) {
      var currentActiveOption = this._activeOption;

      if (currentActiveOption) {
        currentActiveOption.removeActiveStyles();
      }

      newActiveOption.setActiveStyles();
      this._activeOptionIndex = index;
      this._activeOption = newActiveOption;
    }
  }, {
    key: "_listenToWrapperClick",
    value: function _listenToWrapperClick() {
      var _this3 = this;

      _eventHandler["default"].on(this._wrapper, 'click', function () {
        _this3.toggle();
      });
    }
  }, {
    key: "_listenToClearBtnClick",
    value: function _listenToClearBtnClick() {
      var _this4 = this;

      _eventHandler["default"].on(this.clearButton, 'click', function (event) {
        event.preventDefault();
        event.stopPropagation();

        _this4._handleClear();
      });
    }
  }, {
    key: "_listenToClearBtnKeydown",
    value: function _listenToClearBtnKeydown() {
      var _this5 = this;

      _eventHandler["default"].on(this.clearButton, 'keydown', function (event) {
        if (event.keyCode === _keycodes.ENTER) {
          _this5._handleClear();

          event.preventDefault();
          event.stopPropagation();
        }
      });
    }
  }, {
    key: "_handleClear",
    value: function _handleClear() {
      if (this.multiple) {
        this._selectionModel.clear();

        this._deselectAllOptions(this.options);

        if (this.hasSelectAll) {
          this._updateSelectAllState();
        }
      } else {
        var selected = this._selectionModel.selection;

        this._selectionModel.clear();

        selected.deselect();
      }

      this._updateInputValue();

      this._updateLabelPosition();

      this._updateClearButtonVisibility();

      this._emitValueChangeEvent(null);

      this._emitNativeChangeEvent();
    }
  }, {
    key: "_listenToOptionsClick",
    value: function _listenToOptionsClick() {
      var _this6 = this;

      _eventHandler["default"].on(this.optionsWrapper, 'click', function (event) {
        var optionGroupLabel = event.target.classList.contains(CLASS_NAME_OPTION_GROUP_LABEL);

        if (optionGroupLabel) {
          return;
        }

        var target = event.target.nodeName === 'DIV' ? event.target : _selectorEngine["default"].closest(event.target, SELECTOR_OPTION);
        var selectAllOption = target.classList.contains(CLASS_NAME_SELECT_ALL_OPTION);

        if (selectAllOption) {
          _this6._handleSelectAll();

          return;
        }

        var id = target.dataset.id;

        var option = _this6.options.find(function (option) {
          return option.id === id;
        });

        if (option && !option.disabled) {
          _this6._handleSelection(option);
        }
      });
    }
  }, {
    key: "_handleSelectAll",
    value: function _handleSelectAll() {
      var selected = this._selectAllOption.selected;

      if (selected) {
        this._deselectAllOptions(this.options);

        this._selectAllOption.deselect();
      } else {
        this._selectAllOptions(this.options);

        this._selectAllOption.select();
      }

      this._updateInputValue();

      this._updateLabelPosition();

      this._updateClearButtonVisibility();

      this._emitValueChangeEvent(this.value);

      this._emitNativeChangeEvent();
    }
  }, {
    key: "_selectAllOptions",
    value: function _selectAllOptions(options) {
      var _this7 = this;

      options.forEach(function (option) {
        if (!option.selected && !option.disabled) {
          _this7._selectionModel.select(option);

          option.select();
        }
      });
    }
  }, {
    key: "_deselectAllOptions",
    value: function _deselectAllOptions(options) {
      var _this8 = this;

      options.forEach(function (option) {
        if (option.selected && !option.disabled) {
          _this8._selectionModel.deselect(option);

          option.deselect();
        }
      });
    }
  }, {
    key: "_handleSelection",
    value: function _handleSelection(option) {
      if (this.multiple) {
        this._handleMultiSelection(option);

        if (this.hasSelectAll) {
          this._updateSelectAllState();
        }
      } else {
        this._handleSingleSelection(option);
      }

      this._updateInputValue();

      this._updateLabelPosition();

      this._updateClearButtonVisibility();
    }
  }, {
    key: "_handleSingleSelection",
    value: function _handleSingleSelection(option) {
      var currentSelected = this._selectionModel.selections[0];

      if (currentSelected && currentSelected !== option) {
        this._selectionModel.deselect(currentSelected);

        currentSelected.deselect();
        currentSelected.node.setAttribute('selected', false);

        _eventHandler["default"].trigger(this._element, EVENT_DESELECT, {
          value: currentSelected.value
        });
      }

      if (!currentSelected || currentSelected && option !== currentSelected) {
        this._selectionModel.select(option);

        option.select();
        option.node.setAttribute('selected', true);

        _eventHandler["default"].trigger(this._element, EVENT_SELECT, {
          value: option.value
        });

        this._emitValueChangeEvent(this.value);

        this._emitNativeChangeEvent();
      }

      this.close();

      this._input.focus();
    }
  }, {
    key: "_handleMultiSelection",
    value: function _handleMultiSelection(option) {
      if (option.selected) {
        this._selectionModel.deselect(option);

        option.deselect();
        option.node.setAttribute('selected', false);

        _eventHandler["default"].trigger(this._element, EVENT_DESELECT, {
          value: option.value
        });
      } else {
        this._selectionModel.select(option);

        option.select();
        option.node.setAttribute('selected', true);

        _eventHandler["default"].trigger(this._element, EVENT_SELECT, {
          value: option.value
        });
      }

      this._emitValueChangeEvent(this.value);

      this._emitNativeChangeEvent();
    }
  }, {
    key: "_emitValueChangeEvent",
    value: function _emitValueChangeEvent(value) {
      _eventHandler["default"].trigger(this._element, EVENT_VALUE_CHANGE, {
        value: value
      });
    }
  }, {
    key: "_emitNativeChangeEvent",
    value: function _emitNativeChangeEvent() {
      _eventHandler["default"].trigger(this._element, EVENT_CHANGE);
    }
  }, {
    key: "_updateInputValue",
    value: function _updateInputValue() {
      var labels = this.multiple ? this._selectionModel.labels : this._selectionModel.label;
      var value;

      if (this.multiple && this._config.displayedLabels !== -1 && this._selectionModel.selections.length > this._config.displayedLabels) {
        value = "".concat(this._selectionModel.selections.length, " options selected");
      } else {
        value = labels;
      }

      if (value) {
        this._input.value = value;
      } else {
        this._input.value = '';
      }
    }
  }, {
    key: "_updateLabelPosition",
    value: function _updateLabelPosition() {
      var label = _selectorEngine["default"].findOne(SELECTOR_LABEL, this._wrapper);

      if (!label) {
        return;
      }

      if (this._input.value !== '' || this._isOpen) {
        _manipulator["default"].addClass(label, CLASS_NAME_ACTIVE);
      } else {
        _manipulator["default"].removeClass(label, CLASS_NAME_ACTIVE);
      }
    }
  }, {
    key: "_updateClearButtonVisibility",
    value: function _updateClearButtonVisibility() {
      if (!this.clearButton) {
        return;
      }

      var hasSelection = this._selectionModel.selection || this._selectionModel.selections.length > 0;

      if (hasSelection) {
        _manipulator["default"].addStyle(this.clearButton, {
          display: 'block'
        });
      } else {
        _manipulator["default"].addStyle(this.clearButton, {
          display: 'none'
        });
      }
    }
  }, {
    key: "_updateSelectAllState",
    value: function _updateSelectAllState() {
      var selectAllSelected = this._selectAllOption.selected;
      var allSelected = (0, _util["default"])(this.options);

      if (!allSelected && selectAllSelected) {
        this._selectAllOption.deselect();
      } else if (allSelected && !selectAllSelected) {
        this._selectAllOption.select();
      }
    }
  }, {
    key: "toggle",
    value: function toggle() {
      if (this._isOpen) {
        this.close();
      } else {
        this.open();
      }
    }
  }, {
    key: "open",
    value: function open() {
      var _this9 = this;

      var isDisabled = this._config.disabled;

      var openEvent = _eventHandler["default"].trigger(this._element, EVENT_OPEN);

      if (this._isOpen || isDisabled || openEvent.defaultPrevented) {
        return;
      }

      this._openDropdown();

      this._updateDropdownWidth();

      this._setFirstActiveOption();

      this._scrollToOption(this._activeOption);

      if (this._config.filter) {
        // We need to wait for popper initialization, otherwise
        // dates container will be focused before popper position
        // update which can change the scroll position on the page
        setTimeout(function () {
          _this9.filterInput.focus();
        }, 0);

        this._listenToSelectSearch(); // New listener for dropdown navigation is needed, because
        // we focus search input inside dropdown template, wchich is
        // appended to the body. In this case listener attached to the
        // select wrapper won't work


        this._listenToDropdownKeydown();
      }

      this._listenToOptionsClick();

      this._listenToOutsideClick();

      this._listenToWindowResize();

      this._isOpen = true;

      this._updateLabelPosition();

      this._setInputActiveStyles();
    }
  }, {
    key: "_openDropdown",
    value: function _openDropdown() {
      var _this10 = this;

      this._popper = new _popper["default"](this._input, this._dropdownContainer, {
        placement: 'bottom-start'
      });

      this._container.appendChild(this._dropdownContainer); // We need to add delay to wait for the popper initialization
      // and position update


      setTimeout(function () {
        _manipulator["default"].addClass(_this10.dropdown, CLASS_NAME_OPEN);
      }, 0);
    }
  }, {
    key: "_updateDropdownWidth",
    value: function _updateDropdownWidth() {
      var inputWidth = this._input.offsetWidth;

      _manipulator["default"].addStyle(this._dropdownContainer, {
        width: "".concat(inputWidth, "px")
      });
    }
  }, {
    key: "_setFirstActiveOption",
    value: function _setFirstActiveOption() {
      var options = this._getNavigationOptions();

      var currentActive = this._activeOption;

      if (currentActive) {
        currentActive.removeActiveStyles();
      }

      var firstSelected = this.multiple ? this._selectionModel.selections[0] : this._selectionModel.selection;

      if (firstSelected) {
        this._activeOption = firstSelected;
        firstSelected.setActiveStyles();
        this._activeOptionIndex = options.findIndex(function (option) {
          return option === firstSelected;
        });
      } else {
        this._activeOption = null;
        this._activeOptionIndex = -1;
      }
    }
  }, {
    key: "_setInputActiveStyles",
    value: function _setInputActiveStyles() {
      _manipulator["default"].addClass(this._input, CLASS_NAME_FOCUSED);
    }
  }, {
    key: "_listenToWindowResize",
    value: function _listenToWindowResize() {
      _eventHandler["default"].on(window, 'resize', this._handleWindowResize.bind(this));
    }
  }, {
    key: "_handleWindowResize",
    value: function _handleWindowResize() {
      if (this._dropdownContainer) {
        this._updateDropdownWidth();
      }
    }
  }, {
    key: "_listenToSelectSearch",
    value: function _listenToSelectSearch() {
      var _this11 = this;

      this.filterInput.addEventListener('input', function (event) {
        var searchTerm = event.target.value;
        var debounceTime = _this11._config.filterDebounce;

        _this11._debounceFilter(searchTerm, debounceTime);
      });
    }
  }, {
    key: "_debounceFilter",
    value: function _debounceFilter(searchTerm, debounceTime) {
      var _this12 = this;

      if (this._debounceTimeoutId) {
        clearTimeout(this._debounceTimeoutId);
      }

      this._debounceTimeoutId = setTimeout(function () {
        _this12._filterOptions(searchTerm);
      }, debounceTime);
    }
  }, {
    key: "_filterOptions",
    value: function _filterOptions(searchTerm) {
      var _this13 = this;

      var filtered = [];

      this._optionsToRender.forEach(function (option) {
        var isOptionGroup = option.hasOwnProperty('options');
        var isValidOption = !isOptionGroup && option.label.toLowerCase().includes(searchTerm.toLowerCase());
        var group = {};

        if (isOptionGroup) {
          group.label = option.label;
          group.options = _this13._filter(searchTerm, option.options);

          if (group.options.length > 0) {
            filtered.push(group);
          }
        }

        if (isValidOption) {
          filtered.push(option);
        }
      });

      var hasNoResultsText = this._config.noResultText !== '';
      var hasFilteredOptions = filtered.length !== 0;

      if (hasFilteredOptions) {
        this._updateOptionsListTemplate(filtered);

        this._popper.scheduleUpdate();

        this._filteredOptionsList = this._getPlainOptions(filtered);

        if (this.hasSelectAll) {
          this._updateSelectAllState();
        }

        this._setFirstActiveOption();
      } else if (!hasFilteredOptions && hasNoResultsText) {
        var noResultsTemplate = this._getNoResultTemplate();

        this.optionsWrapper.innerHTML = noResultsTemplate;
      }
    }
  }, {
    key: "_updateOptionsListTemplate",
    value: function _updateOptionsListTemplate(optionsToRender) {
      var optionsWrapperContent = _selectorEngine["default"].findOne(SELECTOR_OPTIONS_LIST, this._dropdownContainer) || _selectorEngine["default"].findOne(SELECTOR_NO_RESULTS, this._dropdownContainer);

      var optionsListTemplate = (0, _templates.getOptionsListTemplate)(optionsToRender, this._selectAllOption, this._config);
      this.optionsWrapper.removeChild(optionsWrapperContent);
      this.optionsWrapper.appendChild(optionsListTemplate);
    }
  }, {
    key: "_getNoResultTemplate",
    value: function _getNoResultTemplate() {
      return "<div class=\"select-no-results\" style=\"height: ".concat(this._config.optionHeight, "px\">").concat(this._config.noResultText, "</div>");
    }
  }, {
    key: "_filter",
    value: function _filter(value, options) {
      var filterValue = value.toLowerCase();
      return options.filter(function (option) {
        return option.label.toLowerCase().includes(filterValue);
      });
    }
  }, {
    key: "_listenToDropdownKeydown",
    value: function _listenToDropdownKeydown() {
      _eventHandler["default"].on(this.dropdown, 'keydown', this._handleOpenKeydown.bind(this));
    }
  }, {
    key: "_listenToOutsideClick",
    value: function _listenToOutsideClick() {
      _eventHandler["default"].on(document, 'click', this._handleOutSideClick.bind(this));
    }
  }, {
    key: "_handleOutSideClick",
    value: function _handleOutSideClick(event) {
      var isSelectContent = this._wrapper && this._wrapper.contains(event.target);

      var isDropdown = event.target === this._dropdownContainer;

      var isDropdownContent = this._dropdownContainer && this._dropdownContainer.contains(event.target);

      if (!isSelectContent && !isDropdown && !isDropdownContent) {
        this.close();
      }
    }
  }, {
    key: "close",
    value: function close() {
      var _this14 = this;

      var closeEvent = _eventHandler["default"].trigger(this._element, EVENT_CLOSE);

      if (!this._isOpen || closeEvent.defaultPrevented) {
        return;
      }

      if (this._config.filter) {
        this._resetFilterState();

        this._updateOptionsListTemplate(this._optionsToRender);
      }

      this._removeDropdownEvents();

      _manipulator["default"].removeClass(this.dropdown, CLASS_NAME_OPEN);

      setTimeout(function () {
        _manipulator["default"].removeClass(_this14._input, CLASS_NAME_FOCUSED);

        _manipulator["default"].removeClass(_this14._input, CLASS_NAME_ACTIVE);

        _this14._updateLabelPosition();
      }, 0);
      setTimeout(function () {
        if (_this14._container && _this14._dropdownContainer.parentNode === _this14._container) {
          _this14._container.removeChild(_this14._dropdownContainer);
        }

        _this14._popper.destroy();

        _this14._isOpen = false;

        _eventHandler["default"].off(_this14.dropdown, 'transitionend');
      }, ANIMATION_TRANSITION_TIME);
    }
  }, {
    key: "_resetFilterState",
    value: function _resetFilterState() {
      this.filterInput.value = '';
      this._filteredOptionsList = null;
    }
  }, {
    key: "_removeDropdownEvents",
    value: function _removeDropdownEvents() {
      _eventHandler["default"].off(document, 'click');

      if (this._config.filter) {
        _eventHandler["default"].off(this.dropdown, 'keydown');
      }

      _eventHandler["default"].off(this.optionsWrapper, 'click');
    }
  }, {
    key: "_addMutationObserver",
    value: function _addMutationObserver() {
      var _this15 = this;

      this._mutationObserver = new MutationObserver(function () {
        if (_this15._wrapper) {
          _this15._updateSelections();

          _this15._updateDisabledState();
        }
      });

      this._observeMutationObserver();
    }
  }, {
    key: "_updateSelections",
    value: function _updateSelections() {
      this._optionsToRender = this._getOptionsToRender(this._element);
      this._plainOptions = this._getPlainOptions(this._optionsToRender);

      this._selectionModel.clear();

      this._setDefaultSelections();

      this._updateInputValue();

      this._updateLabelPosition();

      this._updateClearButtonVisibility();

      if (this.hasSelectAll) {
        this._updateSelectAllState();
      }

      var hasFilterValue = this._config.filter && this.filterInput && this.filterInput.value;

      if (this._isOpen && !hasFilterValue) {
        this._updateOptionsListTemplate(this._optionsToRender);

        this._setFirstActiveOption();
      } else if (this._isOpen && hasFilterValue) {
        this._filterOptions(this.filterInput.value);

        this._setFirstActiveOption();
      } else {
        this._dropdownContainer = (0, _templates.getDropdownTemplate)(this._dropdownContainerId, this._config, this._input.offsetWidth, this._dropdownHeight, this._selectAllOption, this._optionsToRender, this._customContent);
      }
    }
  }, {
    key: "_updateDisabledState",
    value: function _updateDisabledState() {
      var input = _selectorEngine["default"].findOne(SELECTOR_INPUT, this._wrapper);

      if (this._element.hasAttribute('disabled')) {
        this._config.disabled = true;
        input.setAttribute('disabled', '');
      } else {
        this._config.disabled = false;
        input.removeAttribute('disabled');
      }
    }
  }, {
    key: "_observeMutationObserver",
    value: function _observeMutationObserver() {
      if (!this._mutationObserver) {
        return;
      }

      this._mutationObserver.observe(this._element, {
        attributes: true,
        childList: true,
        characterData: true,
        subtree: true
      });
    }
  }, {
    key: "_disconnectMutationObserver",
    value: function _disconnectMutationObserver() {
      if (this.mutationObserver) {
        this._mutationObserver.disconnect();

        this._mutationObserver = null;
      }
    }
  }, {
    key: "_createSelectAllOption",
    value: function _createSelectAllOption() {
      var id = this._selectAllId;
      var nativeOption = null;
      var multiple = true;
      var value = 'select-all';
      var label = this._config.selectAllLabel;
      var selected = (0, _util["default"])(this.options);
      var disabled = false;
      var hidden = false;
      var secondaryText = null;
      var groupId = null;
      var icon = null;
      return new _selectOption["default"](id, nativeOption, multiple, value, label, selected, disabled, hidden, secondaryText, groupId, icon);
    }
  }, {
    key: "dispose",
    value: function dispose() {
      this._removeComponentEvents();

      this._destroyMaterialSelect();

      _data["default"].removeData(this._element, DATA_KEY);
    }
  }, {
    key: "_removeComponentEvents",
    value: function _removeComponentEvents() {
      _eventHandler["default"].off(this.input, 'click');

      _eventHandler["default"].off(this.wrapper, this._handleKeydown.bind(this));

      _eventHandler["default"].off(this.clearButton, 'click');

      _eventHandler["default"].off(this.clearButton, 'keydown');

      _eventHandler["default"].off(window, 'resize', this._handleWindowResize.bind(this));
    }
  }, {
    key: "_destroyMaterialSelect",
    value: function _destroyMaterialSelect() {
      if (this._isOpen) {
        this.close();
      }

      this._destroyMaterialTemplate();
    }
  }, {
    key: "_destroyMaterialTemplate",
    value: function _destroyMaterialTemplate() {
      var wrapperParent = this._wrapper.parentNode;
      wrapperParent.appendChild(this._element);

      _manipulator["default"].removeClass(this._element, CLASS_NAME_INITIALIZED);

      wrapperParent.removeChild(this._wrapper);
    }
  }, {
    key: "setValue",
    value: function setValue(value) {
      var _this16 = this;

      this.options.filter(function (option) {
        return option.selected;
      }).forEach(function (selection) {
        return selection.nativeOption.selected = false;
      });
      var isMultipleValue = Array.isArray(value);

      if (isMultipleValue) {
        value.forEach(function (selectionValue) {
          return _this16._selectByValue(selectionValue);
        });
      } else {
        this._selectByValue(value);
      }

      this._updateSelections();
    }
  }, {
    key: "_selectByValue",
    value: function _selectByValue(value) {
      var correspondingOption = this.options.find(function (option) {
        return option.value === value;
      });
      correspondingOption.nativeOption.selected = true;
    }
  }, {
    key: "filterInput",
    get: function get() {
      return _selectorEngine["default"].findOne(SELECTOR_FILTER_INPUT, this._dropdownContainer);
    }
  }, {
    key: "dropdown",
    get: function get() {
      return _selectorEngine["default"].findOne(SELECTOR_DROPDOWN, this._dropdownContainer);
    }
  }, {
    key: "optionsList",
    get: function get() {
      return _selectorEngine["default"].findOne(SELECTOR_OPTIONS_LIST, this._dropdownContainer);
    }
  }, {
    key: "optionsWrapper",
    get: function get() {
      return _selectorEngine["default"].findOne(SELECTOR_OPTIONS_WRAPPER, this._dropdownContainer);
    }
  }, {
    key: "clearButton",
    get: function get() {
      return _selectorEngine["default"].findOne(SELECTOR_CLEAR_BUTTON, this._wrapper);
    }
  }, {
    key: "options",
    get: function get() {
      return this._filteredOptionsList ? this._filteredOptionsList : this._plainOptions;
    }
  }, {
    key: "value",
    get: function get() {
      return this.multiple ? this._selectionModel.values : this._selectionModel.value;
    }
  }, {
    key: "multiple",
    get: function get() {
      return this._config.multiple;
    }
  }, {
    key: "hasSelectAll",
    get: function get() {
      return this.multiple && this._config.selectAll;
    }
  }], [{
    key: "jQueryInterface",
    value: function jQueryInterface(config, options) {
      return this.each(function () {
        var data = _data["default"].getData(this, DATA_KEY);

        var _config = _typeof(config) === 'object' && config;

        if (!data && /dispose/.test(config)) {
          return;
        }

        if (!data) {
          data = new Select(this, _config);
        }

        if (typeof config === 'string') {
          if (typeof data[config] === 'undefined') {
            throw new TypeError("No method named \"".concat(config, "\""));
          }

          data[config](options);
        }
      });
    }
  }, {
    key: "getInstance",
    value: function getInstance(element) {
      return _data["default"].getData(element, DATA_KEY);
    }
  }, {
    key: "NAME",
    get: function get() {
      return NAME;
    }
  }]);

  return Select;
}();

var _default = Select;
exports["default"] = _default;
var $ = (0, _index.getjQuery)();

_selectorEngine["default"].find(SELECTOR_SELECT).forEach(function (select) {
  var instance = Select.getInstance(select);

  if (!instance) {
    instance = new Select(select);
  }
});
/**
 * ------------------------------------------------------------------------
 * jQuery
 * ------------------------------------------------------------------------
 * add .timepicker to jQuery only if jQuery is present
 */


if ($) {
  var JQUERY_NO_CONFLICT = $.fn[NAME];
  $.fn[NAME] = Select.jQueryInterface;
  $.fn[NAME].Constructor = Select;

  $.fn[NAME].noConflict = function () {
    $.fn[NAME] = JQUERY_NO_CONFLICT;
    return Select.jQueryInterface;
  };
}