"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _selectorEngine = _interopRequireDefault(require("../../mdb/dom/selector-engine"));

var _manipulator = _interopRequireDefault(require("../../mdb/dom/manipulator"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var SELECTOR_FORM_CHECK_INPUT = '.form-check-input';
var CLASS_NAME_SELECTED = 'selected';
var CLASS_NAME_ACITVE = 'active';

var SelectOption =
/*#__PURE__*/
function () {
  function SelectOption(id, nativeOption, multiple, value, label, selected, disabled, hidden, secondaryText, groupId, icon) {
    _classCallCheck(this, SelectOption);

    this.id = id;
    this.nativeOption = nativeOption;
    this.multiple = multiple;
    this.value = value;
    this.label = label;
    this.selected = selected;
    this.disabled = disabled;
    this.hidden = hidden;
    this.secondaryText = secondaryText;
    this.groupId = groupId;
    this.icon = icon;
    this.node = null;
    this.active = false;
  }

  _createClass(SelectOption, [{
    key: "select",
    value: function select() {
      if (this.multiple) {
        this._selectMultiple();
      } else {
        this._selectSingle();
      }
    }
  }, {
    key: "_selectSingle",
    value: function _selectSingle() {
      if (!this.selected) {
        _manipulator["default"].addClass(this.node, CLASS_NAME_SELECTED);

        this.node.setAttribute('aria-selected', true);
        this.selected = true;

        if (this.nativeOption) {
          this.nativeOption.selected = true;
        }
      }
    }
  }, {
    key: "_selectMultiple",
    value: function _selectMultiple() {
      if (!this.selected) {
        var checkbox = _selectorEngine["default"].findOne(SELECTOR_FORM_CHECK_INPUT, this.node);

        checkbox.checked = true;

        _manipulator["default"].addClass(this.node, CLASS_NAME_SELECTED);

        this.node.setAttribute('aria-selected', true);
        this.selected = true;

        if (this.nativeOption) {
          this.nativeOption.selected = true;
        }
      }
    }
  }, {
    key: "deselect",
    value: function deselect() {
      if (this.multiple) {
        this._deselectMultiple();
      } else {
        this._deselectSingle();
      }
    }
  }, {
    key: "_deselectSingle",
    value: function _deselectSingle() {
      if (this.selected) {
        _manipulator["default"].removeClass(this.node, CLASS_NAME_SELECTED);

        this.node.setAttribute('aria-selected', false);
        this.selected = false;

        if (this.nativeOption) {
          this.nativeOption.selected = false;
        }
      }
    }
  }, {
    key: "_deselectMultiple",
    value: function _deselectMultiple() {
      if (this.selected) {
        var checkbox = _selectorEngine["default"].findOne(SELECTOR_FORM_CHECK_INPUT, this.node);

        checkbox.checked = false;

        _manipulator["default"].removeClass(this.node, CLASS_NAME_SELECTED);

        this.node.setAttribute('aria-selected', false);
        this.selected = false;

        if (this.nativeOption) {
          this.nativeOption.selected = false;
        }
      }
    }
  }, {
    key: "setNode",
    value: function setNode(node) {
      this.node = node;
    }
  }, {
    key: "setActiveStyles",
    value: function setActiveStyles() {
      if (!this.active) {
        this.active = true;

        _manipulator["default"].addClass(this.node, CLASS_NAME_ACITVE);
      }
    }
  }, {
    key: "removeActiveStyles",
    value: function removeActiveStyles() {
      if (this.active) {
        this.active = false;

        _manipulator["default"].removeClass(this.node, CLASS_NAME_ACITVE);
      }
    }
  }]);

  return SelectOption;
}();

var _default = SelectOption;
exports["default"] = _default;