"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var SelectionModel =
/*#__PURE__*/
function () {
  function SelectionModel() {
    var multiple = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

    _classCallCheck(this, SelectionModel);

    this._multiple = multiple;
    this._selections = [];
  }

  _createClass(SelectionModel, [{
    key: "select",
    value: function select(option) {
      if (this._multiple) {
        this._selections.push(option);
      } else {
        this._selections = [option];
      }
    }
  }, {
    key: "deselect",
    value: function deselect(option) {
      if (this._multiple) {
        var optionIndex = this._selections.findIndex(function (selection) {
          return option === selection;
        });

        this._selections.splice(optionIndex, 1);
      } else {
        this._selections = [];
      }
    }
  }, {
    key: "clear",
    value: function clear() {
      this._selections = [];
    }
  }, {
    key: "selection",
    get: function get() {
      return this._selections[0];
    }
  }, {
    key: "selections",
    get: function get() {
      return this._selections;
    }
  }, {
    key: "label",
    get: function get() {
      return this._selections[0] && this.selection.label;
    }
  }, {
    key: "labels",
    get: function get() {
      return this._selections.map(function (selection) {
        return selection.label;
      }).join(', ');
    }
  }, {
    key: "value",
    get: function get() {
      return this.selections[0] && this.selection.value;
    }
  }, {
    key: "values",
    get: function get() {
      return this._selections.map(function (selection) {
        return selection.value;
      });
    }
  }]);

  return SelectionModel;
}();

var _default = SelectionModel;
exports["default"] = _default;