"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getToggleButtonTemplate = exports.getTimepickerTemplate = void 0;

/* eslint-disable import/prefer-default-export */

/* eslint-disable indent */
var getTimepickerTemplate = function getTimepickerTemplate(_ref) {
  var format24 = _ref.format24,
      okLabel = _ref.okLabel,
      cancelLabel = _ref.cancelLabel,
      headID = _ref.headID,
      footerID = _ref.footerID,
      bodyID = _ref.bodyID,
      pickerID = _ref.pickerID,
      clearLabel = _ref.clearLabel,
      inline = _ref.inline,
      showClearBtn = _ref.showClearBtn,
      amLabel = _ref.amLabel,
      pmLabel = _ref.pmLabel;
  var normalTemplate = "<div id='".concat(pickerID, "' class='timepicker-wrapper h-100 d-flex align-items-center justify-content-center flex-column position-fixed'>\n               <div class=\"d-flex align-items-center justify-content-center flex-column shadow timepicker-container\">\n                  <div class=\"d-flex flex-column timepicker-elements justify-content-around\">\n                  <div id='").concat(headID, "' class='timepicker-head d-flex flex-row align-items-center justify-content-center'\n                  style='padding-right:").concat(format24 ? 50 : 0, "px'>\n                  <div class='timepicker-head-content d-flex w-100 justify-content-evenly'>\n                      <div class=\"timepicker-current-wrapper\">\n                        <span class=\"position-relative h-100\">\n                          <button type='button' class='timepicker-current timepicker-hour active ripple' tabindex=\"0\">21</button>\n                        </span>\n                        <button type='button' class='timepicker-dot' disabled>:</button>\n                      <span class=\"position-relative h-100\">\n                        <button type='button' class='timepicker-current timepicker-minute ripple' tabindex=\"0\">21</button>\n                      </span>\n                      </div>\n                      ").concat(!format24 ? "<div class=\"d-flex flex-column justify-content-center timepicker-mode-wrapper\">\n                              <button type='button' class=\"timepicker-hour-mode timepicker-am ripple\" tabindex=\"0\">".concat(amLabel, "</button>\n                              <button class=\"timepicker-hour-mode timepicker-pm ripple\" tabindex=\"0\">").concat(pmLabel, "</button>\n                            </div>") : '', "\n                  </div>\n                </div>\n                ").concat(!inline ? "<div id='".concat(bodyID, "' class='timepicker-clock-wrapper d-flex justify-content-center flex-column align-items-center'>\n                        <div class='timepicker-clock'>\n                          <span class='timepicker-middle-dot position-absolute'></span>\n                          <div class='timepicker-hand-pointer position-absolute'>\n                            <div class='timepicker-circle position-absolute'></div>\n                          </div>\n                          ").concat(format24 ? '<div class="timepicker-clock-inner"></div>' : '', "\n                         </div>\n                      </div>") : '', "\n\n              </div>\n                <div id='").concat(footerID, "' class='timepicker-footer'>\n                  <div class=\"w-100 d-flex justify-content-between\">\n                    ").concat(showClearBtn ? "<button type='button' class='timepicker-button timepicker-clear ripple' tabindex=\"0\">".concat(clearLabel, "</button>") : '', "\n                    <button type='button' class='timepicker-button timepicker-cancel ripple' tabindex=\"0\">").concat(cancelLabel, "</button>\n                    <button type='button' class='timepicker-button timepicker-submit ripple' tabindex=\"0\">").concat(okLabel, "</button>\n                  </div>\n                </div>\n              </div>\n        </div>");
  var inlineTemplate = "<div id='".concat(pickerID, "' class='timepicker-wrapper h-100 d-flex align-items-center justify-content-center flex-column timepicker-wrapper-inline'>\n               <div class=\"d-flex align-items-center justify-content-center flex-column shadow timepicker-container\">\n                  <div class=\"d-flex flex-column timepicker-elements justify-content-around timepicker-elements-inline\">\n                  <div id='").concat(headID, "' class='timepicker-head d-flex flex-row align-items-center justify-content-center timepicker-head-inline'\n                  style='padding-right:0px'>\n                  <div class='timepicker-head-content d-flex w-100 justify-content-evenly align-items-center'>\n                      <div class=\"timepicker-current-wrapper\">\n                        <span class=\"position-relative h-100 timepicker-inline-hour-icons\">\n                          <i class=\"fas fa-chevron-up position-absolute text-white timepicker-icon-up timepicker-icon-inline-hour\"></i>\n                          <button type='button' class='timepicker-current timepicker-hour active ripple timepicker-current-inline' tabindex=\"0\">21</button>\n                          <i class=\"fas fa-chevron-down position-absolute text-white timepicker-icon-down timepicker-icon-inline-hour\"></i>\n                        </span>\n                        <button type='button' class='timepicker-dot timepicker-current-inline' disabled>:</button>\n                      <span class=\"position-relative h-100  timepicker-inline-minutes-icons\">\n                        <i class=\"fas fa-chevron-up position-absolute text-white timepicker-icon-up timepicker-icon-inline-minute\"></i>\n                        <button type='button' class='timepicker-current timepicker-minute ripple timepicker-current-inline' tabindex=\"0\">21</button>\n                        <i class=\"fas fa-chevron-down position-absolute text-white timepicker-icon-down timepicker-icon-inline-minute\"></i>\n                      </span>\n                      </div>\n                      ").concat(!format24 ? "<div class=\"d-flex justify-content-center timepicker-mode-wrapper\">\n                              <button type='button' class=\"timepicker-hour-mode timepicker-am ripple mr-2 ml-4\" tabindex=\"0\">".concat(amLabel, "</button>\n                              <button class=\"timepicker-hour-mode timepicker-pm ripple\" tabindex=\"0\">").concat(pmLabel, "</button>\n                              <button type='button' class='timepicker-button timepicker-submit timepicker-submit-inline ripple py-1 px-2 mb-0' tabindex=\"0\">").concat(okLabel, "</button>\n                            </div>") : '', "\n                      ").concat(format24 ? "<button class='timepicker-button timepicker-submit timepicker-submit-inline ripple py-1 px-2 mb-0' tabindex=\"0\">".concat(okLabel, "</button>") : '', "\n                  </div>\n                </div>\n              </div>\n           </div>\n        </div>\n  ");
  return inline ? inlineTemplate : normalTemplate;
};

exports.getTimepickerTemplate = getTimepickerTemplate;

var getToggleButtonTemplate = function getToggleButtonTemplate(options, id) {
  var iconClass = options.iconClass;
  return "\n  <button id=\"".concat(id, "\" tabindex=\"0\" type=\"button\" class=\"timepicker-toggle-button\" data-toggle=\"timepicker\"  >\n    <i class=\"").concat(iconClass, "\"></i>\n  </button>\n");
};

exports.getToggleButtonTemplate = getToggleButtonTemplate;