"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _util = require("../../mdb/util");

var _data = _interopRequireDefault(require("../../mdb/dom/data"));

var _eventHandler = _interopRequireDefault(require("../../mdb/dom/event-handler"));

var _press = _interopRequireDefault(require("./press"));

var _swipe = _interopRequireDefault(require("./swipe"));

var _pan = _interopRequireDefault(require("./pan"));

var _pinch = _interopRequireDefault(require("./pinch"));

var _tap = _interopRequireDefault(require("./tap"));

var _rotate = _interopRequireDefault(require("./rotate"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var NAME = 'touch';
var DATA_KEY = 'mdb.touch';

var Touch =
/*#__PURE__*/
function () {
  function Touch(element) {
    var _this = this;

    var event = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'swipe';
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

    _classCallCheck(this, Touch);

    this._element = element;
    this._event = event; // events

    this.swipe = event === 'swipe' ? new _swipe["default"](element, options) : null;
    this.press = event === 'press' ? new _press["default"](element, options) : null;
    this.pan = event === 'pan' ? new _pan["default"](element, options) : null;
    this.pinch = event === 'pinch' ? new _pinch["default"](element, options) : null;
    this.tap = event === 'tap' ? new _tap["default"](element, options) : null;
    this.rotate = event === 'rotate' ? new _rotate["default"](element, options) : null; // handlers

    this._touchStartHandler = function (e) {
      return _this._handleTouchStart(e);
    };

    this._touchMoveHandler = function (e) {
      return _this._handleTouchMove(e);
    };

    this._touchEndHandler = function (e) {
      return _this._handleTouchEnd(e);
    };
  }

  _createClass(Touch, [{
    key: "dispose",
    value: function dispose() {
      _eventHandler["default"].off(this._element, 'touchstart', this._touchStartHandler);

      _eventHandler["default"].off(this._element, 'touchmove', this._touchMoveHandler);

      _eventHandler["default"].off(this._element, 'touchend', this._touchEndHandler);

      this.swipe = null;
      this.press = null;
      this.pan = null;
      this.pinch = null;
      this.tap = null;
      this.rotate = null;
    }
  }, {
    key: "init",
    value: function init() {
      // istanbul ignore next
      _eventHandler["default"].on(this._element, 'touchstart', this._touchStartHandler); // istanbul ignore next


      _eventHandler["default"].on(this._element, 'touchmove', this._touchMoveHandler); // istanbul ignore next


      _eventHandler["default"].on(this._element, 'touchend', this._touchEndHandler);
    }
  }, {
    key: "_handleTouchStart",
    value: function _handleTouchStart(e) {
      this[this._event].handleTouchStart(e);
    }
  }, {
    key: "_handleTouchMove",
    value: function _handleTouchMove(e) {
      this[this._event].handleTouchMove(e);
    }
  }, {
    key: "_handleTouchEnd",
    value: function _handleTouchEnd(e) {
      this[this._event].handleTouchEnd(e);
    }
  }], [{
    key: "jQueryInterface",
    value: function jQueryInterface(config) {
      return this.each(function () {
        var data = _data["default"].getData(this, DATA_KEY);

        var _config = _typeof(config) === 'object' && config;

        if (!data && /dispose/.test(config)) {
          return;
        }

        if (!data) {
          data = new Touch(this, _config);
        }

        if (typeof config === 'string') {
          if (typeof data[config] === 'undefined') {
            throw new TypeError("No method named \"".concat(config, "\""));
          } // eslint-disable-next-line consistent-return


          return data[config];
        }
      });
    }
  }]);

  return Touch;
}();

var $ = (0, _util.getjQuery)();

if ($) {
  var JQUERY_NO_CONFLICT = $.fn[NAME];
  $.fn[NAME] = Touch.jQueryInterface;
  $.fn[NAME].Constructor = Touch;

  $.fn[NAME].noConflict = function () {
    $.fn[NAME] = JQUERY_NO_CONFLICT;
    return Touch.jQueryInterface;
  };
}

var _default = Touch;
exports["default"] = _default;