"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _touchUtil = _interopRequireDefault(require("./touchUtil"));

var _eventHandler = _interopRequireDefault(require("../../mdb/dom/event-handler"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var DEFAULT_OPTIONS = {
  threshold: 20,
  direction: 'all',
  pointers: 1
};
var NAME = 'pan';
var EVENT_START = "".concat(NAME, "start");
var EVENT_END = "".concat(NAME, "end");
var EVENT_MOVE = "".concat(NAME, "move");
var LEFT = 'left';
var RIGHT = 'right';

var Pan =
/*#__PURE__*/
function (_TouchUtil) {
  _inherits(Pan, _TouchUtil);

  function Pan(element) {
    var _this;

    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, Pan);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Pan).call(this));
    _this._element = element;
    _this._options = _objectSpread({}, DEFAULT_OPTIONS, {}, options);
    _this._startTouch = null;
    return _this;
  } // Getters


  _createClass(Pan, [{
    key: "handleTouchStart",
    value: function handleTouchStart(e) {
      e.preventDefault();
      this._startTouch = this._getCoordinates(e);
      this._movedTouch = e;

      _eventHandler["default"].trigger(this._element, EVENT_START, {
        touch: e
      });
    }
  }, {
    key: "handleTouchMove",
    value: function handleTouchMove(e) {
      e.preventDefault();
      var _this$_options = this._options,
          threshold = _this$_options.threshold,
          direction = _this$_options.direction;

      var postion = this._getCoordinates(e);

      var movedPosition = this._getCoordinates(this._movedTouch);

      var displacement = this._getOrigin(postion, this._startTouch);

      var displacementMoved = this._getOrigin(postion, movedPosition);

      var pan = this._getDirection(displacement);

      var movedDirection = this._getDirection(displacementMoved);

      var x = pan.x,
          y = pan.y;

      if (direction === 'all' && (y.value > threshold || x.value > threshold)) {
        var _direction = y.value > x.value ? y.direction : x.direction;

        _eventHandler["default"].trigger(this._element, "".concat(NAME).concat(_direction));

        _eventHandler["default"].trigger(this._element, NAME, displacementMoved);
      }

      var axis = direction === LEFT || direction === RIGHT ? 'x' : 'y';

      if (movedDirection[axis].direction === direction && pan[axis].value > threshold) {
        _eventHandler["default"].trigger(this._element, "".concat(NAME).concat(direction), _defineProperty({}, axis, postion[axis] - movedPosition[axis]));
      }

      this._movedTouch = e;

      _eventHandler["default"].trigger(this._element, EVENT_MOVE, {
        touch: e
      });
    }
  }, {
    key: "handleTouchEnd",
    value: function handleTouchEnd(e) {
      e.preventDefault();
      this._movedTouch = null;
      this._startTouch = null;

      _eventHandler["default"].trigger(this._element, EVENT_END, {
        touch: e
      });
    }
  }], [{
    key: "NAME",
    get: function get() {
      return NAME;
    }
  }]);

  return Pan;
}(_touchUtil["default"]);

var _default = Pan;
exports["default"] = _default;