"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _touchUtil = _interopRequireDefault(require("./touchUtil"));

var _eventHandler = _interopRequireDefault(require("../../mdb/dom/event-handler"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var DEFAULT_OPTIONS = {
  pointers: 2,
  threshold: 10
};
var NAME = 'pinch';
var EVENT_END = "".concat(NAME, "end");
var EVENT_START = "".concat(NAME, "start");
var EVENT_MOVE = "".concat(NAME, "move");

var Pinch =
/*#__PURE__*/
function (_TouchUtil) {
  _inherits(Pinch, _TouchUtil);

  function Pinch(element) {
    var _this;

    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, Pinch);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Pinch).call(this));
    _this._element = element;
    _this._options = _objectSpread({}, DEFAULT_OPTIONS, {}, options);
    _this._startTouch = null;
    _this._origin = null;
    _this._touch = null;
    _this._math = null;
    _this._ratio = null;
    return _this;
  } // Getters


  _createClass(Pinch, [{
    key: "handleTouchStart",
    value: function handleTouchStart(e) {
      e.preventDefault();
      if (e.touches.length !== this._options.pointers) return;

      var _this$_getPinchTouchO = this._getPinchTouchOrigin(e.touches),
          _this$_getPinchTouchO2 = _slicedToArray(_this$_getPinchTouchO, 2),
          touch = _this$_getPinchTouchO2[0],
          origin = _this$_getPinchTouchO2[1];

      this._touch = touch;
      this._origin = origin;
      this._startTouch = this._touch;

      _eventHandler["default"].trigger(this._element, EVENT_START, {
        ratio: this._ratio,
        origin: this._origin
      });
    }
  }, {
    key: "handleTouchMove",
    value: function handleTouchMove(e) {
      var _this$_options = this._options,
          threshold = _this$_options.threshold,
          pointers = _this$_options.pointers;
      if (e.touches.length !== pointers) return;
      e.preventDefault();
      this._touch = this._getPinchTouchOrigin(e.touches)[0];
      this._ratio = this._touch / this._startTouch;
      var typeofing = typeof this._startTouch === 'number' && typeof this._touch === 'number'; // eslint-disable-next-line no-restricted-globals

      var isNumber = !isNaN(this._startTouch) && !isNaN(this._touch);

      if (typeofing && isNumber) {
        if (this._origin.x > threshold || this._origin.y > threshold) {
          this._startTouch = this._touch;

          _eventHandler["default"].trigger(this._element, NAME, {
            ratio: this._ratio,
            origin: this._origin
          });

          _eventHandler["default"].trigger(this._element, EVENT_MOVE, {
            ratio: this._ratio,
            origin: this._origin
          });
        }
      }
    }
  }, {
    key: "handleTouchEnd",
    value: function handleTouchEnd() {
      var typeofing = typeof this._startTouch === 'number' && typeof this._touch === 'number'; // eslint-disable-next-line no-restricted-globals

      var isNumber = !isNaN(this._startTouch) && !isNaN(this._touch);

      if (typeofing && isNumber) {
        this._startTouch = null;

        _eventHandler["default"].trigger(this._element, EVENT_END, {
          ratio: this._ratio,
          origin: this._origin
        });
      }
    }
  }], [{
    key: "NAME",
    get: function get() {
      return NAME;
    }
  }]);

  return Pinch;
}(_touchUtil["default"]);

var _default = Pinch;
exports["default"] = _default;