"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _touchUtil = _interopRequireDefault(require("./touchUtil"));

var _eventHandler = _interopRequireDefault(require("../../mdb/dom/event-handler"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var DEFAULT_OPTIONS = {
  interval: 500,
  time: 250,
  taps: 1,
  pointers: 1
};
var NAME = 'tap';

var Tap =
/*#__PURE__*/
function (_TouchUtil) {
  _inherits(Tap, _TouchUtil);

  function Tap(element, options) {
    var _this;

    _classCallCheck(this, Tap);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Tap).call(this));
    _this._element = element;
    _this._options = _objectSpread({}, DEFAULT_OPTIONS, {}, options);
    _this._timer = null;
    _this._tapCount = 0;
    return _this;
  } // Getters


  _createClass(Tap, [{
    key: "handleTouchStart",
    value: function handleTouchStart(e) {
      var _this2 = this;

      var _this$_getCoordinates = this._getCoordinates(e),
          x = _this$_getCoordinates.x,
          y = _this$_getCoordinates.y;

      var _this$_options = this._options,
          interval = _this$_options.interval,
          taps = _this$_options.taps,
          pointers = _this$_options.pointers;

      if (e.touches.length === pointers) {
        this._tapCount += 1;

        if (this._tapCount === 1) {
          this._timer = setTimeout(function () {
            _this2._tapCount = 0;
          }, interval);
        }

        if (this._tapCount === taps) {
          clearTimeout(this._timer);
          this._tapCount = 0;

          _eventHandler["default"].trigger(this._element, NAME, {
            origin: {
              x: x,
              y: y
            }
          });
        }
      }

      return e;
    }
  }, {
    key: "handleTouchEnd",
    value: function handleTouchEnd() {
      return;
    }
  }, {
    key: "handleTouchMove",
    value: function handleTouchMove() {
      return;
    }
  }], [{
    key: "NAME",
    get: function get() {
      return NAME;
    }
  }]);

  return Tap;
}(_touchUtil["default"]);

var _default = Tap;
exports["default"] = _default;