"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var TouchUtil =
/*#__PURE__*/
function () {
  function TouchUtil() {
    _classCallCheck(this, TouchUtil);
  }

  _createClass(TouchUtil, [{
    key: "_getCoordinates",
    value: function _getCoordinates(e) {
      var _e$touches = _slicedToArray(e.touches, 1),
          touch = _e$touches[0];

      return {
        x: touch.clientX,
        y: touch.clientY
      };
    }
  }, {
    key: "_getDirection",
    value: function _getDirection(_ref) {
      var x = _ref.x,
          y = _ref.y;
      return {
        x: {
          direction: x < 0 ? 'left' : 'right',
          value: Math.abs(x)
        },
        y: {
          direction: y < 0 ? 'up' : 'down',
          value: Math.abs(y)
        }
      };
    }
  }, {
    key: "_getOrigin",
    value: function _getOrigin(_ref2, _ref3) {
      var x = _ref2.x,
          y = _ref2.y;
      var x2 = _ref3.x,
          y2 = _ref3.y;
      return {
        x: x - x2,
        y: y - y2
      };
    }
  }, {
    key: "_getDistanceBetweenTwoPoints",
    value: function _getDistanceBetweenTwoPoints(x1, x2, y1, y2) {
      return Math.hypot(x2 - x1, y2 - y1);
    }
  }, {
    key: "_getMidPoint",
    value: function _getMidPoint(_ref4) {
      var x1 = _ref4.x1,
          x2 = _ref4.x2,
          y1 = _ref4.y1,
          y2 = _ref4.y2;
      return {
        x: (x1 + x2) / 2,
        y: (y1 + y2) / 2
      };
    }
  }, {
    key: "_getVectorLength",
    value: function _getVectorLength(_ref5) {
      var x1 = _ref5.x1,
          x2 = _ref5.x2,
          y1 = _ref5.y1,
          y2 = _ref5.y2;
      return Math.sqrt(Math.pow(x2 - x1, 2) + Math.pow(y2 - y1, 2));
    }
  }, {
    key: "_getRightMostTouch",
    value: function _getRightMostTouch(touches) {
      var rightMost = null;
      var distance = Number.MIN_VALUE;
      touches.forEach(function (touch) {
        if (touch.clientX > distance) {
          rightMost = touch;
        }
      });
      return rightMost;
    }
  }, {
    key: "_getAngle",
    value: function _getAngle(x1, y1, x2, y2) {
      return Math.atan2(y2 - y1, x2 - x1);
    }
  }, {
    key: "_getAngularDistance",
    value: function _getAngularDistance(start, end) {
      return end - start;
    }
  }, {
    key: "_getCenterXY",
    value: function _getCenterXY(_ref6) {
      var x1 = _ref6.x1,
          x2 = _ref6.x2,
          y1 = _ref6.y1,
          y2 = _ref6.y2;
      return {
        x: x1 + (x2 - x1) / 2,
        y: y1 + (y2 - y1) / 2
      };
    }
  }, {
    key: "_getPinchTouchOrigin",
    value: function _getPinchTouchOrigin(touches) {
      var _touches = _slicedToArray(touches, 2),
          t1 = _touches[0],
          t2 = _touches[1];

      var _position = {
        x1: t1.clientX,
        x2: t2.clientX,
        y1: t1.clientY,
        y2: t2.clientY
      };
      return [this._getVectorLength(_position), this._getCenterXY(_position)];
    }
  }, {
    key: "_getPosition",
    value: function _getPosition(_ref7) {
      var x1 = _ref7.x1,
          x2 = _ref7.x2,
          y1 = _ref7.y1,
          y2 = _ref7.y2;
      return {
        x1: x1,
        x2: x2,
        y1: y1,
        y2: y2
      };
    }
  }]);

  return TouchUtil;
}();

var _default = TouchUtil;
exports["default"] = _default;